unit Menu_X;

interface

{$ifdef BP7}
uses crt, altro;
{$endif}
{$ifdef FP}
uses crt,mouse,math, altro32;
{$endif}

type   MenuLista_X=object
        x,y,error,bk_color,txt_Color,selezionato,bk_selezione,txt_ColorVeloce,txt_ColorSelezione:byte;
        controllo{ se la riga entra nel monitor },topo,tastiera:boolean;
        constructor init;
        destructor  destroy;
        procedure   Assegna(var N:MenuLista_X);
        function    NuovoElemento(testo:string; tasto:byte):byte;  {torna la posizione dove inserito}
        function    Costruisci:integer; { ritorna la colonna selezionata, negativa se ho premuto ESC }
       end;

implementation

type tipo=record
          nome:string;
          Tasto:byte;
          end;

const num=40;

var lista:array [1..num] of tipo;
    mox,moy,tasto,old_selezionato,elementi:byte;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function MenuLista_X.NuovoElemento(testo:string; tasto:byte):byte;  {torna la posizione dove inserito}
begin
if elementi=num then
   begin
   NuovoElemento:=0;
   Error:=1;
   exit;
   end;
inc(elementi);
lista[elementi].nome:=testo;
lista[elementi].Tasto:=tasto;
NuovoElemento:=elementi;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure MenuLista_X.Assegna(var N:MenuLista_X);
var i:byte;
begin
n.init;
n.txt_Color:=txt_Color;
n.txt_ColorSelezione:=txt_ColorSelezione;
n.txt_ColorVeloce:=txt_ColorVeloce;
n.bk_selezione:=bk_selezione;
n.bk_color:=bk_color;
n.controllo:=controllo;
n.error:=error;
n.selezionato:=selezionato;
n.x:=x;
n.y:=y;
n.tastiera:=tastiera;
n.topo:=topo;
for i:=1 to elementi do N.NuovoElemento(lista[i].nome, lista[i].tasto);
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

constructor MenuLista_X.init;
var i:byte;
begin
txt_Color:=7;
txt_ColorSelezione:=0;
txt_ColorVeloce:=white;
bk_selezione:=7;
bk_color:=0;
controllo:=false;
elementi:=0;
error:=0;
selezionato:=0;
x:=1;
y:=1;
tastiera:=true;
topo:=true;
for i:=1 to num do
    begin
    lista[i].nome:='';
    lista[i].Tasto:=0;
    end;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

destructor MenuLista_X.destroy;
begin
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure writeColor(s:string; txt,Veloce,elemento,txt_ColorSelezione,selezionato:byte);
var i:byte;
begin
hidemouse;
i:=pos(char(lista[elemento].tasto),s);
if elemento<>selezionato then textcolor(txt)
                         else textcolor(txt_ColorSelezione);
write(copy(s,1,i-1));
if i>0 then
   begin
   if i>0 then textcolor(Veloce);
   write(copy(s,i,1));
   end;
if elemento<>selezionato then textcolor(txt)
                         else textcolor(txt_ColorSelezione);

write(copy(s,i+1,255));
showmouse;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure stampa_selezionato(x,y,selezionato,bk_color,bk_selezione,txt_Color,txt_ColorVeloce,txt_ColorSelezione:byte);
var x_pos,i:byte;
begin
hidemouse;
if old_selezionato=selezionato then
   begin
   showmouse;
   Exit;
   end;
if old_selezionato>0 then
   begin
   x_pos:=0;
   for i:=1 to old_selezionato-1 do x_pos:=x_pos+length(lista[i].nome)+2;
   gotoxy(x+x_pos,y);
   textbackground(bk_color);
   writeColor(' '+lista[old_selezionato].nome+' ',txt_Color,txt_ColorVeloce,old_selezionato,txt_ColorSelezione,selezionato);
   end;
x_pos:=0;
for i:=1 to selezionato-1 do x_pos:=x_pos+length(lista[i].nome)+2;
gotoxy(x+x_pos,y);
textbackground(bk_Selezione);
writeColor(' '+lista[selezionato].nome+' ',txt_Color,txt_ColorVeloce,selezionato,txt_ColorSelezione,selezionato);
showmouse;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function Dimensioni(x2,y2:byte):byte;
var maxl,x,y:byte;
begin
maxl:=0;
for x:=1 to elementi do maxl:=maxl+2+length(lista[x].nome);
x:=GetTextMaxX;
y:=GetTextMaxY;
if x2-1+maxl>x then Dimensioni:=12 else
if (x2-1+maxl=x)and (y2=y) then Dimensioni:=12 else dimensioni:=0;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function MenuLista_X.Costruisci:integer;
var i,j:byte;
    c:char;
begin
hidemouse;
if (not tastiera) and (not topo) then
   begin
   Error:=2;
   RunError(201);
   exit;
   end;
if elementi=0 then
   begin
   error:=3;
   RunError(201);
   exit;
   end;
if (selezionato>elementi) then
   begin
   Error:=4;
   RunError(201);
   Exit;
   end;
for i:=1 to elementi do
    for j:=1 to length(lista[i].nome) do
        if lista[i].nome[j]<#32 then
                                begin
                                Error:=6;
                                RunError(201);
                                Exit;
                                end;
old_selezionato:=0;
for i:=1 to elementi do
    begin
    if not (char(lista[i].tasto) in ['0'..'9','a'..'z','A'..'Z',#1]) then
                 begin
                 Error:=10;
                 RunError(201);
                 Exit;
                 end;
    for j:=1 to length(lista[i].nome) do
        if lista[i].nome[j]<#32 then
                                begin
                                Error:=6;
                                RunError(201);
                                Exit;
                                end;
    end;
if selezionato=0 then
   for i:=1 to elementi do
       if lista[i].nome<>'' then
          begin
          selezionato:=i;
          break;
          end;
if controllo then
   begin
   Error:=dimensioni(x,y);
   if Error<>0 then
      begin
      RunError(201);
      Exit;
      end;
   end;
cursorOff;
gotoxy(x,y);
Textbackground(bk_color);
textcolor(txt_Color);
for i:=1 to elementi do writeColor(' '+lista[i].nome+' ',txt_color,txt_colorVeloce,i,txt_ColorSelezione,selezionato);
showmouse;
stampa_selezionato(x,y,selezionato,bk_color,bk_selezione,txt_Color,txt_ColorVeloce,txt_ColorSelezione);
repeat
 if keypressed or not topo then
     begin
     c:=readkey;
     case ord(c) of
         13: begin
             Costruisci:=selezionato;
             Exit;
             end;
         27: begin
             Costruisci:=-selezionato;
             Exit;
             end;
          0: begin
             c:=readkey;
             case ord(c) of
                  80: begin { freccia giu' }
                      Costruisci:=selezionato;
                      Exit;
                      end;
                  77: begin { freccia destra }
                      old_selezionato:=selezionato;
                      if selezionato<elementi then inc(selezionato)
                                              else selezionato:=1;
                      stampa_selezionato(x,y,selezionato,bk_color,bk_selezione,txt_Color,txt_ColorVeloce,txt_ColorSelezione);
                      end;
                  75: begin { freccia sinistra }
                      old_selezionato:=selezionato;
                      if selezionato>1 then dec(selezionato)
                                       else selezionato:=elementi;
                      stampa_selezionato(x,y,selezionato,bk_color,bk_selezione,txt_Color,txt_ColorVeloce,txt_ColorSelezione);
                      end;
                   else
                    for i:=1 to elementi do { ho premuto un tasto alt+selezionato? quale? }
                        if (lista[i].Tasto=ord(from_alt_to_char(ord(c)))) and (lista[i].Tasto<>1) then
                                begin
                                old_selezionato:=selezionato;
                                costruisci:=i;
                                stampa_selezionato(x,y,i,bk_color,bk_selezione,txt_Color,txt_ColorVeloce,txt_ColorSelezione);
                                exit;
                                end;
                  end;
             end
          else
           for i:=1 to elementi do { ho premuto un tasto selezionato? quale? }
               if upcase(char(lista[i].Tasto))=upcase(c) then
                      begin
                      old_selezionato:=selezionato;
                      costruisci:=i;
                      stampa_selezionato(x,y,i,bk_color,bk_selezione,txt_Color,txt_ColorVeloce,txt_ColorSelezione);
                      exit;
                      end;
          end;
     end
    else
     begin
     Click(mox,moy,tasto); {restituisce il click del mouse in mox,moy,tasto}
     if tasto=1 then
                begin
                costruisci:=0;
                if moy=y then
                   begin
                   j:=0;
                   for i:=1 to elementi do
                       begin
                       j:=j+2+length(lista[i].nome);
                       if (mox-x+1) in [j-1-length(lista[i].nome)..j] then
                           begin
                           old_selezionato:=selezionato;
                           stampa_selezionato(x,y,i,bk_color,bk_selezione,txt_Color,txt_ColorVeloce,txt_ColorSelezione);
                           costruisci:=i;
                           exit;  {ho cliccato su una colonna valida}
                           end;
                       end;
                   end;
                gotoxy(x,y);      {ho cliccato fuori dalle colonne valide}
                old_selezionato:=0;
                Textbackground(bk_color);
                textcolor(txt_Color);
                for i:=1 to elementi do
                    writeColor(' '+lista[i].nome+' ',txt_color,txt_colorVeloce,i,txt_ColorSelezione,selezionato);
                exit;
                end;
     end;
until false;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

begin
end.


 Error
   0  : nesssun errore
   1  : troppe righe inserite
   2  : tastiera e mouse disabilitati (*)
   3  : 0 elementi (*)
   4  : elemento selezionato non valido (*)
   5  :
   6  : il nome della riga contiene caratteri non validi (<#32) (*)
   7  :
   8  :
   10 : tasto di scalta rapido non compreso tra  a..z  o  A..Z, #27, #1 (non assegnato) (*)
   12 : se la finestra non entra nel monitor (*)
(*)  quando chiamo il metodo Costruisci
