unit SF16_2;  {Sfoglia Files a 16 bit, versione 2}

interface

uses Crt,Altro,WinDos,Dos,Strings;

function SfogliaFile(XX,YY:byte; all,ordina,topo:boolean; testo,percorso_:string; var ifiles:string; CD:byte):string;

implementation

const maxx=1000;
type  tipo1=string[13];
      AA=array[1..maxx] of tipo1;

var  A:AA;          {per il QSort}
     q:word;

var   percorso,nomefile:string;
      count,iesimo,app:word;
      selezionato,X,Y:byte;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function Partition(var A:AA; p,r:word):word;
var i,j:word;
    x,xx: tipo1;
begin
x:=A[p];
i:=p-1;
j:=r+1;
while true do
      begin
      repeat
       dec(j);
      until A[j]<=x;
      repeat
       inc(i);
      until A[i]>=x;
      if i<j then
             begin
             xx:=A[i];
             A[i]:=A[j];
             A[j]:=xx;
             end
            else
             begin
             Partition:=j;
             Break;
             end;
      end;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure RilascioDestra(var mox,moy,tasto:byte);
var y,x,b:integer;
begin
 asm
  mov bx,1     {in:    bx=0: S,  bx=1: D,  bx=2: C}
  mov ax,6
  int 33h
  mov y,dx    {Y}
  mov x,cx    {X}
  mov b,bx
  end;
moy:=y div 8 +1;
mox:=x div 8 +1;
tasto:=b;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure QuickSort(var A:AA; p,r:word);
begin
if p<r then
       begin
       q:=Partition(A,p,r);
       QuickSort(A,p,q);
       QuickSort(A,q+1,r);
       end;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure FindFiles(path:string; all:boolean);
var F: SearchRec;
    i:longint;
label continua;
begin
FindFirst(Path,  Anyfile - VolumeId - Directory, F);
while (DosError = 0) and (Count < Maxx) do
  begin
  if all=false then if ((f.attr and hidden)<>0)or((f.attr and sysfile)<>0) then
                    goto continua;
  if (f.attr and directory) =0  then
                                begin
                                Inc(Count);
                                A[count]:='f'+LowStr(f.name);
                                for i:=1 to count-1 do
                                    if A[count]=A[i] then
                                       begin
                                       dec(count);
                                       break;
                                       end;
                                end;
  continua:
  FindNext(F);
  end;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure FindAllFiles(percorso,ifiles:string; all:boolean);
var testa,coda:string;   {casi speciali in cui ifiles= '' *. .* . }
    F: SearchRec;
label continua2;

begin
if copy(ifiles,length(ifiles),1)=';' then ifiles:=copy(ifiles,1,length(ifiles)-1);
if ifiles='' then ifiles:='*.*';
testa:=ifiles;
while (testa<>'') do
          begin
          Testa_Coda(testa,';',testa,coda);
          if testa[1]=';' then delete(testa,1,1);
          if (testa=';')or(testa='') then testa:='*.*';
          if copy(testa,1,1)='.' then testa:='*'+testa;
          if copy(testa,posRL('.',testa,255)+1,1)='' then testa:=testa+'*';
          FindFiles(percorso+testa,all);
          testa:=coda;
          end;

FindFirst(percorso+'*.*', directory, F);
while (DosError = 0) and (Count < Maxx) do
         begin
         if f.name='.' then goto continua2;
         if all=false then if ((f.attr and hidden)<>0)or((f.attr and sysfile)<>0) then
                           goto continua2;
         if (f.attr and directory) <>0  then
                                        begin
                                        Inc(Count);
                                        A[count]:='D'+f.name;
                                        end;
         continua2:
         FindNext(F);
         end;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure YellowZona;
begin
textbackground(3);
textcolor(yellow);
gotoxy(X+4,Y+5+selezionato);
if A[iesimo][1]='D' then write(copy(A[iesimo],2,255),'\')
                    else write(copy(A[iesimo],2,255));
while whereX<x+16 do write(' ');
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure NonTrovato;
begin
textcolor(white);
textbackground(3);
gotoxy(x+20,y+17);
case DosError of
        3: write('Percorso non trovato.');
     2,18: write('File non trovato.');
     end;
sound(300);
delay2(0);
Tast_Vuota;
nosound;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure BarraV(const topo:boolean);
var i:word;
begin
if topo then HideMouse;
for i:=2 to 12 do
    begin
    gotoxy(X+18,Y+5+i);
    write('');
    end;
i:=count div 11;
if i<>0 then i:=iesimo div i;
i:=i+2;
if i>12 then i:=12;
if iesimo=1 then i:=2;
gotoxy(X+18,Y+5+i);
textbackground(black+7);
textcolor(black);
write(#9);
if topo then ShowMouse;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure Dettagli(const topo:boolean; const ifiles:string);
var dt : DateTime; {UnpackTime }
    F: SearchRec;
begin
if nomefile='..' then FindFirst(percorso+'.', Anyfile, F)
                 else FindFirst(percorso+nomefile, Anyfile, F);
if topo then HideMouse;
if DosError<>0 then NonTrovato;
if DosError=0 then if Char_VideoXY(x+20,y+17) in ['T',' '] then else
                      begin
                      textbackground(3);
                      gotoxy(x+20,y+17);
                      write('                     ');
                      end;
textbackground(3);
textcolor(blue);
gotoxy(X+10,Y+2);
if A[iesimo][1]<>'D' then write(nomefile)
                     else write(copy(nomefile+'\'+ifiles,1,36));
while whereX<X+46 do write(' ');
textcolor(0);
gotoxy(X+20,Y+8);
write('Percorso: ');
textcolor(white);
write(copy(percorso,1,19));
gotoxy(X+20,Y+9);
write(copy(percorso,20,29));
gotoxy(X+20,Y+10);
write(copy(percorso,49,29));
textcolor(0);
gotoxy(X+20,Y+8+4);
write('Dimensione del file:       ');
textcolor(white);
gotoxy(X+20,Y+9+4);
if DosError=0 then write(Dim_punto(f.size))
              else write('?');
textcolor(0);
write(' bytes');
while (wherex<X+50)and(whereX>1) do write(' ');
gotoxy(X+20,Y+11+4);
write('Attributi: ');
textcolor(white);
if DosError=0 then
   begin
   if (f.attr and archive)<>0 then write('A') else write('_');
   if (f.attr and readonly)<>0 then write('R') else write('_');
   if (f.attr and hidden)<>0 then write('H') else write('_');
   if (f.attr and sysfile)<>0 then write('S') else write('_');
   if (f.attr and directory)<>0 then write('D') else write('_');
   end
  else write('???? ');
UnpackTime(f.time,dt);
textcolor(0);
gotoxy(X+20,Y+13+4);
write('Data: ');
textcolor(white);
if DosError=0 then
              begin
              if dt.day<10 then write('0');
              Write(dt.day,'/');
              if dt.month<10 then write('0');
              Write(dt.month,'/');
              if dt.year<10 then write('0');
              Write(dt.year);
              end
             else write('??/??/????');
gotoxy(X+20,Y+15+4);
textcolor(0);
write('Ora: ');
textcolor(white);
if DosError=0 then
   begin
   if dt.hour<10 then write('0');
   Write(dt.hour,':');
   if dt.min<10 then write('0');
   Write(dt.min,':');
   if dt.sec<10 then write('0');
   Write(dt.sec);
   end
  else write('??:??:??');
if topo then ShowMouse;
BarraV(topo);
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure Mostra(primo:word);
var s:tipo1;
    i:word;
begin
textbackground(3);  {*** la stampa}
textcolor(blue);
for i:=primo to 12+primo do
    begin
    gotoxy(X+4,Y+i+1-primo+5);
    if i<=count then
                if A[i][1]='D' then s:=copy(A[i],2,255)+'\'
                               else s:=copy(A[i],2,255)
                else s:='            ';
    while length(s)<13 do s:=s+' ';
    writeln(s);
    end;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function CercaFile(nome:tipo1):word;
var i,pos:word;
begin
pos:=0;
for i:=1 to count do
    if UpStr(Copy(A[i],2,255))=nome then
                                    begin
                                    pos:=i;
                                    Break;
                                    end;
CercaFile:=pos;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function CercaFile2(nome:tipo1):word;
var i,pos:word;
begin
pos:=0;
for i:=1 to count do
    if UpStr(Copy(A[i],2,length(nome)))=nome then
                                    begin
                                    pos:=i;
                                    Break;
                                    end;
CercaFile2:=pos;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure GreenZona(const topo:boolean);      {*** da aggiornare quello selezionato}
begin
hidemouse;
gotoxy(X+4,Y+selezionato+5);
textbackground(green);
textcolor(white);
if A[iesimo][1]='D' then write(copy(A[iesimo],2,255),'\')
                    else write(copy(A[iesimo],2,255));
while whereX<x+16 do write(' ');
nomefile:=copy(A[iesimo],2,255);
if topo then ShowMouse;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function correggi(s,s1:string):string;
begin
if (s[length(s)]='\')and(s1[1]='\') then correggi:=s+copy(s1,2,255)
                                    else correggi:=s+s1;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function SfogliaFile(XX,YY:byte; all,ordina,topo:boolean; testo,percorso_:string; var ifiles:string; CD:byte):string;
var ii,iii,x_:byte;
    stato:byte;  {0= Nome | 1= Lista | 2= OK | 3= ESCI}
    i,primo:word;
    mox,moy,tasto,posto:byte;
    c:char;
    stringa,str:string;
    scrivo:tipo1;
    insert:boolean;

label next2,next,restart,escoReadStr,readStr,giu,iniziocase,alt_l;
begin
if cd>100 then cd:=100;
percorso:=percorso_;
if pos('\',ifiles)<>0 then
     begin
     SfogliaFile:='';
     Exit;
     end;
insert:=false;
stato:=0;
scrivo:='';
if XX>31 then XX:=31;
if XX=0  then XX:=1;
if YY>5 then YY:=5;
if YY=0 then YY:=1;
X:=XX;
Y:=YY;
if length(testo)>49 then testo[0]:=#49;
restart:
hidemouse;
percorso:=fexpand2(percorso);
{$I-}
chdir(percorso);
{$I+}
if ioresult<>0 then;
if percorso[length(percorso)]<>'\' then percorso:=percorso+'\';
Count:=0;
gotoxy(X,Y);
textbackground(white);
for ii:=1 to 50 do write(' ');
textcolor(black);
gotoxy(25+X-(length(testo)div 2),Y);
write(testo);
textbackground(3);
for ii:=Y+1 to Y+20 do
    begin
    gotoxy(X,ii);
    for i:=1 to 50 do write(' ');
    end;
gotoxy(X,Y+2);
write('   Nome: [                                    ]');
gotoxy(X+3,Y+2);
textcolor(white);
write('N');
gotoxy(X+3,Y+4);
textcolor(white);
write('L');
textcolor(black);
gotoxy(X+4,Y+4);
write('ista:');
gotoxy(X+3,Y+20);
write('Files:');
gotoxy(X+3,Y+5);
write('Ŀ');
for i:=1 to 13 do
    begin
    gotoxy(X+3,Y+5+i);
    write('              ');
    end;
gotoxy(X+3,Y+19);
write('');
textbackground(3);
textcolor(white);
gotoxy(X+10,Y+20);
write(copy(ifiles,1,35));
if length(ifiles)>35 then write('...');
gotoxy(X+18,Y+6);
write(#24);
gotoxy(X+18,Y+18);
write(#25);
textbackground(lightgreen);
gotoxy(X+24,Y+6);
write('   Ok   ');
gotoxy(X+37,Y+6);
write('  Esci  ');              {grafica finita}
c:=#1;                          {inizializzo e cerco}
iesimo:=1;  {a cui punta}
primo:=1;   {in alto}
selezionato:=1;

textbackground(3);
gotoxy(X+22,y+12);
write('Ricerca files in corso... '+#8);
showmouse;
FindAllFiles(percorso,ifiles,all);
if ordina then
          begin
          app:=CercaFile('..');
          if app=0 then QuickSort(A,1,count)
                   else if app>1 then
                        begin
                        A[app]:=A[1];
                        A[1]:='D..';
                        QuickSort(A,2,count);
                        end;
          end;
for i:=count+1 to maxx do A[i]:='';
posto:=length(A[1]);
gotoxy(X+19,Y+4);
textcolor(white);
textbackground(3);
write(dim_punto(count));
textcolor(black);
write(' elementi trovati     ');
if count=maxx then
   begin
   textcolor(white);
   textbackground(3);
   gotoxy(x+20,y+17);
   write('Troppi files nella directory:');
   gotoxy(x+20,y+18);
   write('alcuni non postranno essere');
   gotoxy(x+20,y+19);
   write('visualizzati.');
   sound(300);
   delay2(0);
   Tast_Vuota;
   nosound;
   end;

Mostra(primo);
if topo then ShowMouse;
nomefile:=Copy(A[1],2,255);  {serve solo per dettagli della riga successiva}
Dettagli(topo,ifiles);
nomefile:='';
GreenZona(topo);
gotoxy(X+4,Y+selezionato+5);
repeat
if stato=0 then
           begin
           YellowZona;
           textbackground(green);
           gotoxy(X+24,Y+6);
           write(' ');
           gotoxy(X+31,Y+6);
           write(' ');
           gotoxy(X+37,Y+6);
           write(' ');
           gotoxy(X+44,Y+6);
           write(' ');
           gotoxy(x+10,y+2);
           textbackground(3);
           textcolor(blue);
           readStr:
           scrivo:='';
           if topo then ShowMouse;
           if insert then CursorBig else cursorOn;
           posto:=length(nomefile+'\'+ifiles)+1;
           x_:=posto+1;
           if A[iesimo][1]='D' then
                                begin
                                stringa:=nomefile;
                                nomefile:=ReadString2(nomefile+'\'+ifiles,X+10,X+46,0,topo,true,insert,moy,mox,posto,x_)
                                end
                               else
                                begin
                                stringa:=nomefile;
                                nomefile:=ReadString2(nomefile,X+10,X+46,0,topo,true,insert,moy,mox,posto,x_);
                                end;
             if (nomefile='') and
                ( ((mox=13)and(moy=0)) or ((moy=Y+6)and(mox>X+23)and(mox<X+32)) ) then
                           begin
                           nomefile:=stringa;
                           goto readStr;
                           end;
           if (upcase(percorso[1]) in ['A'..'Z']) and (percorso[2]=':') and
              (percorso[3]='\') and (nomefile='\') then
              begin
              percorso:=percorso[1]+':\';
              goto restart;
              end;
           if (exist(ExpandEnvironment(percorso+nomefile))>-1) or
              isdir(ExpandEnvironment(percorso+nomefile)) then
                          else if copy(percorso,1,2)<>'\\' then nomefile:=fexpand2(nomefile);
           cursorOn;
           if (mox=27)and(moy=0) then      {ESC 2 volte esce totalmente}
              begin
              SfogliaFile:='';
              Exit;
              end;
           if (mox=13)and(moy=0) then       {INVIO}
               begin
               next:  {emula INVIO quando si preme su OK}
               stringa:=fexpand2(correggi(percorso,nomefile));
               ii:=pos('*',nomefile);
               if ii=0 then ii:=255;
               iii:=pos('?',nomefile);
               if iii=0 then iii:=255;
               ii:=Trunc(min(ii,iii));
               if posrl('\',nomefile,length(nomefile))<ii then
                  if (pos('*',nomefile)>0)or(pos('?',nomefile)>0) then {l'input era una directory + files}
                     begin
                     stato:=0;
                     if (Copy(nomefile,2,1)=':')or(Copy(nomefile,1,1)='\') then
                                                                  else nomefile:=fexpand2(correggi(percorso,nomefile));
                     percorso:=copy(nomefile,1,posrl('\',nomefile,255));
                     ifiles:=copy(nomefile,posrl('\',nomefile,length(nomefile))+1,255);
                     goto restart;
                     end;
               if posrl('\',nomefile,length(nomefile))>ii then  {Ok: tipo c:\*?\xyz }
                  begin
                  SfogliaFile:=UpStr(nomefile);
                  Exit;
                  end;

               if Exist(stringa)>=0 then  {era un file}
                  begin
                  SfogliaFile:=UpStr(stringa);
                  Exit;
                  end;
               if isDir(stringa) then  {era una directory}
                  begin
                  stato:=1;
                  percorso:=stringa;
                  goto restart;
                  end;
               stringa:=fexpand2(nomefile);
               if Exist(stringa)>=0 then  {l'input era un file}
                  begin
                  SfogliaFile:=UpStr(stringa);
                  Exit;
                  end;
               if isDir(stringa) then  {l'input era una directory}
                  begin
                  stato:=1;
                  percorso:=stringa;
                  goto restart;
                  end;
               if (Copy(nomefile,2,1)=':')or(Copy(nomefile,1,1)='\') then
                   SfogliaFile:=UpStr(fexpand2(nomefile))
                  else
                   SfogliaFile:=UpStr(fexpand2(correggi(percorso,nomefile)));
               Exit;  {qualunque cosa sia, esce: potrebbe crearla (salva) }
               end;
           if (mox=9)and(moy=0) then       {TAB}
              begin
              stato:=1;
              GreenZona(topo);
              textbackground(3);           {aggiorno il readstring}
              textcolor(blue);
              textbackground(3);
              gotoxy(X+9,Y+2);
              if A[iesimo][1]<>'D' then write('['+nomefile)
                                   else write(copy('['+nomefile+'\'+ifiles,1,36));
              while whereX<X+46 do write(' ');
              write(']');
              gotoxy(X+4,Y+selezionato+5);
              if topo then ShowMouse;
              end;
           if (moy=255)and(mox=38) then
              begin               {ALT +L}
   ALT_L:
              stato:=1;
              GreenZona(topo);
              gotoxy(X+4,Y+selezionato+5);
              c:=#1;
              textbackground(3);
              textcolor(blue);
              gotoxy(X+9,Y+2);
              if A[iesimo][1]<>'D' then write('['+nomefile)
                                   else write(copy('['+nomefile+'\'+ifiles,1,36));
              str:='';
              for i:=wherex to X+45 do str:=str+' ';
              write(str+']');
              gotoxy(X+4,Y+selezionato+5);
              end;

           if  ( (mox=X+18)and(moy>Y+5)and(moy<Y+19)and(count>13) ) or
               ( (mox>X+3) and(mox<X+17)and(moy>Y+5)and(moy<Y+19) ) then
                             goto next2;   {area lista files e freccine}
           if (moy>0)and(moy<26) then {mouse che clicca fuori da readstring}
              begin
              tasto:=1;
              goto escoReadStr;
              end;

           end;
if KeyPressed or not topo then c:=Readkey
              else
               begin
               Rilascio(mox,moy,tasto);
               escoReadStr:
               if tasto=1 then
                  begin
                  if (moy=Y+6)and(mox>X+36)and(mox<X+45) then  {ESCI}
                     begin
                     SfogliaFile:='';
                     Exit;
                     end;
                  if (moy=Y+6)and(mox>X+23)and(mox<X+32) then  {OK}
                     case stato of
                        1,2: begin
                             c:=#13;
                             stato:=1;
                             cursorOn;
                             end;
                          3: begin
                             gotoxy(X+37,Y+6);
                             write(' ');
                             gotoxy(X+44,Y+6);
                             write(' ');
                             GreenZona(topo);
                             gotoxy(X+4,Y+selezionato+5);
                             c:=#13;
                             stato:=1;
                             cursorOn;
                             end;
                          0: goto Next;
                          end; {del case}
                  end;
               RilascioDestra(mox,moy,tasto); {conferma l' apertura}
               if (tasto=1)and(stato=1)and(count>0)
                  and(selezionato=moy-Y-5) then goto next;
               Click(mox,moy,tasto);
               if tasto=1 then      {Gestione mouse}
                  begin
                  Next2: {esce da readstring e controlla area file e freccine}
                  if (moy=Y+2)and(mox>X+9)and(mox<X+46) then
                     begin
                     stato:=0;
                     Continue;            {ritorna al readstring}
                     end;
                  if (mox=(X+18)) and (moy=(Y+6)) then  {freccina alta}
                                                  begin
                                                  stato:=1;
                                                  c:=#72;
                                                  delay2(cd);
                                                  goto iniziocase;
                                                  end;
                  if (mox=(X+18)) and (moy=(Y+18)) then {freccina bassa}
                                                  begin
                                                  stato:=1;
                                                  c:=#80;
                                                  delay2(cd);
                                                  goto iniziocase;
                                                  end;
                  if (mox=X+18)and(moy>Y+6)and(moy<Y+18)and(count>21) then
                     begin  {barra}
                     stato:=1;
                     i:=count div 11;
                     if i<>0 then i:=iesimo div i;
                     i:=i+2;
                     if i>12 then i:=12;
                     if iesimo=1 then i:=2;
                     if i+y+5<>moy then
                        begin
                        iesimo:=(count div 11)*(moy-7-y)+2;
                        primo:=iesimo;
                        posto:=length(A[iesimo]);
                        selezionato:=1;
                        mostra(primo);
                        dettagli(topo,ifiles);
                        c:=#72;
                        goto iniziocase;
                        end;
                     end;
                  if (mox>X+3)and(mox<X+17)and(moy>Y+5)and(moy<Y+19) then
                     if (count>0) then
                        begin {file selezionato}
                        if stato<>1 then
                                    begin
                                    textbackground(green);
                                    gotoxy(X+24,Y+6);
                                    write(' ');
                                    gotoxy(X+31,Y+6);
                                    write(' ');
                                    gotoxy(X+37,Y+6);
                                    write(' ');
                                    gotoxy(X+44,Y+6);
                                    write(' ');
                                    end;
                        cursorOn;
                        ii:=moy-Y-5;
                        if (selezionato=ii)and(stato=1) then Continue;
                        stato:=1;
                        if selezionato>ii then   {verso sopra}
                               begin
                               textbackground(3);    {*** da aggiornare quello selezionato precedentemente}
                               textcolor(blue);
                               gotoxy(X+4,Y+selezionato+5);
                               if A[iesimo][1]='D' then write(copy(A[iesimo],2,255),'\')
                                                   else write(copy(A[iesimo],2,255));
                               while whereX<x+16 do write(' ');
                               iesimo:=iesimo-(selezionato-ii);
                               posto:=length(A[iesimo]);
                               selezionato:=ii;
                               end
                              else if count<>iesimo then
                               begin  {verso sotto}
                               textbackground(3);    {*** da aggiornare quello selezionato precedentemente}
                               textcolor(blue);
                               gotoxy(X+4,Y+selezionato+5);  {*** da aggiornare quello selezionato}
                               if A[iesimo][1]='D' then write(copy(A[iesimo],2,255),'\')
                                                   else write(copy(A[iesimo],2,255));
                               while whereX<x+16 do write(' ');
                               if count-primo>=ii then
                                                  begin
                                                  selezionato:=ii;
                                                  iesimo:=primo+selezionato-1;
                                                  end
                                                 else
                                                  begin
                                                  selezionato:=count-primo+1;
                                                  iesimo:=count;
                                                  end;
                               posto:=length(A[iesimo]);
                               end;
                        GreenZona(topo);
                        Dettagli(topo,ifiles);
                        gotoxy(X+4,Y+selezionato+5);
                        end;
                  end;
               if stato=0 then
                          begin
                          nomefile:=stringa;
                          goto readStr;
                          end;
               end;
if c=#0 then
        begin
        c:=ReadKey;
        iniziocase:
        if ord(c) in [71,79,81,77,80,72,73,75] then scrivo:='';
        if ( stato in [1..3] ) and (ord(c)=49) then { ALT + N }
           begin
           stato:=0;
           Continue;
           end;
        if ( (stato=2) or (stato=3) ) and (ord(c)=38) then
                 begin { ALT + L }
                 if stato=2 then gotoxy(X+24,Y+6)
                            else gotoxy(X+37,Y+6);
                 write(' ');
                 if stato=2 then gotoxy(X+31,Y+6)
                            else gotoxy(X+44,Y+6);
                 write(' ');
                 cursorOn;
                 moy:=255;
                 goto ALT_L;
                 end;
        if (count>0)and(stato=1) then
        case ord(c) of
             71: if iesimo>1 then     { inizio }
                             begin
                             iesimo:=1;
                             primo:=1;
                             selezionato:=1;
                             Mostra(primo);
                             GreenZona(topo);
                             Dettagli(topo,ifiles);
                             gotoxy(X+4,Y+6);
                             posto:=length(A[iesimo]);
                             end;
             79: if iesimo<count then     { fine }
                    begin
                    iesimo:=count;
                    primo:=(count div 13) *13 +1;
                    selezionato:=count mod 13;
                    if selezionato=0 then
                                     begin
                                     selezionato:=13;
                                     primo:=primo-13;
                                     end;
                    Mostra(primo);
                    GreenZona(topo);
                    Dettagli(topo,ifiles);
                    gotoxy(X+4,Y+selezionato+5);
                    posto:=length(A[iesimo]);
                    end;
           81,77: if (iesimo<count-12)and(count>13) then  { pag giu' /destra }
                    begin
                    iesimo:=iesimo+13;
                    primo:=primo+13;
                    if iesimo>count then iesimo:=count;
                    if primo>count then
                                begin
                                selezionato:=selezionato-(count-primo)-1;
                                primo:=count;
                                end;
                    Mostra(primo);
                    dec(iesimo);
                    dec(selezionato);
                    posto:=length(A[iesimo]);
                    goto giu;
                    end
                   else
                    begin
                    c:=#79;
                    goto iniziocase;
                    end;
             80: if iesimo<count then  { giu' }
                    begin                             Giu:
                    inc(iesimo);
                    if selezionato<13 then inc(selezionato)
                                     else
                                      begin
                                      inc(primo);
                                      Mostra(primo);
                                      end;
                    GreenZona(topo);
                    if whereY>y+6 then
                       begin     {*** da aggiornare quello selezionato precedentemente}
                       gotoxy(X+4,Y+selezionato+4);
                       textbackground(3);
                       textcolor(blue);
                       if A[iesimo-1][1]='D' then write(copy(A[iesimo-1],2,255),'\')
                                             else write(copy(A[iesimo-1],2,255));
                       while whereX<x+16 do write(' ');
                       posto:=length(A[iesimo]);
                       end;
                    Dettagli(topo,ifiles);
                    gotoxy(X+4,Y+selezionato+5);
                    end;
             72: if iesimo>1 then   { su }
                    begin
                    dec(iesimo);
                    if selezionato>1 then dec(selezionato)
                                     else
                                      begin
                                      dec(primo);
                                      Mostra(primo);
                                      end;
                    GreenZona(topo);
                    gotoxy(X+4,Y+selezionato+6);
                    textbackground(3);    {*** da aggiornare quello selezionato precedentemente}
                    textcolor(blue);
                    if A[iesimo+1][1]='D' then write(copy(A[iesimo+1],2,255),'\')
                                          else write(copy(A[iesimo+1],2,255));
                    while whereX<x+16 do write(' ');
                    Dettagli(topo,ifiles);
                    gotoxy(X+4,Y+selezionato+5);
                    posto:=length(A[iesimo]);
                    end;
          73,75: if iesimo>13 then  { pag su /sinistra }
                    begin
                    iesimo:=iesimo-13;
                    primo:=primo-13;
                    if iesimo<13 then
                                 begin
                                 selezionato:=iesimo;
                                 primo:=1;
                                 end;
                    Mostra(primo);
                    dec(iesimo);
                    dec(selezionato);
                    posto:=length(A[iesimo]);
                    goto giu;
                    end
                   else
                    begin
                    c:=#71;
                    goto iniziocase;
                    end;
             end; {del case}
             c:=#1;
        end
       else if c<>#1 then {tasto normale}
        begin
        if topo then HideMouse;
        case c of
            #13:  case stato of    {INVIO}
                       3: begin                  {ESCI}
                          SfogliaFile:='';
                          Exit;
                          end;
                     2,1: begin                  {OK o selezionato}
                          cursorOn;
                          scrivo:='';
                          if Copy(A[iesimo],1,1)='D' then
                             begin
                             if Copy(A[iesimo],2,255)='..' then
                                 begin
                                 i:=PosRL('\',percorso,length(percorso)-1);
                                 if i>0 then percorso:=Copy(percorso,1,i)
                                        else
                                         begin
                                         if topo then ShowMouse;
                                         c:=#1;
                                         Continue; {unita' Subst}
                                        end;
                                 end
                                else percorso:=percorso+nomefile+'\';
                             stato:=1;
                             goto restart;
                             end;
                          if Copy(A[iesimo],1,1)='f' then
                             begin
                             SfogliaFile:=UpStr(percorso+nomefile);
                             Exit;
                             end;
                          end;
                      end;  {del case}
             #9:  begin         {cambia stato con TAB}
                  scrivo:='';
                  inc(stato);
                  if stato>3 then stato:=0;
                  if (stato=3) then
                     begin
                     YellowZona;
                     textbackground(green);
                     textcolor(white);
                     cursorOff;
                     gotoxy(X+24,Y+6);
                     write(' ');
                     gotoxy(X+31,Y+6);
                     write(' ');
                     gotoxy(X+37,Y+6);
                     write('[');
                     gotoxy(X+44,Y+6);
                     write(']');
                     end;
                  if stato=2 then
                     begin
                     YellowZona;
                     textbackground(green);
                     textcolor(white);
                     cursorOff;
                     gotoxy(X+24,Y+6);
                     write('[');
                     gotoxy(X+31,Y+6);
                     write(']');
                     end;
                  if stato=1 then
                             begin
                             GreenZona(topo);
                             cursorOn;
                             end;
                  if stato=0 then
                     begin
                     c:=#1;   {readstring}
                     Continue;
                     end;
                  end;
            #27:  begin  {tasto ESC}
                  SfogliaFile:='';
                  Exit;
                  end;
            #38:  if ALT then  {ALT + L  LISTA}
                     begin
                     scrivo:='';
                     stato:=1;
                     textbackground(green);
                     gotoxy(X+24,Y+6);
                     write(' ');
                     gotoxy(X+31,Y+6);
                     write(' ');
                     gotoxy(X+37,Y+6);
                     write(' ');
                     gotoxy(X+44,Y+6);
                     write(' ');
                     GreenZona(topo);
                     gotoxy(X+4,Y+selezionato+5);
                     cursorOn;
                     end;
            #49:  if ALT then  {ALT + N  NOME}
                     begin
                     scrivo:='';
                     stato:=0;
                     continue;
                     end;
             end; {del case}
        if (stato=1) then  {in ogni altro stato, azzerarlo}
           begin
           stringa:=scrivo;
           if c=#8 then if length(scrivo)>0 then scrivo[0]:=char(length(scrivo)-1);
           if ord(c) in [32..255] then if length(scrivo)<13 then scrivo:=scrivo+Upcase(c);
           if scrivo<>stringa then
              begin
              i:=CercaFile2(scrivo);
              if (i<>iesimo)and(i>0) then
                 begin
                 iesimo:=i;
                 if iesimo<7 then
                    begin
                    primo:=1;
                    selezionato:=i;
                    end
                   else
                    begin
                    primo:=iesimo-6;
                    selezionato:=iesimo-primo+1;
                    end;
                 Mostra(primo);
                 GreenZona(topo);
                 Dettagli(topo,ifiles);
                 end;
              if (i=0)and(ord(c) in [32..255]){and(length(scrivo)>length(stringa))}
                     and (length(scrivo)>0) then scrivo[0]:=char(length(scrivo)-1);
              gotoxy(X+4+length(scrivo),Y+selezionato+5);
              end;
           end;
        if topo then ShowMouse;
        c:=#1;
        end
until false;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

end.
