unit ALTROW;     { ALTROW.PAS : Unit con particolari funzioni e procedure. }

interface
uses WinCrt,WinDos,Strings;

const invio=#13+#10;
      os_prog='WIN';
      bit=16;
      Black=0;
      Blue=1;
      Green=2;
      Cyan=3;
      Red=4;
      Magenta=5;
      Brown=6;
      LightGray=7;
      DarkGray=8;
      LightBlue=9;
      LightGreen=10;
      LightCyan=11;
      LightRed=12;
      LightMagenta=13;
      Yellow=14;
      White=15;
      BW40=0;
      CO40=1;
      BW80=2;
      CO80=3;
      Mono=7;
      C40=CO40;
      C80=CO80;
      Archive=faArchive;
      ReadOnly=faReadOnly;
      Directory=faDirectory;
      Hidden=faHidden;
      SysFile=faSysFile;
      AnyFile=faAnyFile;
      VolumeID=faVolumeID;
function getshortname(var s:string):boolean;
function getlongname(var s:string):boolean;
type SearchRec=tSearchRec;

          {***FILE***}
procedure FSplit(p:string; var d,n,e:string);
function  Attr(s:string):string;
function  contaThis(path,nome:string):longint;
function  ChangeFileExt(const FileName, Extension: string): string;
function  underdos:boolean;
function  underwin:boolean;
function  contaDirFile(s:string):longint;
function  contaDir(s:string):longint;
function  contaFile(s:string):longint;
  { tornano rispettivamente quanti file e directory, directory, files
    ci sono in una directory, -1 se non e' una directory}
function  SubDir(path,tmpfile:string):byte;
  { data una directory, crea nel file tmpfiles la struttura delle
    sottodirectory della directory indicata sottoforma di stringhe.
    Le stringhe sono di 256 caratteri, i caratteri che non appartengono alle
    sottodirectory sono il carattere di ordinata 0.
    Torna: 0= (sovra) scrittura avvenuta con successo
           1= scrittura su file fallita
           2= operazione interrotta dall'utente premendo il tasto ESC
   il file non viene cancellato se la funzione torna 1 o 2.
   Se il file e' vuoto, significa che non ci sono sottodirectori, o non
   esiste quella indicata }
function  DeleteFile(TmpFiles:string):boolean;
  { cancella il file indicato: se lo cancella torna true, se non c'era o non
    puo' cancellarlo torna il valore false}
function  TmpFile(ilFile:string):string;
  { torna il percorso+nome del file temporaneo, guarda le variabili d'ambiente }
function  NewDir(dir:string):integer;
  { crea una directory e sottodirectory }
function  ValidNameDos(s:string):byte;
function  ValidNameWin(s:string):byte;
function  ValidName(s:string):byte;
  { torna 0 se il nome del file (path opzionale) e' valido, altrimenti
    la posizione dove inizia l'errore }
function  NameOf(s:string):string;
  { dato un cammino, restituisce il percorso senza file }
function  PathOf(stringa:string):string;
  { dato un cammino, restituisce il percorso senza file: finira' con : o \}
function  DeepDir(s:string):string;
  { data una stringa come directory, torna stringa vuota se non era o non
    esisteva come directory, altrimenti restituisce un cammino in profondita'
    (non e' detto che sia il piu' lungo) }
function  isDir(s:string):boolean;
  { data una stringa, torna true se l'equivalente della directory esiste,
    false se non c'e' o non lo e' }
function  DirEmpty(s:string):boolean;
  { data una stringa, torna true se l'equivalente della directory e' vuota,
    false se non lo e' o non esiste }
function  TruncPath(str:string; Max:byte):string;
  { dato percorso e/o nomefile , ed una lunghezza massima, ne restituisce
    l'equivalente abrreviato con  U:\...\?????????? o lo stesso se non e'
    possibile abbreviarlo }
function  CharReserved(s:string; jolly:boolean):byte;
  { data una stringa indica se e' lecita usarla come nome di file: il nome
    potrebbe contenere caratteri riservati al DOS. Torna la posizione del
    carattere se e' ve ne e',altrimenti 0. Jolly indica se considerare anche
    ? e * come riservati.
    Caratteri riservati: ,;=+ /:|<>" e  0..32 }
function  CharDriver(s:string):char;
  { data una stringa ne torna il driver se valido, altrimenti il carattere 0 }
function  NumDriver(s:string):byte;
  { data una stringa ne torna il numero del driver se valido, altrimenti 255 }
function  Exist(nome:string):longint; { controlla se esiste un path+file
                                      { non accetta caratteri jolli (*,?)
                                      { se non esiste ritorna -1,
                                        altrimenti la dimensione del file }
function  NameReserved(str:string):boolean;
  { data una stringa indica se e' lecita usarla come nome di file: il nome
    potrebbe essere riservato al DOS. Torna true se e' riservata,
    altrimenti false }
function ExpandEnvironment(s:string):string;
  { converte le variabili d'ambiente di un percorso, senza espanderlo, se tutte
    corrette ( %xxx% ) }
function  fexpand2(s:string):string;
  { come FExpand, ma converte pure le variabili d'ambiente se tutte corrette
    ( %xxx% ) }

          {***STRINGHE e NUMERI***}
procedure setlength(var s:string; n:byte);
procedure Reverse(var str:string);
procedure ExchangeChar(var a,b:char);
procedure ExchangeByte(var a,b:byte);
procedure ExchangeInteger(var a,b:integer);
procedure ExchangeLongint(var a,b:longint);
procedure ExchangeStr(var s1,s2:string);
procedure Testa_Coda(str,ins:string; var testa,coda:string);
function  Bool(b:boolean):byte; {torna 1 se b=true, 0 se b=false}
function  Union(s1,s2:string):string;
function  Intersection(s1,s2:string):string;
function  Single(str:string):string; {toglie i caratteri ripetuti}
function  fDelete(Str: String; Index,Count:Integer):string; {come il delete}
function  Dim_Punto(num:longint):string; {raggruppa le cifre a 3 a 3}
function  IntToStr(I: Longint): String;  {Converte da intero a stringa}
function  ToByte(L:longint):byte;       {casting da integer o longint a byte }
function  ToLongint(x:integer):Longint; {casting da byte o integer a longint}
function  FromTo(oldV:string; oldB,newB:byte):string;{newV} {converte da base a base (2..16)}
function  ToDecimal(num:string; oldBase:byte):string; {converte da base 2..16 a decimale}
function  DecimalTo(numdec:longint; newBase:byte):string; {converte da decimale a base 2..16 (maiuscolo)}
function  fReverse(str:string):string;   {inverte una stringa}
function  noSpaceR(str:string):string;   {toglie gli spazi finali (a destra)}
function  noSpaceL(str:string):string;   {toglie spazi iniziali (a sinistra)}
function  LowStr(str:string):string;     {stringa tutta minuscola}
function  UpStr(str:string):string;      {stringa tutta maiuscola}
function  PosRL(sub,str:string; start:byte):byte;     {cerca una stringa partendo da start da DS}
function  StringToPChar(s:string):PChar; {converte da stringa a PChar}
function  FreeChar(c,s:string):string;
function  Conta(str,stringa:string; start:byte; b:boolean):byte;
  {conta quante volte str compare in stringa a partire da start, se b=true a destra di start,
   altrimenti a sinistra}
function  CopyRL(str :string; start,count:integer):string; {copia da D verso S}
function  SostituisciLR(n:byte; sub,str,stringa:string):string; {da sinistra
  verso destra, sostituisce l' n-sima stringa sub, con str nella stringa}
function  SostituisciRL(n:byte; sub,str,stringa:string):string;
{da destra verso sinistra, sostituisce l' n-sima stringa sub, con str nella stringa}
function  Digits(c:char):boolean; {torna true se il carattere e' un numero}
function  Letters(c:char):boolean;{torna true se il carattere e' una lettera}
function  PosStart(sub,s:string; start:byte):byte;   {cerca una stringa partendo da start}
function  PosJolly(sub,str:string; start:byte):byte; {cerca una stringa jolly partendo da start SD}
function  PosJollyRL(sub,str:string; start:byte):byte;{cerca una stringa jolly partendo da start da DS}
function  LowCase(c:char):char; {da maiuscolo a minuscolo}
function  GetEnvVarS(s:string):string;
  {restituisce le impostazioni di una variabile d' ambiente}

          {***TEMPO***}
procedure Delay2(tempo:longint); {ritardo in centesimi di secondo reali}
function  Time100:longint;       {restituisce il tempo attuale in centesimi}

          {***TASTIERA***}
{ function  Tasti_Speciali:byte;   per shift,ctrl.alt...
  da non interfacciare esternamente }
function  Alt:boolean;           {true se Alt premuto}
function  Shift:boolean;         {true se Shift premuto}
function  Ctrl:boolean;          {true se Ctrl premuto}
procedure Tast_Vuota;            {svuota il buffer della tastiera}
procedure keyspeed(delay,rate:byte);

          {***MATEMETICA***}
procedure Eleva(base,esponente:real; var potenza:real; var err:byte);
function  IsInt(X: real): boolean;  {Torna vero se il numero e' un intero es: 4,000000000000}
function  TAN (angle: real): real;  {tangente in radianti}
function  COTAN (angle: real):real; {cotangente in radianti}
function  SIGN (R: real): real;     {ritorna -1 se R<0, 0 se R=0, o 1 se R>0.}
function  FACT (n: integer): real;  {Ritorna il fattoriale di un numero tra 0..33, -1 altrimenti}
function  DegToRad(gr:real):real;   {converte da gradi a radianti}
function  RadToDeg(rad:real):real;  {converte da radianti a gradi}
function  Max(a,b:real):real;       {torna il Max fra 2 numeri reali}
function  Min(a,b:real):real;       {torna il Min fra 2 numeri reali}

          {***compatibilita'***}
function  LastMode:byte;
procedure TextMode(x:byte);
procedure textcolor(x:byte);
procedure textbackground(x:byte);
procedure nosound;
procedure Sound(Hz: Word);

implementation

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure keyspeed(delay,rate:byte);
begin
asm
 mov ah,03
 mov al,05
 mov bh,delay  { delay ritardo }
 mov bl,rate   { rate  frequenza }
 int 16h
 end;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function Time100:longint;     {restituisce il tempo attuale in centesimi}
var h,m,s,cs:word;
begin
GetTime(h,m,s,cs);
Time100:=(h*60*60+m*60+s)*100+cs;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure Delay2(tempo:longint);      {ritardo in centesimi di secondo}
var tempo_inizio:longint;
begin
 tempo_inizio:=time100;
repeat until abs(Time100-tempo_inizio)>tempo;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function Dim_Punto(num:longint):string;
var numero,numero1:string[30];
    i,pos:byte;
    negativo:boolean;
begin
pos:=0;
numero1:='';
if num<0 then
         begin
         negativo:=true;
         num:=-num;
         end
        else negativo:=false;
str(num,numero);
for i:=length(numero) downto 1 do
    begin
    inc(pos);
    numero1:=numero1+numero[i];
    if (pos mod 3 =0)and(pos<>length(numero)) then numero1:=numero1+ '.';
    end;
if negativo then dim_punto:='-'+fReverse(numero1)
            else dim_punto:=fReverse(numero1);
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function DecimalTo(numdec:longint; newBase:byte):string;
var s:string;           {converte da decimale a base 2..16 (maiuscolo)}
    v:byte;             {se la base e' errata torna stringa vuota}
    c:char;
    neg:boolean;
begin
if (newBase>16)or(newBase<2) then
      begin
      DecimalTo:='';
      Exit;
      end;
s:='';
if numdec<0 then
    begin
    neg:=true;
    numdec:=-numdec;
    end
   else neg:=false;
repeat
 v:=numdec mod newBase;
 numdec:=numdec div newBase;
 case v of
   10: c:='A';
   11: c:='B';
   12: c:='C';
   13: c:='D';
   14: c:='E';
   15: c:='F';
   else c:=char(v+48);
 end;
 s:=c+s;
until numdec=0;
if neg then s:='-'+s;
DecimalTo:=s;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function fReverse(str:string):string;
var s2:string;
    l,i:byte;
begin
l:=length(str);
s2[0]:=str[0];
for i:=1 to L do s2[i]:=str[l-i+1];
fReverse:=s2;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure Tast_Vuota;     {svuota il buffer della tastiera}
begin
while keypressed do ReadKey;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function Tasti_Speciali:byte;   {per shift,ctrl.alt...}
var valore:byte;
begin
asm
  mov ah,2h
  int 16h
  mov valore,al
  end;
Tasti_Speciali:=valore;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function Shift:boolean;
var tasti:byte;
begin
tasti:=Tasti_Speciali;
Shift:=false;
if (tasti and 1 <>0)or(tasti and 2 <>0) then Shift:=true;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure Eleva(base,esponente:real; var potenza:real; var err:byte);
begin             { b^x = e^( Ln (b^x) ) = e^( x Ln b ) }
if base=0 then Err:=1;            {Valori per Err:             }
if base>0 then                             { 1:   Base = 0     }
     begin                                 { 2:   Esponente <0 }
     if esponente<0 then err:=2;           { 3:   Base <0 , Esponente >0 }
     potenza:=exp(esponente*ln(base));     { 4:   Base <0 , Esponente <0 }
     end;
if (base<0) and (esponente>0) then err:=3;
if (base<0) and (esponente<0) then err:=4;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function LowCase(c:char):char; {da maiuscolo a minuscolo}
begin
if c in ['A'..'Z'] then LowCase:=char(ord(c)+32)
                   else LowCase:=c;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function noSpaceR(str:string):string;   {toglie gli spazi finali (a destra)}
var tot,i:byte;
begin
tot:=0;
for i:=length(str) downto 1 do
      if str[i] in [' ',#9] then inc(tot)
                            else Break;
str[0]:=char(ord(str[0])-tot);
noSpaceR:=str;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function noSpaceL(str:string):string; {toglie spazi iniziali (a sinistra)}
var tot,i:byte;
begin
tot:=0;
for i:=1 to length(str) do
      if str[i] in [' ',#9] then inc(tot)
                            else Break;
noSpaceL:=copy(str,tot+1,length(str)-tot);
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function UpStr(str:string):string;
var i:byte;
begin
for i:=1 to length(str) do str[i]:=UpCase(str[i]);
UpStr:=str;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function LowStr(str:string):string;
var i:byte;
begin
for i:=1 to length(str) do str[i]:=LowCase(str[i]);
LowStr:=str;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function PosRL(sub,str:string; start:byte):byte;  {cerca una stringa partendo da start da destra verso sinistra}
var i,j,pos,lsub,lstr:byte;
    pezzo:string;
begin
str:=Copy(str,1,start);
lstr:=length(str);
lsub:=length(sub);
PosRL:=0;
for i:=lstr downto lsub do
      begin
      pezzo:='';
      pos:=0;
      for j:=1 to lsub do
               begin
               pezzo:=str[i-pos]+pezzo;
               inc(pos);
               end;
      if pezzo=sub then
                   begin
                   PosRL:=i-lsub+1;
                   Exit;
                   end
                  else PosRL:=0;
      end;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function SostituisciLR(n:byte; sub,str,stringa:string):string;
{da sinistra verso destra, sostituisce l' n-sima stringa sub, con str nella stringa}
var posto,i:byte;
    str2:string;
begin
str2:=stringa;
posto:=0;
for i:=1 to n do
   begin
   posto:=pos(sub,str2);
   if posto=0 then Break
              else str2[posto]:=char(ord(str[1])-1); {il pos successivo sicuramente sara' diverso}
   end;
if posto<>0 then
     begin
     delete(stringa,posto,length(sub));
     insert(str,stringa,posto);
     end;
SostituisciLR:=stringa;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function SostituisciRL(n:byte; sub,str,stringa:string):string;
{da destra verso sinistra, sostituisce l' n-sima stringa sub, con str nella stringa}
var posto,i:byte;
    str2:string;
begin
str2:=stringa;
posto:=0;
for i:=1 to n do
   begin
   posto:=posRL(sub,str2,length(str));
   if posto=0 then Break      {il pos successivo sicuramente sara' diverso}
              else str2[posto+length(sub)-1]:=char(ord(str[length(str)])-1);
   end;
if posto<>0 then
     begin
     delete(stringa,posto,length(sub));
     insert(str,stringa,posto);
     end;
SostituisciRL:=stringa;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function Conta(str,stringa:string; start:byte; b:boolean):byte;
var count,posto,i:byte;
begin
if b then stringa:=Copy(stringa,start,length(stringa)-start+1) {a destra}
     else stringa:=Copy(stringa,1,start);                      {a sinistra}
count:=0;
for i:=1 to length(stringa)-length(str)+1 do
  begin
  posto:=pos(str,stringa);
  if posto=0 then break
        else
         begin
         count:=count+1;
         stringa[posto]:=char(ord(stringa[posto])+1);
         end;
  end;
conta:=count;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function CopyRL(str :string; start,count:integer):string; {copia da D verso S}
var str2:string;
    i:integer;
begin
str2:='';
for i:=1 to count do
   if (start+1-i>0)and(length(str)>start-i) then str2:=str[start+1-i]+str2
                                            else Break;
CopyRL:=str2;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function TruncPath(str:string; Max:byte):string; {2.0}
var a,b:integer;
begin
str:=FExpand2(str);
a:=pos('\',str);
if (length(str)<=Max)or(a=0) then
   begin
   TruncPath:=str;
   exit;
   end;
str[a]:='?';
repeat
 b:=pos('\',str);
 if b=0 then Break
        else str[b]:='?';
 str:=copy(str,1,a)+'...'+copy(str,b,255);
until length(str)<=max;
for b:=a to length(str) do if str[b]='?' then str[b]:='\';
TruncPath:=str;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure ExchangeInteger(var a,b:integer);
var c:integer;
begin
c:=a;
a:=b;
b:=c;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure ExchangeLongint(var a,b:longint);
var c:longint;
begin
c:=a;
a:=b;
b:=c;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure ExchangeByte(var a,b:byte);
var c:byte;
begin
c:=a;
a:=b;
b:=c;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function ToLongint(x:integer):Longint;
begin
ToLongint:=x;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function IntToStr(I: Longint): String; { Converte da intero a stringa }
var
 S: string[11];
begin
 Str(I, S);
 IntToStr := S;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure ExchangeChar(var a,b:char);
var c:char;
begin
c:=a;
a:=b;
b:=c;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure Reverse(var str:string);
var i,L:byte;
begin
L:=length(str);
for i:=1 to (L div 2) do ExchangeChar(str[i],str[L-i+1]);
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function ToDecimal(num:string; oldBase:byte):string; {converte da base 2..16 a decimale}
var i,cifra,err:byte;
    neg:boolean;
    old,valore,cont:longint;
    risult:real;
begin
if (oldBase>16)or(oldBase<2) then
      begin
      ToDecimal:='';
      Exit;
      end;
valore:=0;
cont:=-1;
if num[1]='-' then
    begin
    neg:=true;
    delete(num,1,1);
    end
   else neg:=false;

for i:=length(num) downto 1 do
begin
 inc(cont);
 if num[i] in ['0'..'9'] then cifra:=ord(num[i])-48
    else
     case UpCase(num[i]) of
        'A': cifra:=10;
        'B': cifra:=11;
        'C': cifra:=12;
        'D': cifra:=13;
        'E': cifra:=14;
        'F': cifra:=15;
        end;
if cifra>oldBase then
      begin
      ToDecimal:='';
      Exit;
      end
     else
      begin
      Eleva(oldBase,cont,risult,err);
      old:=valore;
      Valore:=valore+cifra*Trunc(risult);
      if valore<old then
          begin
          ToDecimal:='';  {sforato il max longint}
          Exit;
          end;
      end;
end;
if neg then valore:=-valore;
ToDecimal:=IntToStr(valore);
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function IsInt(X: real): boolean; {Torna vero se il numero e' un intero es: 4,000000000000}
begin
if abs (X) < maxint then IsInt := X = trunc (X)
                    else IsInt := false
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function TAN (angle: real): real;
begin
  TAN := SIN (angle) / COS (angle);
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function COTAN (angle: real): real; {cotangente in radianti}
begin
  COTAN := COS (angle) / SIN (angle);
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function SIGN (R: real): real; {ritora -1 se R<0, 0 if R=0, o 1 if R>0.}
begin
if R > 0.0 then SIGN := 1.0
           else if R < 0.0 then SIGN := -1.0
                           else SIGN := 0.0;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function FACT (n: integer): real;  {Ritorna il fattoriale di un numero tra 0..33, -1 altrimenti}
var k: integer;
    ans: real;
begin
  ans := 1.0;
  if (n<0)or(n>33) then FACT := -1
                   else for k := 2 to n do ans := k * ans;
  FACT := ans
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function FromTo(oldV:string; oldB,newB:byte):string;{newV} {converte da base a base (2..16)}
var num:longint;
    err:integer;
begin
oldV:=ToDecimal(oldV,oldB); {converte da base 2..16 a decimale}
if oldV<>'' then {no errori nella riga precedente durante la conversione}
   begin
   Val(oldV,num,err);
   FromTo:=DecimalTo(num,newB);
   end
  else FromTo:='';
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function ToByte(L:longint):byte;
begin
ToByte:=L mod 256;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function DegToRad(gr:real):real;  {g:r = 360 : 2*3.14}
begin
DegToRad:=gr / 180 * Pi;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function RadToDeg(rad:real):real;  {g:r = 360 : 2*3.14}
begin
RadToDeg:=rad * 180 / Pi;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function fDelete(Str: String; Index,Count:Integer):string;
begin
delete(Str,Index,Count);
fDelete:=str;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function Max(a,b:real):real;
begin
if a>b then Max:=a
       else Max:=b;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function Min(a,b:real):real;
begin
if a<b then Min:=a
       else Min:=b;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function Single(str:string):string; {toglie i caratteri ripetuti}
var i,ii:byte;
begin
i:=0;
repeat
 inc(i);
 ii:=i;
 repeat
  inc(ii);
  if str[i]=str[ii] then
              begin
              Delete(str,ii,1);
              dec(ii);
              end;
 until ii>=length(str);
until i>=length(str);
Single:=str;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function Union(s1,s2:string):string;
begin
s1:=Single(s1);
s2:=Single(s2);
if length(s1)+length(s2)<256 then Union:=Single(s1+s2)
                             else Union:=''; {se si superano i 255 caratteri}
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure ExchangeStr(var s1,s2:string);
var s3:string;
begin
s3:=s1;
s1:=s2;
s2:=s3;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function Intersection(s1,s2:string):string;
var i:byte;
    s3:string;
begin
s3:='';
s1:=Single(s1);
s2:=Single(s2);
if length(s2)<length(s1) then ExchangeStr(s1,s2);
for i:=1 to length(s1) do if Pos(s1[i],s2)>0 then s3:=s3+s1[i];
Intersection:=s3;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure Testa_Coda(str,ins:string; var testa,coda:string);
var i,pos1,pos2,S,tmp:byte;
    app:string;
begin
ins:=Single(ins);
coda:='';
testa:='';
if length(str)<2 then
    begin
    testa:=str;
    Exit;
    end;
if ins='' then
   begin
   testa:=str;
   Exit;
   end;                {trovo il 1 elemento separatore}
pos1:=255;  {il massimo}
for i:=1 to length(ins) do
    begin
    tmp:=Pos(ins[i],str);
    if tmp=0 then tmp:=255;
    pos1:=Trunc(Min(pos1,tmp));
    if pos1=1 then Break; {non puo' essere < 1: inutile continuare il ciclo}
    end;
if pos1=255 then S:=0  {non vi sono elementi separatori}
            else S:=1; {c'e' almeno un elemento separatore}
if S=1 then
       begin
       pos2:=255;  {il massimo}
       app:=fDelete(str,pos1,1);
       for i:=1 to length(ins) do
           begin
           tmp:=Pos(ins[i],app);
           if tmp=0 then tmp:=255;
           pos2:=Trunc(Min(pos2,tmp));
           if pos2=1 then Break; {non puo' essere < 1: inutile continuare il ciclo}
           end;
       if pos2=255 then {S=1 c'e' solo un elemento separatore}
                   else
                    begin
                    S:=2; {ci sono almeno 2 elementi separatori}
                    inc(pos2);
                    end;
       end;
case S of
 0: testa:=str;
 1: if pos1=1 then testa:=str
              else
               begin
               testa:=Copy(str,1,pos1-1);
               coda:=Copy(str,pos1,length(str)-pos1+1);
               end;
 2: if pos1=1 then
               begin
               testa:=Copy(str,1,pos2-1);
               coda:=Copy(str,pos2,length(str)-pos1+1)
               end
              else
               begin
               testa:=Copy(str,1,pos1-1);
               coda:=Copy(str,pos1,length(str)-pos1+1);
               end;
 end;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function Alt:boolean;
begin
if (Tasti_Speciali and 8 <>0) then Alt:=true
                              else Alt:=false;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function Ctrl:boolean;
begin
if (Tasti_Speciali and 4 <>0) then Ctrl:=true
                              else Ctrl:=false;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function Bool(b:boolean):byte;
begin
if b then Bool:=1
     else Bool:=0;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function CharReserved(s:string; jolly:boolean):byte;
var i,posto:byte;    {escluso i caratteri jolly ?*}
    bad:string;
    risultato:boolean;
begin
bad:=',;=+ /:|<>"';
if jolly then bad:=bad+'?*';
for i:=0 to 32 do bad:=bad+char(i);
risultato:=false;
for i:=1 to length(bad) do
    begin
    posto:=pos(bad[i],s);
    if posto<>0 then
          begin
          risultato:=true;
          Break;
          end;
    end;
if risultato then CharReserved:=posto
             else CharReserved:=0;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function Letters(c:char):boolean;
begin
if UpCase(c) in ['A'..'Z'] then Letters:=true
                           else Letters:=false;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function Digits(c:char):boolean;
begin
if c in ['0'..'9'] then Digits:=true
                   else Digits:=false;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function PosStart(sub,s:string; start:byte):byte;
var posiz:byte;
begin
posiz:=pos(sub,Copy(s,start,length(s)-start+1));
if posiz=0 then PosStart:=0
           else PosStart:=start-1+posiz;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function CharDriver(s:string):char;
begin
if length(s)<2 then CharDriver:=#0
   else if s[2]<>':' then CharDriver:=#0
           else if Letters(s[1]) then CharDriver:=UpCase(s[1])
                                 else CharDriver:=#0;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function NumDriver(s:string):byte;
begin
if length(s)<2 then NumDriver:=255
   else if s[2]<>':' then NumDriver:=255
           else if Letters(s[1]) then NumDriver:=ord( UpCase(s[1]) )-64
                                 else NumDriver:=255;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function PosJolly(sub,str:string; start:byte):byte;
var position,stringa:string;
    a,cicli:byte;
begin
str:=Copy(str,start,length(str)-start+1);
position:='';
for a:=1 to length(sub) do if sub[a]='?' then position:=position+char(a);

cicli:=0;
while true do
      begin
      inc(cicli);
      stringa:=Copy(str,cicli,length(str)-cicli+1); {copia la parte interessata}
      for a:=1 to length(position) do  {modifica dove necessario}
          if a<=length(str) then stringa[ord(position[a])]:='?'
                            else Break;
      a:=pos(sub,stringa);
      if a>0 then
             begin
             PosJolly:=start-1+a+cicli-1;
             Exit;
             end
            else
             if cicli>=length(str)-length(sub)+1 then
                                                    begin
                                                    PosJolly:=0;
                                                    Exit;
                                                    end;
      end;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function PosJollyRL(sub,str:string; start:byte):byte;
var position,stringa:string;
    a,cicli:byte;
begin
str:=Copy(str,1,start);
position:='';
for a:=1 to length(sub) do if sub[a]='?' then position:=position+char(a);
cicli:=length(sub)-1;
while true do
      begin
      inc(cicli);
      stringa:=Copy(str,length(str)-cicli+1,cicli); {copia la parte interessata}
      for a:=1 to length(position) do  {modifica dove necessario}
          if a<=length(str) then stringa[ord(position[a])]:='?'
                            else Break;
      a:=posRL(sub,stringa,length(stringa));
      if a>0 then
             begin
             PosJollyRL:=length(str)-length(stringa)+1;
             Exit;
             end
            else
             if cicli>length(stringa) then
                                      begin
                                      PosJollyRL:=0;
                                      Exit;
                                      end;
      end;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function Exist(nome:string):longint;
var DirInfo: TSearchRec;
    a:array[0..255] of char;
begin
Exist:=-1;   {non esiste}
if (nome[length(nome)]='.') then Exit;
if ( Pos('*',nome)<>0 ) or (Pos('?',nome)<>0) then Exit;
StrPCopy(A, nome);
FindFirst(a,faReadOnly + faArchive + faSysfile + faHidden + faAnyfile, DirInfo);
if DosError = 0 then Exist:=DirInfo.Size;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function NameReserved(str:string):boolean;
var err:boolean;
    app,d,n:string;
    Dirx: array[0..fsDirectory] of Char;
    Name: array[0..fsFileName] of Char;
    Ext:  array[0..fsExtension] of Char;

begin
FileSplit(StringToPChar(str), Dirx, name, ext);
D:=StrPas(dirX);
N:=StrPas(name);
if length(N)>4 then
      begin
      NameReserved:=false;
      Exit;
      end;
err:=false;
N:=UpStr(N);
str:=N;   {il nome e' in STR}
while length(str)<4 do str:=str+' '; {la qualsiasi cosa: correzione di STR}
app:=str[1]+str[2]+str[3];
repeat
 if app='COM' then if str[4] in ['1'..'4'] then err:=true;
 if err then Break;
 if app='LPT' then if str[4] in ['1'..'9'] then err:=true;
 if err then Break;
 if (N='AUX') or (N='NUL') or (N='PRN') or (N='CON') then err:=true;
until True;
NameReserved:=err;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function DirEmpty(s:string):boolean;
var vuota:boolean;
    DirInfo: TSearchRec;
begin
case s[length(s)] of
     '\' : s:=s+'*.*';
     ':' : s:=s+'*.*';
     else  s:=s+'\*.*';
     end;
vuota:=true;
FindFirst(StringToPChar(s), faArchive + faReadOnly + faDirectory + faHidden + faSysFile + faAnyFile, DirInfo);
while (DosError=0) and vuota do
      begin
      if (StrPas(dirinfo.Name)<>'.')and(StrPas(dirinfo.Name)<>'..') then vuota:=false;
      FindNext(DirInfo);
      end;
DirEmpty:=vuota;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function StringToPChar(s:string):PChar;
var a:array[0..255] of char;
begin
StrPCopy(A, s);
StringToPChar:=a;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function isDir(s:string):boolean;
var F: file;
    Attr: Word;
begin
if (length(s)<>3)and(length(s)<>1) then if (s[length(s)]='\') then s:=Copy(s,1,length(s)-1);
Assign(F, s);
GetFAttr(F, Attr);
if DosError <> 0 then isDir:=false
                 else if Attr and faDirectory = 0 then isDir:=false
                                                  else isDir:=true;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function FreeChar(c,s:string):string;
var i,j:byte;
    ris:string;
begin
for i:=1 to length(c) do
      begin
      ris:='';
      for j:=1 to length(s) do
          if c[i]<>s[j] then ris:=ris+s[j];
      s:=ris;
      end;
FreeChar:=s;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function DeepDir(s:string):string;
var DirX: TSearchRec;
    i:byte;
    name,result:string;
label start;
begin
s:=UpStr(s);
if s[length(s)]='\' then result:=Copy(s,1,length(s)-1)
                    else result:=s;
case s[length(s)] of
     '\' : s:=s+'*.*';
     ':' : s:=s+'*.*';
     else  s:=s+'\*.*';
     end;

start:
FindFirst(StringToPChar(s), faDirectory, DirX);
if DosError=0 then
 for i:=1 to 3 do
     begin
     FindNext(DirX);
     name:=StrPas(dirX.name);{*** oppure name:=Copy(name,1,pos(#0,name)-1);}
     if (name<>'.')and(name<>'..')and(dirx.attr and faDirectory <>0) then
        begin
        s:=result+'\'+name+'\*.*';
        result:=result+'\'+name;
        goto start;
        end;
     end
    else result:='';
DeepDir:=result;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function GetEnvVarS(s:string):string;
var EnvironmentVar: PChar;
begin
EnvironmentVar:=GetEnvVar(stringtopchar(s));
if EnvironmentVar=nil  then GetEnvVarS:=''
                       else GetEnvVarS:=StrPas(EnvironmentVar);
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function NameOf(s:string):string;
var   Dir: array[0..fsDirectory] of Char;
      Name: array[0..fsFileName] of Char;
      Ext: array[0..fsExtension] of Char;
begin
FileSplit(StringToPchar(s), Dir, Name, Ext);
NameOf:=StrPas(name)+StrPas(ext);
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure FSplit(p:string; var d,n,e:string);
var Path: array[0..fsPathName] of Char;
    Dir: array[0..fsDirectory] of Char;
    Name: array[0..fsFileName] of Char;
    Ext: array[0..fsExtension] of Char;
begin
 FileSplit(stringtopchar(P), Dir, Name, Ext);
 d:=strpas(dir);
 n:=strpas(name);
 e:=strpas(ext);
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function PathOf(stringa:string):string;
var   Dir: array[0..fsDirectory] of Char;
      Name: array[0..fsFileName] of Char;
      Ext: array[0..fsExtension] of Char;
begin
FileSplit(StringToPchar(stringa), Dir, Name, Ext);
PathOf:=StrPas(Dir);
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function ValidName(s:string):byte;
var testa,coda:string;
    posto,posto1:integer;
    d,n,e:string;
begin
testa:=s;
if testa='' then
            begin
            ValidName:=1;
            Exit;
            end;
if testa[length(testa)]='.' then
   begin
   ValidName:=length(testa);
   Exit;
   end;
                     {controllo se il ':' e' valido}
posto:=CharReserved(testa[1]+Copy(testa,3,255),false);
if posto>1 then inc(posto);
if posto<>0 then
            begin
            ValidName:=posto;
            Exit;
            end;

{? e * non possono stare prima dell'ultimo \}
posto:=pos('?',testa);
if posto=0 then posto:=257;
posto1:=pos('*',testa);
if posto1=0 then posto1:=257;
posto:=Trunc(min(posto,posto1));
if posto<PosRL('\',testa,255) then
   begin
   ValidName:=posto;
   Exit;
   end;

if Copy(testa,2,1)=':' then      {controllo se il ':' e' valido}
   begin
   if Letters(testa[1])=false then
      begin
      ValidName:=1;
      Exit;
      end;
   testa:=Copy(testa,3,255);
   end;

posto:=pos('\\',testa);
if posto>0 then
   begin
   ValidName:=posto;
   Exit;
   end;

posto:=pos('...',testa);
if posto>0 then
   begin
   ValidName:=posto;
   Exit;
   end;

while (testa<>'') do
          begin
          Testa_Coda(testa,'\',testa,coda);
          if (testa[1]='\')and(testa<>'\') then testa:=Copy(testa,2,255);
          if testa='..' then
                        begin
                        testa:=coda;
                        Continue;
                        end;
          posto:=Conta('.',testa,1,true);
          if posto>1 then
             begin
             testa[pos('.',testa)]:='X';
             ValidName:=pos('.',testa);
             Exit;
             end;
          if (testa='') or NameReserved(testa) then
             begin
             ValidName:=Length(s)-length(coda)+1-length(testa);
             Exit;
             end;
          FSplit(testa, D, N, E);
          if ( (length(n)+length(e))<>length(testa) ) or
             not (length(n) in [1..8] ) or   {nella ver 32 bit e' un po' diversa, ma equivalente}
             not (length(e) in [0..4] ) then {controllo lunghezza nome.est}
              begin
              ValidName:=Length(s)-length(coda)+1-length(testa);
              Exit;
              end;
          testa:=coda;
          end;

ValidName:=0;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function NewDir(dir:string):integer;
var originaldir,testa,coda,thispath:string;
    creato,first:boolean;
    i:byte;
begin
i:=ValidName(dir);
if i>0 then
       begin
       NewDir:=i;
       Exit;
       end;
originaldir:=dir;
first:=true;
creato:=false;
GetDir(0,thispath);  {lo salvo per rispristinarlo dopo}
if length(dir)>1 then if dir[2]=':' then
   begin
   {$i-}
   ChDir(dir[1]+dir[2]);
   {$i+}
   if IOResult=0 then dir:=copy(dir,3,255)
                 else
                  begin
                  NewDir:=-1; { *** Unita' specificata non valida}
                  {$I-}
                  chdir(thispath);
                  {$I+}
                  if IOResult<>0 then ;
                  Exit;
                  end;
   end;
while (dir<>'') do
      begin
      Testa_Coda(dir,'\',dir,coda);
      if first then first:=false
               else dir:=copy(dir,2,255);
      {$i-}
      ChDir(dir);
      {$i+}
      if IOResult<>0 then
                     begin
                     if dir='..' then
                                 begin
                                 NewDir:=-2; { *** Percorso inesistente }
                                 {$I-}
                                 chdir(thispath);
                                 {$I+}
                                 if IOResult<>0 then ;
                                 Exit;
                                 end;
                     {$I-}
                     MkDir(dir);
                     {$I+}
                     if IOResult=0 then creato:=true else;
                     {$i-}
                     ChDir(dir);
                     {$i+}
                     if IOResult<>0 then
                                 begin
                                 NewDir:=-3; { *** Accesso negato }
                                 {$I-}
                                 chdir(thispath);
                                 {$I+}
                                 if IOResult<>0 then ;
                                 Exit;
                                 end;
                     end;
      dir:=coda;
      end;   {while}
if creato then NewDir:=0   { *** Directory Creata }
          else NewDir:=-4; { *** La directory esiste gia' }
{$I-}
chdir(thispath);
{$I+}
if IOResult<>0 then ;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function TmpFile(ilFile:string):string;
var tt1:string;

function TMP(t1:string):string;  {sottofunzione di TmpFile}
var p2,nome,estensione,risultato:string;
    valore:longint;
    punto:byte;

label riprova;

begin
valore:=-1;
if isDir(T1) then
   begin
   if t1[length(t1)]<>'\' then t1:=t1+'\';
   p2:=t1;
   t1:=t1+ilFile;
   if Exist(t1)=-1 then  {non esiste}
                   begin
                   Tmp:=t1;
                   Exit;
                   end
                  else   {esiste, devo cambiare nome}
                   begin
                   t1:=p2;
      riprova:     inc(valore);
                   if valore>99999999 then
                      begin
                      Tmp:='';
                      Exit;
                      end;
                   p2:=IntToStr(valore);
                   punto:=pos('.',ilFile);
                   if punto=0 then estensione:=''
                              else estensione:=Copy(ilFile,punto+1,3);
                   if punto=0 then nome:=ilFile
                              else nome:=Copy(ilFile,1,pos('.',ilFile)-1);
                   while length(nome)<8 do nome:=nome+'0';
                   nome:=Copy(nome,1,8-length(p2))+p2;
                   if estensione<>'' then risultato:=t1+nome+'.'+estensione
                                     else risultato:=t1+nome;
                   if Exist(risultato)=-1 then
                      begin
                      Tmp:=risultato;
                      Exit;
                      end
                     else goto riprova;
                   end;
   end
  else if NewDir(t1)=0 then
   begin
   if t1[length(t1)]<>'\' then t1:=t1+'\';
   Tmp:=t1+ilFile;
   Exit;
   end;
end;

begin    {codice di TmpFile}
tt1:='';
if (ilFile<>NameOf(ilFile))or(ValidName(ilFile)>0)or(pos('*',ilFile)<>0)or(pos('?',ilFile)<>0) then
   begin
   TmpFile:='';
   Exit;
   end;

if tt1='' then tt1:=TMP(StrPas(GetEnvVar(StringToPChar('TMP'))));
if tt1='' then tt1:=TMP(StrPas(GetEnvVar(StringToPChar('TEMP'))));
if tt1='' then
          begin
          GetDir(0,tt1);
          if tt1[length(tt1)]<>'\' then tt1:=tt1+'\';
          tt1:=TMP(tt1);
          end;
TmpFile:=tt1;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function DeleteFile(TmpFiles:string):boolean;
var tmp: file;
begin
assign(tmp,TmpFiles);
SetFAttr(tmp, faArchive);
{$I-}
Erase(tmp);
{$I+}
if IOResult <> 0 then DeleteFile:=false
                 else DeleteFile:=true;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function SubDir(path,tmpfile:string):byte;
var  DirInfo: TSearchRec;
     tmp: file of string;
     stringa,old_s:string;
     p_inizio:longint;
     l:byte;
begin
assign(tmp,tmpfile);
{$i-}
rewrite(tmp);
{$i+}
if IOResult<>0 then
               begin
               Subdir:=1;
               Exit;
               end;
if (path<>'')and((path[length(path)] in ['\',':'])=false) then path:=path+'\';
p_inizio:=0;
FindFirst(StringToPChar(path+'*.*'), faReadOnly+faHidden+faSysFile+faDirectory+faArchive, DirInfo);
while DosError = 0 do
      begin
      if (dirinfo.attr and fadirectory) =0 then
         begin
         FindNext(DirInfo);
         Continue;
         end;
      if (StrPas(dirinfo.name)='.')or(StrPas(dirinfo.name)='..') then
         begin
         FindNext(DirInfo);
         Continue;
         end;
      if (path<>'')and((path[length(path)] in ['\',':'])=false) then path:=path+'\';
      stringa:=path+StrPas(DirInfo.Name);
      {***SOLO PER DISGNOSTICA}
      while length(stringa)<255 do stringa:=stringa+#0;
      {$i-}
      Write(tmp,stringa);
      {$i+}
      if IOResult<>0 then
               begin
               Subdir:=1;
               Exit;
               end;
      FindNext(DirInfo);
      end;

while true do
      begin
      if KeyPressed then
            case readkey of
              #27: begin
                   Subdir:=2;
                   Exit;
                   end;
              #00: readkey;
            end;
      {$i-}
      Seek(tmp,p_inizio);
      {$i+}
      if IOResult<>0 then
               begin
               Subdir:=1;
               Exit;
               end;
      if EOF(tmp) then Break;
      inc(p_inizio);
      {$i-}
      read(tmp,stringa);
      {$i+}
      if IOResult<>0 then
               begin
               Subdir:=1;
               Exit;
               end;
      {***SOLO PER DISGNOSTICA}
      stringa:=FreeChar(#0,stringa);
      if (stringa<>'')and((stringa[length(stringa)] in ['\',':'])=false) then stringa:=stringa+'\';
      old_s:=stringa;
      FindFirst(StringToPChar(stringa+'*.*'), faReadOnly+faHidden+faSysFile+faDirectory+faArchive, DirInfo);
      while DosError = 0 do
            begin
            if (dirinfo.attr and fadirectory)=0 then
               begin
               FindNext(DirInfo);
               Continue;
               end;
            if (StrPas(dirinfo.name)='.')or(StrPas(dirinfo.name)='..') then
               begin
               FindNext(DirInfo);
               Continue;
               end;
            if (stringa<>'')and((stringa[length(stringa)] in ['\',':'])=false) then stringa:=stringa+'\';
            stringa:=old_s+StrPas(DirInfo.Name);
            {***SOLO PER DISGNOSTICA}
            while length(stringa)<255 do stringa:=stringa+#0;
            Seek(tmp,(FileSize(tmp)));
            {$i-}
            Write(tmp,stringa);
            {$i+}
            if IOResult<>0 then
               begin
               Subdir:=1;
               Exit;
               end;
            FindNext(DirInfo);
            end;
      end;
{$i-}
Close(tmp);
{$i+}
if IOResult<>0 then
               begin
               Subdir:=1;
               Exit;
               end;
Subdir:=0;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function ExpandEnvironment(s:string):string;
var old,new_str:string;
    p1,p2:byte;
    ss:pchar;
begin
old:=s;
repeat
 p1:=pos('%',s);
 if p1=0 then break;
 p2:=pos('%',copy(s,p1+1,255));
 p2:=p2+p1;
 if p1=p2 then break;
 new_str:=strpas(GetEnvVar(stringtopchar(copy(s,p1+1,p2-p1-1))));
 if new_str='' then break;
 s:=copy(s,1,p1-1)+new_str+copy(s,p2+1,255);
until false;
if pos('%',s)=0 then ExpandEnvironment:=s
                else ExpandEnvironment:=old;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function fexpand2(s:string):string;
var old,new_str:string;
    p1,p2:byte;
    ss:pchar;
begin
old:=s;
repeat
 p1:=pos('%',s);
 if p1=0 then break;
 p2:=pos('%',copy(s,p1+1,255));
 p2:=p2+p1;
 if p1=p2 then break;
 new_str:=strpas(GetEnvVar(stringtopchar(copy(s,p1+1,p2-p1-1))));
 if new_str='' then break;
 s:=copy(s,1,p1-1)+new_str+copy(s,p2+1,255);
until false;
if pos('%',s)=0 then
                begin
                ss:=stringtopchar(s);
                fileexpand(ss,ss);
                fexpand2:=strpas(ss);
                end
               else fexpand2:=old;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function contaDirFile(s:string):longint;
var DirInfo: TSearchRec;
    tot:longint;

begin
s:=fexpand2(s);
if isDir(s)=false then
                  begin
                  contaDirFile:=-1;
                  Exit;
                  end;
if s[length(s)]<>'\' then s:=s+'\';
s:=s+'*.*';
tot:=0;
FindFirst(stringtopchar(s), faArchive + faReadOnly + faSysFile + faHidden + faDirectory + faAnyfile, DirInfo);
while DosError = 0 do
      begin
      if (StrPas(dirinfo.name)<>'.')and(StrPas(dirinfo.name)<>'..') then inc(tot);
      FindNext(DirInfo);
      end;
contadirfile:=tot;
end;

{++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function contaDir(s:string):longint;
var DirInfo: TSearchRec;
    tot:longint;

begin
s:=fexpand2(s);
if isDir(s)=false then
                  begin
                  contadir:=-1;
                  Exit;
                  end;
if s[length(s)]<>'\' then s:=s+'\';
s:=s+'*.*';
tot:=0;
FindFirst(stringtopchar(s), faArchive + faReadOnly + faSysFile + faHidden + faDirectory + faAnyfile, DirInfo);
while DosError = 0 do
      begin
      if (StrPas(dirinfo.name)<>'.')and(StrPas(dirinfo.name)<>'..')and(dirinfo.attr and fadirectory <>0) then inc(tot);
      FindNext(DirInfo);
      end;
contadir:=tot;
end;

{++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function contaFile(s:string):longint;
var DirInfo: TSearchRec;
    tot:longint;

begin
s:=fexpand2(s);
if isDir(s)=false then
                  begin
                  contafile:=-1;
                  Exit;
                  end;
if s[length(s)]<>'\' then s:=s+'\';
s:=s+'*.*';
tot:=0;
FindFirst(stringtopchar(s), faArchive + faReadOnly + faSysFile + faHidden + faDirectory + faAnyfile, DirInfo);
while DosError = 0 do
      begin
      if (StrPas(dirinfo.name)<>'.')and(StrPas(dirinfo.name)<>'..')and(dirinfo.attr and fadirectory =0) then inc(tot);
      FindNext(DirInfo);
      end;
contaFile:=tot;
end;

{++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure setlength(var s:string; n:byte);
begin
s[0]:=char(n);
end;

{++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function UnderDos:boolean;
begin
underdos:=true;
end;

{++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function UnderWin:boolean;
begin
underWin:=false;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function ValidNameDos(s:string):byte;
begin
ValidNameDos:=ValidName(s);
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function ValidNameWin(s:string):byte;
begin
ValidNameWin:=ValidName(s);
end;

{++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function LastMode:byte;
begin
lastmode:=3;
end;

{++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure TextMode(x:byte);
begin
end;

{++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure textcolor(x:byte);
begin
end;

{++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure textbackground(x:byte);
begin
end;

{++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure nosound;
begin
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure Sound(Hz: Word);
begin
end;

{++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function ChangeFileExt(const FileName, Extension: string): string;
var i: longint;
begin
I := Length(FileName);
while (I > 0) and not(FileName[I] in ['/', '\', ':']) do Dec(I);
if (I = 0) or (FileName[I] <> '') then I := 256;
ChangeFileExt:= Copy(FileName, 1, I - 1) + Extension;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function contaThis(path,nome:string):longint;
var DirInfo: TSearchRec;
    tot:longint;
begin
path:=fexpand2(path);
if isDir(path)=false then
                  begin
                  contaThis:=-1;
                  Exit;
                  end;
if path[length(path)]<>'\' then path:=path+'\';
path:=path+nome;
tot:=0;
FindFirst(stringtopchar(path), faArchive + faReadOnly + faSysFile + faHidden + faDirectory + faAnyfile, DirInfo);
while DosError = 0 do
      begin
      if (StrPas(dirinfo.name)<>'.')and(StrPas(dirinfo.name)<>'..') then inc(tot);
      FindNext(DirInfo);
      end;
contathis:=tot;
end;

{++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function getshortname(var s:string):boolean;
begin
getshortname:=false;
end;

{++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function getlongname(var s:string):boolean;
begin
getlongname:=false;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function Attr(s:string):string;
var F: SearchRec;
begin
if s[length(s)]='\' then s:=copy(s,1,length(s)-1);
FindFirst(stringtopchar(s), Anyfile, F);
if (doserror<>0) then
   begin
   attr:='';
   Exit;
   end;
s:='';
if (f.attr and archive)  <>0 then s:='A'     else s:='_';
if (f.attr and readonly) <>0 then s:=s+'R' else s:=s+'_';
if (f.attr and hidden)   <>0 then s:=s+'H' else s:=s+'_';
if (f.attr and sysfile)  <>0 then s:=s+'S' else s:=s+'_';
if (f.attr and directory)<>0 then s:=s+'D' else s:=s+'_';
attr:=s;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

end.

Versione:    Data:     Righe:  Modifica:

1.075.011  29/09/02     1675   Conta dir_file;
1.075.010  04/07/02     1598   ExpandEnvironment;
1.074.009  28/02/02     1580   FExpand2;
1.073.008  08/02/01     1525   DestroyF,Subdir;
1.071.007  04/02/01     1320   TempFile;
1.070.006  04/01/01     1262   NewDir;
1.069.005  02/01/01     1173   ValidName;
1.068.004  14/12/00     1116   PathOf + NameOf
1.066.003  18/08/00     1109   GetEnvVarS
1.065.002  13/08/00     1095   FreeChar + DeepDir
1.063.001  12/08/00     1038   inizio + FSplitW + StringToPChar.


