unit Menu_Y;

interface

{$ifdef BP7}
uses crt, altro;
{$endif}
{$ifdef FP}
uses crt,mouse,math, altro32;
{$endif}

type   MenuLista_Y=object
        x,y,error,bk_color,txt_ColorCornice,txt_ColorRiga,txt_ColorRigaSelezionata,
        selezionato,bk_selezione,txt_ColorVeloce:byte;
        controllo{ se la finestra entra nel monitor },topo,tastiera:boolean;
        constructor init;
        destructor  destroy;
        procedure   Assegna(var N:MenuLista_Y);
        function    NuovaRiga(testo:string; tasto:byte):byte;  {torna la posizione dove inserito}
        function    Costruisci:byte; { ritorna la riga selezionata }
       end;

implementation

type tipo=record
          nome:string;
          Tasto:byte;
          end;

const num=48;

var lista:array [1..num] of tipo;
    mox,moy,tasto,maxl,old_selezionato,elementi,old_mox,old_moy:byte;
    empty:boolean;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure MenuLista_Y.Assegna(var N:MenuLista_Y);
var i:byte;
begin
n.init;
N.txt_ColorRigaSelezionata:=txt_ColorRigaSelezionata;
N.txt_ColorVeloce:=txt_ColorVeloce;
N.bk_selezione:=bk_selezione;
N.controllo:=controllo;
N.error:=error;
N.selezionato:=selezionato;
N.bk_color:=bk_color;
N.txt_ColorCornice:=txt_ColorCornice;
N.txt_ColorRiga:=txt_ColorRiga;
N.x:=x;
N.y:=y;
N.tastiera:=tastiera;
N.topo:=topo;
for i:=1 to elementi do N.NuovaRiga(lista[i].nome, lista[i].tasto);
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function MenuLista_Y.NuovaRiga(testo:string; tasto:byte):byte;  {torna la posizione dove inserito}
begin
if elementi=num then
   begin
   NuovaRiga:=0;
   Error:=1;
   exit;
   end;
inc(elementi);
lista[elementi].nome:=testo;
lista[elementi].Tasto:=tasto;
NuovaRiga:=elementi;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

constructor MenuLista_Y.init;
var i:byte;
begin
txt_ColorRigaSelezionata:=15;
txt_ColorVeloce:=15;
bk_selezione:=0;
controllo:=false;
elementi:=0;
error:=0;
selezionato:=0;
bk_color:=black;
txt_ColorCornice:=7;
txt_ColorRiga:=7;
x:=1;
y:=1;
tastiera:=true;
topo:=true;
for i:=1 to num do
    begin
    lista[i].nome:='';
    lista[i].Tasto:=0;
    end;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

destructor MenuLista_Y.destroy;
begin
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure writeColor(s:string; txt_ColorRiga,txt_ColorRigaSelezionata,txt_ColorVeloce,elemento:byte);
var i:byte;
begin
hidemouse;
i:=pos(char(lista[elemento].tasto),s);
if elemento=old_selezionato then textcolor(txt_ColorRiga)
                            else textcolor(txt_ColorRigaSelezionata);
write(copy(s,1,i-1));
if i>0 then
   begin
   if i>0 then textcolor(txt_ColorVeloce);
   write(copy(s,i,1));
   end;
if elemento=old_selezionato then textcolor(txt_ColorRiga)
                            else textcolor(txt_ColorRigaSelezionata);
write(copy(s,i+1,255));
showmouse;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure stampa_selezionato(x,y,selezionato,bk_color,bk_selezione,
                             txt_ColorRiga,txt_ColorRigaSelezionata,txt_ColorVeloce:byte);
var s:string;
begin
hidemouse;
if old_selezionato=selezionato then
   begin
   showmouse;
   Exit;
   end;
if old_selezionato>0 then
   begin
   gotoxy(x+1,y+old_selezionato);
   textbackground(bk_color);
   s:=lista[old_selezionato].nome;
   while length(s)<>maxl do s:=s+' ';
   writeColor(s,txt_ColorRiga,txt_ColorRigaSelezionata,txt_ColorVeloce,old_selezionato);
   end;
textcolor(txt_ColorRigaSelezionata);
gotoxy(x+1,y+selezionato);
textbackground(bk_Selezione);
s:=lista[selezionato].nome;
while length(s)<>maxl do s:=s+' ';
writeColor(s,txt_ColorRiga,txt_ColorRigaSelezionata,txt_ColorVeloce,selezionato);
showmouse;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function Dimensioni(x2,y2:byte):byte;
var x,y:byte;
begin
x:=GetTextMaxX;
y:=GetTextMaxY;
if y2+elementi+1>y then Dimensioni:=12 else
if x2+maxl+1>x then Dimensioni:=12 else
if (x2+maxl+1=x)and(y2+elementi+1=y) then dimensioni:=12 else dimensioni:=0;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function MenuLista_Y.Costruisci:byte;
var i,j:byte;
    s:string;
    c:char;
begin
hidemouse;
if (not tastiera) and (not topo) then
   begin
   Error:=2;
   RunError(201);
   exit;
   end;
if elementi=0 then
   begin
   error:=3;
   RunError(201);
   exit;
   end;
if (selezionato>elementi) then
   begin
   Error:=4;
   RunError(201);
   Exit;
   end;
for i:=1 to elementi do
    for j:=1 to length(lista[i].nome) do
        if lista[i].nome[j]<#32 then
                                begin
                                Error:=6;
                                RunError(201);
                                Exit;
                                end;
old_selezionato:=0;
old_mox:=x+1;
old_moy:=y+1;
maxl:=0;
empty:=true;
for i:=1 to elementi do
    begin
    maxL:=trunc(max(length(lista[i].nome),maxl));
    if not (char(lista[i].tasto) in ['0'..'9','a'..'z','A'..'Z',#1,#27]) then
                 begin
                 Error:=10;
                 RunError(201);
                 Exit;
                 end;
    for j:=1 to length(lista[i].nome) do
        begin
        if lista[i].nome[j]<#32 then
                               begin
                               Error:=6;
                               RunError(201);
                               Exit;
                               end;
        empty:=empty and (lista[i].nome='');
        end;
    end;
if empty then
   begin
   Error:=8;
   RunError(201);
   Exit;
   end;
if selezionato=0 then
   for i:=1 to elementi do
       if lista[i].nome<>'' then
          begin
          selezionato:=i;
          break;
          end;
if controllo then
   begin
   Error:=dimensioni(x,y);
   if Error<>0 then
      begin
      RunError(201);
      Exit;
      end;
   end;
Textbackground(bk_color);
cursorOff;
gotoxy(x,y);
s:='';
for i:=1 to maxl do s:=s+'';
textcolor(txt_ColorCornice);
write(''+s+'');
for i:=1 to elementi do
    begin
    gotoxy(x,y+i);
    if lista[i].nome<>'' then
        begin
        textcolor(txt_ColorCornice);
        write('');
        s:=lista[i].nome;
        while length(s)<>maxl do s:=s+' ';
        old_selezionato:=i;
        writeColor(s,txt_ColorRiga,txt_ColorRigaSelezionata,txt_ColorVeloce,i);
        textcolor(txt_ColorCornice);
        write('');
        end
       else
        begin
        s:=lista[i].nome;
        while length(s)<>maxl do s:=s+'';
        textcolor(txt_ColorCornice);
        write(''+s+'');
        end;
    end;
gotoxy(x,y+elementi+1);
s:='';
for i:=1 to maxl do s:=s+'';
write(''+s+'');
showmouse;
stampa_selezionato(x,y,selezionato,bk_color,bk_selezione,txt_ColorRiga,txt_ColorRigaSelezionata,txt_ColorVeloce);
repeat
 if keypressed or not topo then
     begin
     c:=readkey;
     case ord(c) of
         13,32:
             begin
             Costruisci:=selezionato;
             Exit;
             end;
         27: begin
             Costruisci:=0;
             Exit;
             end;
          0: begin
             c:=readkey;
             case ord(c) of
                  80: begin { freccia giu' }
                      old_selezionato:=selezionato;
                      repeat
                       if selezionato<elementi then inc(selezionato)
                                               else selezionato:=1;
                      until lista[selezionato].nome<>'';
                      stampa_selezionato(x,y,selezionato,bk_color,bk_selezione,txt_ColorRiga,
                                         txt_ColorRigaSelezionata,txt_ColorVeloce);
                      end;
                  72: begin { freccia su }
                      old_selezionato:=selezionato;
                      repeat
                       if selezionato>1 then dec(selezionato)
                                        else selezionato:=elementi;
                      until lista[selezionato].nome<>'';
                      stampa_selezionato(x,y,selezionato,bk_color,bk_selezione,txt_ColorRiga,
                                         txt_ColorRigaSelezionata,txt_ColorVeloce);
                      end;
                   else
                    for i:=1 to elementi do { ho premuto un tasto alt+selezionato? quale? }
                        if (lista[i].Tasto=ord(from_alt_to_char(ord(c)))) and (lista[i].Tasto<>1) then
                                       begin
                                       costruisci:=i;
                                       exit;
                                       end;
                  end;
             end
          else
           for i:=1 to elementi do { ho premuto un tasto selezionato? quale? }
               if upcase(char(lista[i].Tasto))=upcase(c) then
                                      begin
                                      costruisci:=i;
                                      exit;
                                      end;
          end;
     end
    else
     begin
     Rilascio(mox,moy,tasto); {restituisce rilascio del mouse in mox,moy,tasto}
     if tasto=1 then
        for i:=1 to elementi do
            if (mox>x)and(mox<=x+maxl)and(moy>y)and(moy<=y+elementi) then
                begin
                i:=moy-y;
                if lista[i].nome='' then i:=0;
                Costruisci:=i;
                Exit;
                end
               else
                begin
                Costruisci:=0; { ho cliccato fuori dalla lista }
                Exit;
                end;
     if tasto=0 then
                begin { mouse spostato }
                click(mox,moy,tasto); {restituisce il click del mouse in mox,moy,tasto}
                if (mox<>old_mox)or(moy<>old_moy) then
                       begin
                       old_mox:=mox;
                       old_moy:=moy;
                       if moy>y then i:=moy-y
                                else i:=0;
                       if (i>0)and(lista[i].nome<>'')and(i<>selezionato)and(mox>x)and(mox<=x+maxl) then
                           begin
                           old_selezionato:=selezionato;
                           selezionato:=i;
                           stampa_selezionato(x,y,selezionato,bk_color,bk_selezione,txt_ColorRiga,
                                              txt_ColorRigaSelezionata,txt_ColorVeloce);
                           end;
                       end;
                end;
     end;
until false;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

begin
end.


 Error
   0  : nesssun errore
   1  : troppe righe inserite
   2  : tastiera e mouse disabilitati (*)
   3  : 0 elementi (*)
   4  : elemento selezionato non valido (*)
   5  :
   6  : il nome della riga contiene caratteri non validi (<#32) (*)
   7  :
   8  : righe tutte vuote (*)
   10 : tasto di scalta rapido non compreso tra  a..z  o  A..Z, #27, #1 (non assegnato) (*)
   12 : se la finestra non entra nel monitor (*)
(*)  quando chiamo il metodo Costruisci
