unit ALTRO;  { Unit con particolari funzioni e procedure a 16 bit}

interface

 uses Crt,Windos,Dos,Strings;

const invio=#13+#10;
      os_prog='DOS';
      bit=16;

          {***FILE***}
function Attr(s:string):string;
function getshortname(var s:string):boolean;
function getlongname(var s:string):boolean;
function ChangeFileExt(const FileName, Extension: string): string;
function underdos:boolean;
function underwin:boolean;
function contaThis(path,nome:string):longint;
function contaDirFile(s:string):longint;
function contaDir(s:string):longint;
function contaFile(s:string):longint;
  { tornano rispettivamente quanti file e directory, directory, files
    ci sono in una directory, -1 se non e' una directory}
function SubDir(path,tmpfiles:string):byte;
  { data una directory, crea nel file tmpfiles la struttura delle
    sottodirectory della directory indicata sottoforma di stringhe.
    Le stringhe sono di 256 caratteri, i caratteri che non appartengono alle
    sottodirectory sono il carattere di ordinata 0.
    Torna: 0= (sovra) scrittura avvenuta con successo
           1= scrittura su file fallita
           2= operazione interrotta dall'utente
   il file non viene cancellato se la funzione torna 1 o 2.
   Se il file e' vuoto, significa che non ci sono sottodirectori, o non
   esiste quella indicata }
function  DeleteFile(TmpFiles:string):boolean;
  { cancella il file indicato: se lo cancella torna true, se non c'era o non
    puo' cancellarlo torna il valore false}
function  TmpFile(ilFile:string):string;
  { torna il percorso+nome del file temporaneo, guarda le variabili d'ambiente }
function  NewDir(dir:string):integer;
  { crea una directory e sottodirectory }
function  ValidNameDos(s:string):byte;
function  ValidNameWin(s:string):byte;
function  ValidName(s:string):byte;
  { torna 0 se il nome del file (path opzionale) e' valido, altrimenti
    la posizione dove inizia l'errore }
function  TruncPath(str:string; Max:byte):string;
  { dato percorso e/o nomefile , ed una lunghezza massima, ne restituisce
    l'equivalente abrreviato con  U:\...\?????????? o lo stesso se non e'
    possibile abbreviarlo }
function  PathOf(stringa:string):string;
  { dato un cammino, restituisce il percorso senza file: finira' con : o \}
function  NameOf(s:string):string;
  { dato un cammino, restituisce il file senza percorso }
function  Exist(nome:string):longint;
  { controlla se esiste un path+file non accetta caratteri jolli (*,?) .
    Se non esiste ritorna -1, altrimenti la dimensione del file }
function  NameReserved(str:string):boolean;
  { data una stringa indica se e' lecita usarla come nome di file: il nome
    potrebbe essere riservato al DOS. Torna true se e' riservata,
    altrimenti false }
function  CharReserved(s:string; jolly:boolean):byte;
  { data una stringa indica se e' lecita usarla come nome di file: il nome
    potrebbe contenere caratteri riservati al DOS. Torna la posizione del
    carattere se e' ve ne e',altrimenti 0. Jolly indica se considerare anche
    ? e * come riservati.
    Caratteri riservati: ,;=+ /:|<>" e  0..32 }
function  CharDriver(s:string):char;
  { data una stringa ne torna il driver se valido, altrimenti il carattere 0 }
function  NumDriver(s:string):byte;
  { data una stringa ne torna il numero del driver se valido, altrimenti 255 }
function  DirEmpty(s:string):boolean;
  { data una stringa, torna true se l'equivalente della directory e' vuota,
    false se non lo e' o non esiste }
function  isDir(s:string):boolean;
  { data una stringa, torna true se l'equivalente della directory esiste,
    false se non c'e' o non lo e' }
function  DeepDir(s:string):string;
  { data una stringa come directory, torna stringa vuota se non era o non
    esisteva come directory, altrimenti restituisce un cammino in profondita'
    (non e' detto che sia il piu' lungo) }
function ExpandEnvironment(s:string):string;
  { converte le variabili d'ambiente di un percorso, senza espanderlo, se tutte
    corrette ( %xxx% ) }
function  fexpand2(s:string):string;
  { come FExpand, ma converte pure le variabili d'ambiente se tutte corrette
    ( %xxx% ) }

          {***STRINGHE e NUMERI***}
procedure setlength(var s:string; n:byte);
procedure Reverse(var str:string);
procedure ExchangeChar(var a,b:char);
procedure ExchangeByte(var a,b:byte);
procedure ExchangeInteger(var a,b:integer);
procedure ExchangeLongint(var a,b:longint);
procedure ExchangeStr(var s1,s2:string);
procedure Testa_Coda(str,ins:string; var testa,coda:string);
function  StringToPChar(s:string):PChar;
function  FreeChar(c,s:string):string;
function  Bool(b:boolean):byte; {torna 1 se b=true, 0 se b=false}
function  Union(s1,s2:string):string;
function  Intersection(s1,s2:string):string;
function  Single(str:string):string; {toglie i caratteri ripetuti}
function  fDelete(Str: String; Index,Count:Integer):string; {come il delete}
function  Dim_Punto(num:longint):string; {raggruppa le cifre a 3 a 3}
function  IntToStr(I: Longint): String;  {Converte da intero a stringa}
function  ToByte(L:longint):byte;       {casting da integer o longint a byte }
function  ToLongint(x:integer):Longint; {casting da byte o integer a longint}
function  FromTo(oldV:string; oldB,newB:byte):string;{newV} {converte da base a base (2..16)}
function  ToDecimal(num:string; oldBase:byte):string; {converte da base 2..16 a decimale}
function  DecimalTo(numdec:longint; newBase:byte):string; {converte da decimale a base 2..16 (maiuscolo)}
function  fReverse(str:string):string;   {inverte una stringa}
function  noSpaceR(str:string):string;   {toglie gli spazi finali (a destra)}
function  noSpaceL(str:string):string;   {toglie spazi iniziali (a sinistra)}
function  LowStr(str:string):string;     {stringa tutta minuscola}
function  UpStr(str:string):string;      {stringa tutta maiuscola}
function  PosRL(sub,str:string; start:byte):byte;     { cerca una stringa partendo da start da DS }
function  Conta(str,stringa:string; start:byte; b:boolean):byte;
  { conta quante volte str compare in stringa a partire da start, se b=true a destra di start,
    altrimenti a sinistra }
function  CopyRL(str :string; start,count:integer):string; { copia da D verso S }
function  SostituisciLR(n:byte; sub,str,stringa:string):string; { da sinistra
    verso destra, sostituisce l' n-sima stringa sub, con str nella stringa }
function  SostituisciRL(n:byte; sub,str,stringa:string):string;
  { da destra verso sinistra, sostituisce l' n-sima stringa sub, con str nella stringa }
function  Digits(c:char):boolean; {torna true se il carattere e' un numero}
function  Letters(c:char):boolean;{torna true se il carattere e' una lettera}
function  PosStart(sub,s:string; start:byte):byte;   {cerca una stringa partendo da start}
function  PosJolly(sub,str:string; start:byte):byte; {cerca una stringa jolly partendo da start SD}
function  PosJollyRL(sub,str:string; start:byte):byte;{cerca una stringa jolly partendo da start da DS}
function  GetEnvVarS(s:string):string; { restituisce le impostazioni di una variabile d' ambiente }
function  ReadString(stringa:string; Xstart,Xtot,status:byte; topo,avanzate:boolean;
                     var ins:boolean;  var lastD,lastU,posto:byte):string;
function  ReadString2(stringa:string; Xstart,Xtot,status:byte; topo,avanzate:boolean;
                     var ins:boolean; var lastD,lastU,cursore_,x_:byte):string;
  { stringa in input }

          {***TEMPO***}
procedure Delay2(tempo:longint); {ritardo in centesimi di secondo reali}
function  Time100:longint;       {restituisce il tempo attuale in centesimi}

          {***COLORI***}
function  BackColor:byte;  {indica il colore di background nella pos attuale}
function  TxtColor:byte;   {indica il colore di textcolor nella pos attuale}
function  Lamp:boolean;    {indica se c' e' il lampeggio nella pos attuale}
function  BackColorXY(x,y:byte):byte; {indica il background dove indicato}
function  TxtColorXY(x,y:byte):byte;  {indica il textcolor dove indicato}
function  LampXY(x,y:byte):boolean;   {indica il lampeggio dove indicato}

          {***CARATTERI***}
function  Char_Video:char;      {indica il carattere nella pos attuale}
function  Char_VideoXY(x,y:byte):char; {torna il carattere dove indicato}
function  LowCase(c:char):char; {da maiuscolo a minuscolo}
function  GetTextMaxY:word;
function  GetTextMaxX:word;

          {***MOUSE***}
procedure Setto_Pos_Mouse(x,y:word);
procedure Rilascio(var mox,moy,tasto:byte); {restituisce rilascio del mouse in mox,moy,tasto}
procedure Click(var mox,moy,tasto:byte);    {restituisce il click del mouse in mox,moy,tasto}
procedure ShowMouse;   {visualizza il mouse}
procedure HideMouse;   {scompare il mouse}
function  Mouse_Presente:boolean; {True se il gestore del mouse e' presente}

          {***TASTIERA***}
{ function  Tasti_Speciali:byte;   per shift,ctrl.alt...
  da non interfacciare esternamente }
function  Alt:boolean;           {true se Alt premuto}
function  Shift:boolean;         {true se Shift premuto}
function  Ctrl:boolean;          {true se Ctrl premuto}
function  from_alt_to_char(b:byte):char;
procedure Tast_Vuota;            {svuota il buffer della tastiera}
procedure CursorOn;              {dimensione del cursore normale}
procedure CursorOff;             {cursore assente}
procedure CursorBig;             {cursore grande}
procedure keyspeed(delay,rate:byte);

          {***MATEMETICA***}
procedure Eleva(base,esponente:real; var potenza:real; var err:byte);
function  IsInt(X: real): boolean;  {Torna vero se il numero e' un intero es: 4,000000000000}
function  TAN (angle: real): real;  {tangente in radianti}
function  COTAN (angle: real):real; {cotangente in radianti}
function  SIGN (R: real): real;     {ritorna -1 se R<0, 0 se R=0, o 1 se R>0.}
function  FACT (n: integer): real;  {Ritorna il fattoriale di un numero tra 0..33, -1 altrimenti}
function  DegToRad(gr:real):real;   {converte da gradi a radianti}
function  RadToDeg(rad:real):real;  {converte da radianti a gradi}
function  Max(a,b:real):real;       {torna il Max fra 2 numeri reali}
function  Min(a,b:real):real;       {torna il Min fra 2 numeri reali}

implementation

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function Time100:longint;     {restituisce il tempo attuale in centesimi}
var h,m,s,cs:word;
begin
GetTime(h,m,s,cs);
Time100:=(h*60*60+m*60+s)*100+cs;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure keyspeed(delay,rate:byte);
begin
asm
 mov ah,03
 mov al,05
 mov bh,delay  { delay ritardo }
 mov bl,rate   { rate  frequenza }
 int 16h
 end;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure Delay2(tempo:longint);      {ritardo in centesimi di secondo}
var tempo_inizio:longint;
begin
 tempo_inizio:=time100;
 repeat until abs(Time100-tempo_inizio)>tempo;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure Setto_Pos_Mouse(x,y:word);
begin
 asm
  mov ax,04       {setto pos mouse}
  mov cx,x   {X}
  mov dx,y   {Y}
  int 33h
  end;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function Char_Video:char;
var k:char;
begin
asm
 mov ah,08
 mov bh,0   {pagina}
 int 10h            {   al:carattere / ah:attributi
                                       4;  colore di foreground
                                       3;  colore di background
                                       1;  lampeggio}
 mov K,al
 end;
Char_Video:=char(K);
end;


{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function Dim_Punto(num:longint):string;
var numero,numero1:string[30];
    i,pos:byte;
    negativo:boolean;
begin
pos:=0;
numero1:='';
if num<0 then
         begin
         negativo:=true;
         num:=-num;
         end
        else negativo:=false;
str(num,numero);
for i:=length(numero) downto 1 do
    begin
    inc(pos);
    numero1:=numero1+numero[i];
    if (pos mod 3 =0)and(pos<>length(numero)) then numero1:=numero1+ '.';
    end;
if negativo then dim_punto:='-'+fReverse(numero1)
            else dim_punto:=fReverse(numero1);
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function DecimalTo(numdec:longint; newBase:byte):string;
var s:string;           {converte da decimale a base 2..16 (maiuscolo)}
    v:byte;             {se la base e' errata torna stringa vuota}
    c:char;
    neg:boolean;
begin
if (newBase>16)or(newBase<2) then
      begin
      DecimalTo:='';
      Exit;
      end;
s:='';
if numdec<0 then
    begin
    neg:=true;
    numdec:=-numdec;
    end
   else neg:=false;
repeat
 v:=numdec mod newBase;
 numdec:=numdec div newBase;
 case v of
   10: c:='A';
   11: c:='B';
   12: c:='C';
   13: c:='D';
   14: c:='E';
   15: c:='F';
   else c:=char(v+48);
 end;
 s:=c+s;
until numdec=0;
if neg then s:='-'+s;
DecimalTo:=s;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function Lamp:boolean; {lampeggio: il bit n 7 (8) di AH}
var lamp_:byte;
begin
asm
 mov ah,08
 mov bh,0   {pagina}
 int 10h

 mov lamp_,ah
 {Shr lamp_,7   richiede 80286   shr/l: Shift destra/sinistra}
 end;
if lamp_ div 128 {2^7}=1 then lamp:=true
                         else lamp:=false;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function TxtColor:byte;  {foreground 0..15= i primi 4 bit di AH bit0,1,2,3}
var attF:byte;
begin
asm
 mov ah,08
 mov bh,0   {pagina}
 int 10h

 mov attF,ah
{ Shl attF,4
  Shr attF,4   richiede 80286 }
 end;          {mod 16, oppure 15 che e' la maschera}
Txtcolor:=attF and 15;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function BackColor:byte;   {background 0..7: i bit 4,5,6 di AH (5,6,7) }
var attB:byte;
begin
asm
 mov ah,08
 mov bh,0        {pagina}
 int 10h

 mov attB,ah
 {Shr attB,4    richiede 80286 }
 end;     {tolgo lamp / tolgo txtcolor}
Backcolor:=(attB and 127 {127=maschera, o mod 128}) div 16;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure Click(var mox,moy,tasto:byte);
var reg:registers;
begin               {640 X 200 = 80*8 X 25*8}
reg.ax:=3;
intr($33,reg);      {bx=1: S,  bx=2: D,  bx=4: C}
mox:=(reg.cx div 8) +1;
moy:=(reg.dx div 8) +1;
tasto:=reg.bx;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure Rilascio(var mox,moy,tasto:byte);
var y,x,b:integer;
begin
 asm
  mov bx,0     {in:    bx=0: S,  bx=1: D,  bx=2: C}
  mov ax,6
  int 33h
  mov y,dx    {Y}
  mov x,cx    {X}
  mov b,bx    { bx=1: rilascio sinistra / bx=2: rilascio destra / bx=4: rilascio centro}
  end;
moy:=y div 8 +1;
mox:=x div 8 +1;
tasto:=b;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure ShowMouse;  {ripristino mouse}
var reg:registers;
begin
reg.ax:=1;    {lasciarlo anche se e' ripetitivo}
intr($33,reg);
reg.ax:=2; {scompare mouse}
intr($33,reg);
reg.ax:=1; {compare mouse}
intr($33,reg);
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function Mouse_Presente:boolean;
var a:integer;
begin
asm
 mov ax,0
 int 33h
 mov a,ax {se ax=-1: gestore mouse presente / se ax=0: gestore mouse assente}
 end;
if a=-1 then mouse_presente:=true
        else mouse_presente:=false;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure Cursore(status:byte);   {status=0 : scompare il cursore}
var alto,basso:byte;              {status=1 : cursore normale}
begin                             {status=2 : cursore grosso (inserito) (tasto insert premuto)}
if status>2 then status:=1;       {status>2 == status=1 : cursore normale}
case status of
     0 : alto:=7;
     1 : alto:=6;
     2 : alto:=0;
     end;
case status of
     0 : basso:=0;
     1 : basso:=7;
     2 : basso:=7;
     end;
asm
 mov ah,01h
 mov ch,alto
 mov cl,basso
 int 10h
 end;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure CursorOff;
begin
cursore(0);
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure CursorBig;
begin
cursore(2);
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure CursorOn;
begin
cursore(1);
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function fReverse(str:string):string;
var s2:string;
    l,i:byte;
begin
l:=length(str);
s2[0]:=str[0];
for i:=1 to L do s2[i]:=str[l-i+1];
fReverse:=s2;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure Tast_Vuota;     {svuota il buffer della tastiera}
begin
while KeyPressed do ReadKey;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function Tasti_Speciali:byte;   {per shift,ctrl.alt...}
var valore:byte;
begin
asm
  mov ah,2h
  int 16h
  mov valore,al
  end;
Tasti_Speciali:=valore;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure HideMouse;
begin
 asm
  mov ax,2
  int 33h
  end;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function Shift:boolean;
var tasti:byte;
begin
tasti:=Tasti_Speciali;
Shift:=false;
if (tasti and 1 <>0)or(tasti and 2 <>0) then Shift:=true;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function Exist(nome:string):longint;  {1.1}
var DirInfo: SearchRec;
begin
Exist:=-1;   {non esiste}
if (nome[length(nome)]='.') then Exit;
if ( Pos('*',nome)<>0 ) or (Pos('?',nome)<>0) then Exit;
FindFirst(nome ,ReadOnly + Archive + Sysfile + Hidden + Anyfile, DirInfo);
if DosError = 0 then Exist:=DirInfo.Size;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure Eleva(base,esponente:real; var potenza:real; var err:byte);
begin             { b^x = e^( Ln (b^x) ) = e^( x Ln b ) }
if base=0 then Err:=1;            {Valori per Err:             }
if base>0 then                             { 1:   Base = 0     }
     begin                                 { 2:   Esponente <0 }
     if esponente<0 then err:=2;           { 3:   Base <0 , Esponente >0 }
     potenza:=exp(esponente*ln(base));     { 4:   Base <0 , Esponente <0 }
     end;
if (base<0) and (esponente>0) then err:=3;
if (base<0) and (esponente<0) then err:=4;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function LowCase(c:char):char; {da maiuscolo a minuscolo}
begin
if c in ['A'..'Z'] then LowCase:=char(ord(c)+32)
                   else LowCase:=c;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function noSpaceR(str:string):string;   {toglie gli spazi finali (a destra)}
var tot,i:byte;
begin
tot:=0;
for i:=length(str) downto 1 do
      if str[i] in [' ',#9] then inc(tot)
                            else Break;
str[0]:=char(ord(str[0])-tot);
noSpaceR:=str;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function noSpaceL(str:string):string; {toglie spazi iniziali (a sinistra)}
var tot,i:byte;
begin
tot:=0;
for i:=1 to length(str) do
      if str[i] in [' ',#9] then inc(tot)
                            else Break;
noSpaceL:=copy(str,tot+1,length(str)-tot);
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function UpStr(str:string):string;
var i:byte;
begin
for i:=1 to length(str) do str[i]:=UpCase(str[i]);
UpStr:=str;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function LowStr(str:string):string;
var i:byte;
begin
for i:=1 to length(str) do str[i]:=LowCase(str[i]);
LowStr:=str;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function PosRL(sub,str:string; start:byte):byte;  {cerca una stringa partendo da start, da destra verso sinistra}
var i,j,pos,lsub,lstr:byte;
    pezzo:string;
begin
str:=Copy(str,1,start);
lstr:=length(str);
lsub:=length(sub);
PosRL:=0;
for i:=lstr downto lsub do
      begin
      pezzo:='';
      pos:=0;
      for j:=1 to lsub do
               begin
               pezzo:=str[i-pos]+pezzo;
               inc(pos);
               end;
      if pezzo=sub then
                   begin
                   PosRL:=i-lsub+1;
                   Exit;
                   end
                  else PosRL:=0;
      end;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function SostituisciLR(n:byte; sub,str,stringa:string):string;
{da sinistra verso destra, sostituisce l' n-sima stringa sub, con str nella stringa}
var posto,i:byte;
    str2:string;
begin
str2:=stringa;
posto:=0;
for i:=1 to n do
   begin
   posto:=pos(sub,str2);
   if posto=0 then Break
              else str2[posto]:=char(ord(str[1])-1); {il pos successivo sicuramente sara' diverso}
   end;
if posto<>0 then
     begin
     delete(stringa,posto,length(sub));
     insert(str,stringa,posto);
     end;
SostituisciLR:=stringa;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function SostituisciRL(n:byte; sub,str,stringa:string):string;
{da destra verso sinistra, sostituisce l' n-sima stringa sub, con str nella stringa}
var posto,i:byte;
    str2:string;
begin
str2:=stringa;
posto:=0;
for i:=1 to n do
   begin
   posto:=posRL(sub,str2,length(str));
   if posto=0 then Break      {il pos successivo sicuramente sara' diverso}
              else str2[posto+length(sub)-1]:=char(ord(str[length(str)])-1);
   end;
if posto<>0 then
     begin
     delete(stringa,posto,length(sub));
     insert(str,stringa,posto);
     end;
SostituisciRL:=stringa;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function Conta(str,stringa:string; start:byte; b:boolean):byte;
var count,posto,i:byte;
begin
if b then stringa:=Copy(stringa,start,length(stringa)-start+1) {a destra}
     else stringa:=Copy(stringa,1,start);                      {a sinistra}
count:=0;
for i:=1 to length(stringa)-length(str)+1 do
  begin
  posto:=pos(str,stringa);
  if posto=0 then break
        else
         begin
         count:=count+1;
         stringa[posto]:=char(ord(stringa[posto])+1);
         end;
  end;
conta:=count;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function CopyRL(str :string; start,count:integer):string; {copia da D verso S}
var str2:string;
    i:integer;
begin
str2:='';
for i:=1 to count do
   if (start+1-i>0)and(length(str)>start-i) then str2:=str[start+1-i]+str2
                                            else Break;
CopyRL:=str2;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function TruncPath(str:string; Max:byte):string; {2.0}
var a,b:integer;
begin
str:=FExpand2(str);
a:=pos('\',str);
if (length(str)<=Max)or(a=0) then
   begin
   TruncPath:=str;
   exit;
   end;
str[a]:='?';
repeat
 b:=pos('\',str);
 if b=0 then Break
        else str[b]:='?';
 str:=copy(str,1,a)+'...'+copy(str,b,255);
until length(str)<=max;
for b:=a to length(str) do if str[b]='?' then str[b]:='\';
TruncPath:=str;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure ExchangeInteger(var a,b:integer);
var c:integer;
begin
c:=a;
a:=b;
b:=c;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure ExchangeLongint(var a,b:longint);
var c:longint;
begin
c:=a;
a:=b;
b:=c;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure ExchangeByte(var a,b:byte);
var c:byte;
begin
c:=a;
a:=b;
b:=c;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function ToLongint(x:integer):Longint;
begin
ToLongint:=x;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function NameReserved(str:string):boolean;
var err:boolean;
    app:string;
    D: DirStr;
    N: NameStr;
    E: ExtStr;
begin
FSplit(str, D, N, E);
if length(N)>4 then
      begin
      NameReserved:=false;
      Exit;
      end;
err:=false;
N:=UpStr(N);
str:=N;   {il nome e' in STR}
while length(str)<4 do str:=str+' '; {la qualsiasi cosa: correzione si STR}
app:=str[1]+str[2]+str[3];
repeat
 if app='COM' then if str[4] in ['1'..'4'] then err:=true;
 if err then Break;
 if app='LPT' then if str[4] in ['1'..'9'] then err:=true;
 if err then Break;
 if (N='AUX') or (N='NUL') or (N='PRN') or (N='CON') then err:=true;
until True;
NameReserved:=err;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function IntToStr(I: Longint): String; { Converte da intero a stringa }
var
 S: string[11];
begin
 Str(I, S);
 IntToStr := S;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure ExchangeChar(var a,b:char);
var c:char;
begin
c:=a;
a:=b;
b:=c;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure Reverse(var str:string);
var i,L:byte;
begin
L:=length(str);
for i:=1 to (L div 2) do ExchangeChar(str[i],str[L-i+1]);
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function ToDecimal(num:string; oldBase:byte):string; {converte da base 2..16 a decimale}
var i,cifra,err:byte;
    neg:boolean;
    old,valore,cont:longint;
    risult:real;
begin
if (oldBase>16)or(oldBase<2) then
      begin
      ToDecimal:='';
      Exit;
      end;
valore:=0;
cont:=-1;
if num[1]='-' then
    begin
    neg:=true;
    delete(num,1,1);
    end
   else neg:=false;

for i:=length(num) downto 1 do
begin
 inc(cont);
 if num[i] in ['0'..'9'] then cifra:=ord(num[i])-48
    else
     case UpCase(num[i]) of
        'A': cifra:=10;
        'B': cifra:=11;
        'C': cifra:=12;
        'D': cifra:=13;
        'E': cifra:=14;
        'F': cifra:=15;
        end;
if cifra>oldBase then
      begin
      ToDecimal:='';
      Exit;
      end
     else
      begin
      Eleva(oldBase,cont,risult,err);
      old:=valore;
      Valore:=valore+cifra*Trunc(risult);
      if valore<old then
          begin
          ToDecimal:='';  {sforato il max longint}
          Exit;
          end;
      end;
end;
if neg then valore:=-valore;
ToDecimal:=IntToStr(valore);
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function IsInt(X: real): boolean; {Torna vero se il numero e' un intero es: 4,000000000000}
begin
if abs (X) < maxint then IsInt := X = trunc (X)
                    else IsInt := false
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function TAN (angle: real): real;
begin
  TAN := SIN (angle) / COS (angle);
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function COTAN (angle: real): real; {cotangente in radianti}
begin
  COTAN := COS (angle) / SIN (angle);
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function SIGN (R: real): real; {ritora -1 se R<0, 0 if R=0, o 1 if R>0.}
begin
if R > 0.0 then SIGN := 1.0
           else if R < 0.0 then SIGN := -1.0
                           else SIGN := 0.0;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function FACT (n: integer): real;  {Ritorna il fattoriale di un numero tra 0..33, -1 altrimenti}
var k: integer;
    ans: real;
begin
  ans := 1.0;
  if (n<0)or(n>33) then FACT := -1
                   else for k := 2 to n do ans := k * ans;
  FACT := ans
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function FromTo(oldV:string; oldB,newB:byte):string;{newV} {converte da base a base (2..16)}
var num:longint;
    err:integer;
begin
oldV:=ToDecimal(oldV,oldB); {converte da base 2..16 a decimale}
if oldV<>'' then {no errori nella riga precedente durante la conversione}
   begin
   Val(oldV,num,err);
   FromTo:=DecimalTo(num,newB);
   end
  else FromTo:='';
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function ToByte(L:longint):byte;
begin
ToByte:=L mod 256;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function DegToRad(gr:real):real;  {g:r = 360 : 2*3.14}
begin
DegToRad:=gr / 180 * Pi;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function RadToDeg(rad:real):real;  {g:r = 360 : 2*3.14}
begin
RadToDeg:=rad * 180 / Pi;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function fDelete(Str: String; Index,Count:Integer):string;
begin
delete(Str,Index,Count);
fDelete:=str;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function Max(a,b:real):real;
begin
if a>b then Max:=a
       else Max:=b;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function Min(a,b:real):real;
begin
if a<b then Min:=a
       else Min:=b;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function Single(str:string):string; {toglie i caratteri ripetuti}
var i,ii:byte;
begin
i:=0;
repeat
 inc(i);
 ii:=i;
 repeat
  inc(ii);
  if str[i]=str[ii] then
              begin
              Delete(str,ii,1);
              dec(ii);
              end;
 until ii>=length(str);
until i>=length(str);
Single:=str;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function Union(s1,s2:string):string;
begin
s1:=Single(s1);
s2:=Single(s2);
if length(s1)+length(s2)<256 then Union:=Single(s1+s2)
                             else Union:=''; {se si superano i 255 caratteri}
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure ExchangeStr(var s1,s2:string);
var s3:string;
begin
s3:=s1;
s1:=s2;
s2:=s3;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function Intersection(s1,s2:string):string;
var i:byte;
    s3:string;
begin
s3:='';
s1:=Single(s1);
s2:=Single(s2);
if length(s2)<length(s1) then ExchangeStr(s1,s2);
for i:=1 to length(s1) do if Pos(s1[i],s2)>0 then s3:=s3+s1[i];
Intersection:=s3;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure Testa_Coda(str,ins:string; var testa,coda:string);
var i,pos1,pos2,S,tmp:byte;
    app:string;
begin
ins:=Single(ins);
coda:='';
testa:='';
if length(str)<2 then
    begin
    testa:=str;
    Exit;
    end;
if ins='' then
   begin
   testa:=str;
   Exit;
   end;                {trovo il 1 elemento separatore}
pos1:=255;  {il massimo}
for i:=1 to length(ins) do
    begin
    tmp:=Pos(ins[i],str);
    if tmp=0 then tmp:=255;
    pos1:=Trunc(Min(pos1,tmp));
    if pos1=1 then Break; {non puo' essere < 1: inutile continuare il ciclo}
    end;
if pos1=255 then S:=0  {non vi sono elementi separatori}
            else S:=1; {c'e' almeno un elemento separatore}
if S=1 then
       begin
       pos2:=255;  {il massimo}
       app:=fDelete(str,pos1,1);
       for i:=1 to length(ins) do
           begin
           tmp:=Pos(ins[i],app);
           if tmp=0 then tmp:=255;
           pos2:=Trunc(Min(pos2,tmp));
           if pos2=1 then Break; {non puo' essere < 1: inutile continuare il ciclo}
           end;
       if pos2=255 then {S=1 c'e' solo un elemento separatore}
                   else
                    begin
                    S:=2; {ci sono almeno 2 elementi separatori}
                    inc(pos2);
                    end;
       end;
case S of
 0: testa:=str;
 1: if pos1=1 then testa:=str
              else
               begin
               testa:=Copy(str,1,pos1-1);
               coda:=Copy(str,pos1,length(str)-pos1+1);
               end;
 2: if pos1=1 then
               begin
               testa:=Copy(str,1,pos2-1);
               coda:=Copy(str,pos2,length(str)-pos1+1)
               end
              else
               begin
               testa:=Copy(str,1,pos1-1);
               coda:=Copy(str,pos1,length(str)-pos1+1);
               end;
 end;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function Alt:boolean;
begin
if (Tasti_Speciali and 8 <>0) then Alt:=true
                              else Alt:=false;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function Ctrl:boolean;
begin
if (Tasti_Speciali and 4 <>0) then Ctrl:=true
                              else Ctrl:=false;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function Bool(b:boolean):byte;
begin
if b then Bool:=1
     else Bool:=0;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function  Char_VideoXY(x,y:byte):char; {torna il carattere dove indicato}
var a,b:byte;
begin
a:=WhereX;
b:=WhereY;
gotoxy(x,y);
Char_VideoXY:=Char_Video;
gotoxy(a,b);
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function  BackColorXY(x,y:byte):byte; {indica il background dove indicato}
var a,b:byte;
begin
a:=WhereX;
b:=WhereY;
gotoxy(x,y);
BackColorXY:=BackColor;
gotoxy(a,b);
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function  TxtColorXY(x,y:byte):byte;  {indica il textcolor dove indicato}
var a,b:byte;
begin
a:=WhereX;
b:=WhereY;
gotoxy(x,y);
TxtColorXY:=TxtColor;
gotoxy(a,b);
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function  LampXY(x,y:byte):boolean;   {indica il lampeggio dove indicato}
var a,b:byte;
begin
a:=WhereX;
b:=WhereY;
gotoxy(x,y);
LampXY:=Lamp;
gotoxy(a,b);
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function CharReserved(s:string; jolly:boolean):byte;
var posto,i:byte;    {escluso i caratteri jolly ?*}
    bad:string;
    risultato:boolean;
begin
bad:=',;=+ /:|<>"';
if jolly then bad:=bad+'?*';
for i:=0 to 32 do bad:=bad+char(i);
risultato:=false;
for i:=1 to length(bad) do
    begin
    posto:=pos(bad[i],s);
    if posto<>0 then
          begin
          risultato:=true;
          Break;
          end;
    end;
if risultato then CharReserved:=posto
             else CharReserved:=0;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function Letters(c:char):boolean;
begin
if UpCase(c) in ['A'..'Z'] then Letters:=true
                           else Letters:=false;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function Digits(c:char):boolean;
begin
if c in ['0'..'9'] then Digits:=true
                   else Digits:=false;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function PosStart(sub,s:string; start:byte):byte;
var posiz:byte;
begin
posiz:=pos(sub,Copy(s,start,length(s)-start+1));
if posiz=0 then PosStart:=0
           else PosStart:=start-1+posiz;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function CharDriver(s:string):char;
begin
if length(s)<2 then CharDriver:=#0
   else if s[2]<>':' then CharDriver:=#0
           else if Letters(s[1]) then CharDriver:=UpCase(s[1])
                                 else CharDriver:=#0;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function NumDriver(s:string):byte;
begin
if length(s)<2 then NumDriver:=255
   else if s[2]<>':' then NumDriver:=255
           else if Letters(s[1]) then NumDriver:=ord( UpCase(s[1]) )-64
                                 else NumDriver:=255;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function PosJolly(sub,str:string; start:byte):byte;
var position,stringa:string;
    a,cicli:byte;
begin
str:=Copy(str,start,length(str)-start+1);
position:='';
for a:=1 to length(sub) do if sub[a]='?' then position:=position+char(a);

cicli:=0;
while true do
      begin
      inc(cicli);
      stringa:=Copy(str,cicli,length(str)-cicli+1); {copia la parte interessata}
      for a:=1 to length(position) do  {modifica dove necessario}
          if a<=length(str) then stringa[ord(position[a])]:='?'
                            else Break;
      a:=pos(sub,stringa);
      if a>0 then
             begin
             PosJolly:=start-1+a+cicli-1;
             Exit;
             end
            else
             if cicli>=length(str)-length(sub)+1 then
                                                    begin
                                                    PosJolly:=0;
                                                    Exit;
                                                    end;
      end;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function PosJollyRL(sub,str:string; start:byte):byte;
var position,stringa:string;
    a,cicli:byte;
begin
str:=Copy(str,1,start);
position:='';
for a:=1 to length(sub) do if sub[a]='?' then position:=position+char(a);
cicli:=length(sub)-1;
while true do
      begin
      inc(cicli);
      stringa:=Copy(str,length(str)-cicli+1,cicli); {copia la parte interessata}
      for a:=1 to length(position) do  {modifica dove necessario}
          if a<=length(str) then stringa[ord(position[a])]:='?'
                            else Break;
      a:=posRL(sub,stringa,length(stringa));
      if a>0 then
             begin
             PosJollyRL:=length(str)-length(stringa)+1;
             Exit;
             end
            else
             if cicli>length(stringa) then
                                      begin
                                      PosJollyRL:=0;
                                      Exit;
                                      end;
      end;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function DirEmpty(s:string):boolean;
var vuota:boolean;
    DirInfo: SearchRec;
begin
case s[length(s)] of
     '\' : s:=s+'*.*';
     ':' : s:=s+'*.*';
     else  s:=s+'\*.*';
     end;
vuota:=true;
FindFirst(s, Archive + ReadOnly + Directory + Hidden + SysFile + AnyFile, DirInfo);
while (DosError=0) and vuota do
      begin
      if (dirinfo.Name<>'.')and(dirinfo.Name<>'..') then vuota:=false;
      FindNext(DirInfo);
      end;
DirEmpty:=vuota;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function isDir(s:string):boolean;
var F: file;
    Attr: Word;
begin
if (pos('\\',copy(s,2,255))<>0) or (s='\\') then
                                            begin
                                            isdir:=false;
                                            Exit;
                                            end;
Assign(F, s);
GetFAttr(F, Attr);
if DosError <> 0 then isDir:=false
                 else if Attr and directory = 0 then isDir:=false
                                                else
                                                 begin
                                                 isDir:=true;
                                                 Exit;
                                                 end;
if (s[length(s)]='\')and(length(s)>1) then
   begin
   s:=copy(s,1,length(s)-1);
   Assign(F, s);
   GetFAttr(F, Attr);
   if (DosError = 0) and  ( Attr and directory <> 0 ) then isDir:=true;
   end;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function StringToPChar(s:string):PChar;
var a:array[0..255] of char;
begin
StrPCopy(A, s);
StringToPChar:=a;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function DeepDir(s:string):string;
var DirX: SearchRec;
    i:byte;
    result:string;
    label start;
begin
s:=UpStr(s);
if s[length(s)]='\' then result:=Copy(s,1,length(s)-1)
                    else result:=s;
case s[length(s)] of
     '\' : s:=s+'*.*';
     ':' : s:=s+'*.*';
     else  s:=s+'\*.*';
     end;
start:
FindFirst(s, Directory, DirX);
if DosError=0 then
for i:=1 to 3 do
       begin
       FindNext(DirX);
       if (dirX.name<>'.')and(dirX.name<>'..')and(dirx.attr and Directory <>0) then
          begin
          s:=result+'\'+dirx.name+'\*.*';
          result:=result+'\'+dirx.name;
          goto start;
          end;
       end
      else result:='';
DeepDir:=result;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function FreeChar(c,s:string):string;
var i,j:byte;
    ris:string;
begin
for i:=1 to length(c) do
      begin
      ris:='';
      for j:=1 to length(s) do if c[i]<>s[j] then ris:=ris+s[j];
      s:=ris;
      end;
FreeChar:=s;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function GetEnvVarS(s:string):string;
var EnvironmentVar: PChar;
begin
EnvironmentVar:=GetEnvVar(stringtopchar(s));
if EnvironmentVar=nil  then GetEnvVarS:=''
                       else GetEnvVarS:=StrPas(EnvironmentVar);
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function ReadString(stringa:string; Xstart,Xtot,status:byte; topo,avanzate:boolean;
                    var ins:boolean; var lastD,lastU,posto:byte):string;
var old_x,mox,moy,mtasto,y,x,maxx:byte;
    c:char;

{---------------------------------------------------------------------------}

procedure Tasto(var x:byte; var stringa:string; c:char; Xtot,Xstart:byte; ins:boolean);
begin
if ins then
        if whereX<Xtot then
                       begin
                       stringa[0]:=char(length(stringa)+1);
                       stringa[length(stringa)]:=#0;
                       stringa[x-Xstart+1]:=c;
                       inc(x);
                       if stringa[length(stringa)]=#0 then stringa[0]:=char(length(stringa)-1);;
                       end else
       else { ins=false }
        if length(stringa)+xstart<Xtot then
                       begin
                       Insert(c,Stringa,x-Xstart+1);
                       inc(x);
                       end;
end;

{---------------------------------------------------------------------------}

begin
maxX:=gettextmaxx;                         {status: 0 = normale}
if Xstart=0 then Xstart:=1;                {status: 1 = maiuscolo}
xstart:=trunc(min(Xstart,maxX-1));         {status: 2 = minuscolo}
if Xtot=0 then Xtot:=1;                    {status: altro = normale}
xtot:=trunc(min(Xtot,maxX-1));
if status>2 then status:=0;
gotoxy(xstart,whereY);
write(stringa);
y:=WhereY;
if posto>length(stringa) then posto:=length(stringa)+1;
if posto=0 then posto:=1;
while whereX<=Xtot do write(' ');
x:=Xstart-1+posto;
gotoxy(x,wherey);
old_x:=255;
c:=#1;
if ins then Cursore(2)
       else Cursore(1);
repeat
if KeyPressed or not topo then
   begin
   c:=ReadKey;
   if ord(c)=0 then
      begin
      c:=ReadKey;
      if ALT and avanzate then
             begin
             lastU:=ord(c);  {esce alla pressione del tasto ALT + qualcosa}
             lastD:=255;
             c:=#13;
             end;
      case ord(c) of
           75: if x>Xstart then dec(x);       {K sinistra}
           83: begin
               if x-length(stringa)-xstart=0 then Continue;
               delete(stringa,x-Xstart+1,1);  {S canc}
               old_x:=255; {forza il compare_mouse}
               end;
           79: x:=length(stringa)+Xstart;     {O fine}
           71: x:=Xstart;                     {G inizio}
           77: if x<length(stringa)+Xstart then inc(x);  {M destra}
           82: begin
               ins:=not ins;                  {R insert}
               if ins then Cursore(2)
                      else Cursore(1);
               Continue;
               end;
           else Continue;
           end;
      if ord(c) in [75,79,71,77] then
         begin
         gotoxy(x,y);
         Continue;
         end;
      end
     else  {tasti normali}
      begin
      lastU:=ord(c); {il valore del tasto}
      lastD:=0;
      case status of
           0: ;
           1: c:=UpCase(c);
           2: c:=LowCase(c);
           end;
      case c of
        #27 : if stringa<>'' then
                 begin   {Esc}
                 gotoxy(Xstart,y);
                 for x:=1 to length(stringa) do write(' ');
                 stringa:='';
                 x:=Xstart;
                 end
                else c:=#13;
        #32..#255 : Tasto(x,stringa,c,Xtot,Xstart,ins);
        #9: if avanzate then c:=#13;
        #8: if x>Xstart then  {back-space}
               begin
               dec(x);
               Delete(stringa,x-Xstart+1,1);
               end
              else Continue;
        end;
      end;
   gotoxy(Xstart,y);
   write(stringa);
   if whereX<80 then write(' ');
   gotoxy(x,y);
   if topo then Showmouse;
   end
  else  {not keypressed}
   if topo then
       begin
       Rilascio(mox,moy,mtasto);
       if mtasto=1 then
          begin
          if moy=y then
             if (mox>=xstart)and(mox<=xstart+length(stringa)-1) then x:=mox else
                if mox<=xtot then if mox>=length(stringa)+xstart then x:=xstart+length(stringa);
          if avanzate and ( (moy<>y)or(x>mox)or(mox>xtot) ) then
             begin
             c:=#13;
             lastU:=mox;
             lastD:=moy;
             Break;
             end;
          end;
       end;
if x<>old_x then
          begin
          old_x:=x;
          gotoxy(x,y);
          if topo then Showmouse;
          end;
until c=#13;
posto:=wherex-xstart+1;
ReadString:=stringa;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function PathOf(stringa:string):string;
var D: DirStr;
    N: NameStr;
    E: ExtStr;
begin
FSplit(stringa, D, N, E);
pathof:=D;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function NameOf(s:string):string;
var D: DirStr;
    N: NameStr;
    E: ExtStr;
begin
FSplit(s, D, N, E);
NameOf:=n+e;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function ValidName(s:string):byte;
var testa,coda:string;
    D: DirStr;
    N: NameStr;
    E: ExtStr;
    posto,posto1:integer;
begin
testa:=s;
if testa='' then
            begin
            ValidName:=1;
            Exit;
            end;
if testa[length(testa)]='.' then
   begin
   ValidName:=length(testa);
   Exit;
   end;
                               {controllo se il ':' e' valido}
if copy(testa,1,2)='\\' then        { net }
                         begin
                         if pos(':',testa)<>0 then
                             begin
                             validname:=pos(':',testa);
                             exit;
                             end
                         end
                        else
                         begin
                         posto:=CharReserved(testa[1]+Copy(testa,3,255),false);
                         if posto>1 then inc(posto);
                         if posto<>0 then
                                     begin
                                     ValidName:=posto;
                                     Exit;
                                     end;
                         end;
{? e * non possono stare prima dell'ultimo \}
posto:=pos('?',testa);
if posto=0 then posto:=257;
posto1:=pos('*',testa);
if posto1=0 then posto1:=257;
posto:=Trunc(min(posto,posto1));
if posto<PosRL('\',testa,255) then
   begin
   ValidName:=posto;
   Exit;
   end;

if Copy(testa,2,1)=':' then      {controllo se il ':' e' valido}
   begin
   if Letters(testa[1])=false then
      begin
      ValidName:=1;
      Exit;
      end;
   testa:=Copy(testa,3,255);
   end;

posto:=pos('\\',copy(testa,2,255));
if posto>0 then
   begin
   ValidName:=posto;
   Exit;
   end;

posto:=pos('...',testa);
if posto>0 then
   begin
   ValidName:=posto;
   Exit;
   end;

if copy(testa,1,2)='\\' then testa[1]:='A'; { \\... deve divetare valido, ad esempio A\... }
while (testa<>'') do
          begin
          Testa_Coda(testa,'\',testa,coda);
          if (testa[1]='\')and(testa<>'\') then testa:=Copy(testa,2,255);
          if testa='..' then
                        begin
                        testa:=coda;
                        Continue;
                        end;
          posto:=Conta('.',testa,1,true);
          if posto>1 then
             begin
             testa[pos('.',testa)]:='X';
             ValidName:=pos('.',testa);
             Exit;
             end;
          if (testa='') or NameReserved(testa) then
             begin
             ValidName:=Length(s)-length(coda)+1-length(testa);
             Exit;
             end;
          FSplit(testa, D, N, E);
          if ( (length(n)+length(e))<>length(testa) ) or
             not (length(n) in [1..8] ) or   {nella ver 32 bit e' un po' diversa, ma equivalente}
             not (length(e) in [0..4] ) then {controllo lunghezza nome.est}
              begin
              ValidName:=Length(s)-length(coda)+1-length(testa);
              Exit;
              end;
          testa:=coda;
          end;
ValidName:=0;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function ValidNameDos(s:string):byte;
begin
ValidNameDos:=ValidName(s);
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function ValidNameWin(s:string):byte;
begin
ValidNameWin:=ValidName(s);
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function NewDir(dir:string):integer;
var testa,coda,thispath:string;
    creato,first:boolean;
    i:byte;
begin
i:=ValidName(dir);
if i>0 then
       begin
       NewDir:=i;
       Exit;
       end;
first:=true;
creato:=false;
GetDir(0,thispath);  {lo salvo per rispristinarlo dopo}
if length(dir)>1 then if dir[2]=':' then
   begin
   {$i-}
   ChDir(dir[1]+dir[2]);
   {$i+}
   if IOResult=0 then dir:=copy(dir,3,255)
                 else
                  begin
                  NewDir:=-1; { *** Unita' specificata non valida}
                  {$I-}
                  chdir(thispath);
                  {$I+}
                  if IOResult<>0 then ;
                  Exit;
                  end;
   end;
while (dir<>'') do
      begin
      Testa_Coda(dir,'\',dir,coda);
      if first then first:=false
               else dir:=copy(dir,2,255);
      {$i-}
      ChDir(dir);
      {$i+}
      if IOResult<>0 then
                     begin
                     if dir='..' then
                                 begin
                                 NewDir:=-2; { *** Percorso inesistente }
                                 {$I-}
                                 chdir(thispath);
                                 {$I+}
                                 if IOResult<>0 then ;
                                 Exit;
                                 end;
                     {$I-}
                     MkDir(dir);
                     {$I+}
                     if IOResult=0 then creato:=true else;
                     {$i-}
                     ChDir(dir);
                     {$i+}
                     if IOResult<>0 then
                                 begin
                                 NewDir:=-3; { *** Accesso negato }
                                 {$I-}
                                 chdir(thispath);
                                 {$I+}
                                 if IOResult<>0 then ;
                                 Exit;
                                 end;
                     end;
      dir:=coda;
      end;   {while}
if creato then NewDir:=0   { *** Directory Creata }
          else NewDir:=-4; { *** La directory esiste gia' }
{$I-}
chdir(thispath);
{$I+}
if IOResult<>0 then ;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function TmpFile(ilFile:string):string;
var tt1:string;

function TMP(t1:string):string;  {sottofunzione di TmpFile}
var p2,nome,estensione,risultato:string;
    valore:longint;
    punto:byte;

label riprova;

begin
valore:=-1;
if isDir(T1) then
   begin
   if t1[length(t1)]<>'\' then t1:=t1+'\';
   p2:=t1;
   t1:=t1+ilFile;
   if Exist(t1)=-1 then  {non esiste}
                   begin
                   Tmp:=t1;
                   Exit;
                   end
                  else   {esiste, devo cambiare nome}
                   begin
                   t1:=p2;
      riprova:     inc(valore);
                   if valore>99999999 then
                      begin
                      Tmp:='';
                      Exit;
                      end;
                   p2:=IntToStr(valore);
                   punto:=pos('.',ilFile);
                   if punto=0 then estensione:=''
                              else estensione:=Copy(ilFile,punto+1,3);
                   if punto=0 then nome:=ilFile
                              else nome:=Copy(ilFile,1,pos('.',ilFile)-1);
                   while length(nome)<8 do nome:=nome+'0';
                   nome:=Copy(nome,1,8-length(p2))+p2;
                   if estensione<>'' then risultato:=t1+nome+'.'+estensione
                                     else risultato:=t1+nome;
                   if Exist(risultato)=-1 then
                      begin
                      Tmp:=risultato;
                      Exit;
                      end
                     else goto riprova;
                   end;
   end
  else if NewDir(t1)=0 then
   begin
   if t1[length(t1)]<>'\' then t1:=t1+'\';
   Tmp:=t1+ilFile;
   Exit;
   end;
end;

begin    {codice di TmpFile}
tt1:='';
if (ilFile<>NameOf(ilFile))or(ValidName(ilFile)>0)or(pos('*',ilFile)<>0)or(pos('?',ilFile)<>0) then
   begin
   TmpFile:='';
   Exit;
   end;

if tt1='' then tt1:=TMP(GetEnv('TMP'));
if tt1='' then tt1:=TMP(GetEnv('TEMP'));
if tt1='' then
          begin
          GetDir(0,tt1);
          if tt1[length(tt1)]<>'\' then tt1:=tt1+'\';
          tt1:=TMP(tt1);
          end;
TmpFile:=tt1;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function DeleteFile(TmpFiles:string):boolean;
var tmp: file;
begin
assign(tmp,TmpFiles);
SetFAttr(tmp, archive);
{$I-}
Erase(tmp);
{$I+}
if IOResult <> 0 then DeleteFile:=false
                 else DeleteFile:=true;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function SubDir(path,tmpfiles:string):byte;
var  DirInfo: SearchRec;
     tmp: file of string;
     stringa,old_s:string;
     p_inizio:longint;

begin
assign(tmp,tmpfiles);
{$i-}
rewrite(tmp);
{$i+}
if IOResult<>0 then
               begin
               subdir:=1;
               exit;
               end;
if (path<>'')and((path[length(path)] in ['\',':'])=false) then path:=path+'\';
p_inizio:=0;
FindFirst(path+'*.*', ReadOnly+Hidden+SysFile+Directory+Archive, DirInfo);
while DosError = 0 do
      begin
      if (dirinfo.attr and directory) =0 then
         begin
         FindNext(DirInfo);
         Continue;
         end;
      if (dirinfo.name='.')or(dirinfo.name='..') then
         begin
         FindNext(DirInfo);
         Continue;
         end;
      if (path<>'')and((path[length(path)] in ['\',':'])=false) then path:=path+'\';
      stringa:=path+DirInfo.Name;
      {***SOLO PER DISGNOSTICA}
      while length(stringa)<255 do stringa:=stringa+#0;
      {$i-}
      Write(tmp,stringa);
      {$i+}
      if IOResult<>0 then
                     begin
                     subdir:=1;
                     exit;
                     end;
      FindNext(DirInfo);
      end;

while true do
      begin
      if KeyPressed then
            case readkey of
              #27: begin
                   subdir:=2;
                   exit;
                   end;
              #00: readkey;
            end;
      {$i-}
      Seek(tmp,p_inizio);
      {$i+}
      if IOResult<>0 then
               begin
               subdir:=1;
               exit;
               end;
      if EOF(tmp) then Break;
      inc(p_inizio);
      {$i-}
      read(tmp,stringa);
      {$i+}
      if IOResult<>0 then
                     begin
                     subdir:=1;
                     exit;
                     end;
      {***SOLO PER DISGNOSTICA}
      stringa:=FreeChar(#0,stringa);
      if (stringa<>'')and((stringa[length(stringa)] in ['\',':'])=false) then stringa:=stringa+'\';
      old_s:=stringa;
      FindFirst(stringa+'*.*', ReadOnly+Hidden+SysFile+Directory+Archive, DirInfo);
      while DosError = 0 do
            begin
            if (dirinfo.attr and directory)=0 then
               begin
               FindNext(DirInfo);
               Continue;
               end;
            if (dirinfo.name='.')or(dirinfo.name='..') then
               begin
               FindNext(DirInfo);
               Continue;
               end;
            if (stringa<>'')and((stringa[length(stringa)] in ['\',':'])=false) then stringa:=stringa+'\';
            stringa:=old_s+DirInfo.Name;
            {***SOLO PER DISGNOSTICA}
            while length(stringa)<255 do stringa:=stringa+#0;
            Seek(tmp,(FileSize(tmp)));
            {$i-}
            Write(tmp,stringa);
            {$i+}
            if IOResult<>0 then
               begin
               subdir:=1;
               exit;
               end;
            FindNext(DirInfo);
            end;
      end;
{$i-}
Close(tmp);
{$i+}
if IOResult<>0 then
               begin
               subdir:=1;
               exit;
               end;
subdir:=0;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function espansione(s:string; e:boolean):string;
var old,new_str:string;
    p1,p2:byte;
begin
old:=s;
repeat
 p1:=pos('%',s);
 if p1=0 then break;
 p2:=pos('%',copy(s,p1+1,255));
 p2:=p2+p1;
 if p1=p2 then break;
 new_str:=GetEnv(copy(s,p1+1,p2-p1-1));
 if new_str='' then break;
 s:=copy(s,1,p1-1)+new_str+copy(s,p2+1,255);
until false;
if pos('%',s)=0 then        { net }
                 if e then
                        if copy(s,1,2)='\\' then espansione:=copy(fexpand(s),pos('\\',fexpand(s)),255)
                                            else espansione:=fexpand(s)
                      else espansione:=s
                else espansione:=old; { numero di '%' dispari: errore}
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function ExpandEnvironment(s:string):string;
begin
ExpandEnvironment:=espansione(s,false);
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function FExpand2(s:string):string;
begin
fexpand2:=espansione(s,true);
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function ReadString2(stringa:string; Xstart,Xtot,status:byte; topo,avanzate:boolean;
                    var ins:boolean; var lastD,lastU,cursore_,x_:byte):string;
var old_x,mox,moy,mtasto,y,maxx:byte;
    c:char;
    diff:integer;
    str_app:string;
    quadra:boolean;

{---------------------------------------------------------------------------}

procedure Tasto(var x,x_:byte; var stringa:string; c:char; Xtot:byte; ins:boolean);
begin
if ins and (x_<=length(stringa)) then
                       begin
                       stringa[x_]:=c;
                       inc(x_);
                       inc(x);
                       end
       else { ins=false }
        if length(stringa)<254 then
                       begin
                       Insert(c,Stringa,x_);
                       if x<xtot then inc(x);
                       inc(x_);
                       end;
end;

{---------------------------------------------------------------------------}

begin
maxX:=gettextmaxx;                         {status: 0 = normale}
if Xstart=0 then Xstart:=1;                {status: 1 = maiuscolo}
xstart:=trunc(min(Xstart,maxX-1));         {status: 2 = minuscolo}
if Xtot=0 then Xtot:=1;                    {status: altro = normale}
xtot:=trunc(min(Xtot,maxX-1));

if xtot-xstart<3 then RunError(201);
if x_>length(stringa)+1 then x_:=length(stringa)+1;
if x_=0 then x_:=1;
if status>2 then status:=0;
y:=WhereY;
cursore_:=trunc(min(cursore_,xtot-xstart+1));
if cursore_>length(stringa) then cursore_:=length(stringa)+1;
if cursore_=0 then cursore_:=1;
if cursore_>x_ then cursore_:=x_;
cursore_:=Xstart-1+cursore_;

gotoxy(xstart-1,Y);
str_app:=copy(stringa,x_-(cursore_-xstart),xtot-xstart);
quadra:=length(str_app)=length(copy(stringa,x_-(cursore_-xstart),255));

while length(str_app)<xtot-xstart do str_app:=str_app+' ';
str_app:=' '+str_app+' ';
if quadra then str_app[length(str_app)]:=']'
          else str_app[length(str_app)]:=#17;

if cursore_-x_=xstart-1 then str_app[1]:='['
                        else str_app[1]:=#16;
write(str_app);
gotoxy(cursore_,y);

old_x:=255;
c:=#1;
if ins then Cursore(2);

repeat
if KeyPressed or not topo then
   begin
   c:=ReadKey;
   if ord(c)=0 then
      begin
      c:=ReadKey;
      if ALT and avanzate then
             begin
             lastU:=ord(c);  {esce alla pressione del tasto ALT + qualcosa}
             lastD:=255;
             c:=#13;
             end;
      case ord(c) of
           75: begin
               if cursore_>Xstart then dec(cursore_);       {K sinistra}
               if x_>1 then dec(x_);
               end;
           83: if x_<=length(stringa) then delete(stringa,x_,1);  {S canc}
           79: begin
               x_:=length(stringa)+1;  {O fine}
               if x_>(xtot-xstart) then cursore_:=xtot
                                   else cursore_:=length(stringa)+xstart;
               end;
           71: begin
               cursore_:=Xstart;              {G inizio}
               x_:=1;
               end;
           77: if x_<=length(stringa) then
                                      begin     {M destra}
                                      inc(x_);
                                      if cursore_<Xtot then inc(cursore_);
                                      end;
           82: begin
               ins:=not ins;                  {R insert}
               if ins then Cursore(2)
                      else Cursore(1);
               Continue;
               end;
           else Continue;
           end;
      end
     else  {tasti normali}
      begin
      lastU:=ord(c); {il valore del tasto}
      lastD:=0;
      case status of
           0: ;
           1: c:=UpCase(c);
           2: c:=LowCase(c);
           end;
      case c of
        #27 : if stringa<>'' then
                 begin   {Esc}
                 gotoxy(Xstart,y);
                 stringa:='';
                 cursore_:=Xstart;
                 x_:=1;
                 end
                else c:=#13;
        #32..#255 : Tasto(cursore_,x_,stringa,c,Xtot,ins);
        #9: if avanzate then c:=#13;
        #8: if x_>1 then
               begin                     {back-space}
               Delete(stringa,x_-1,1);
               dec(x_);
               if cursore_>xstart then dec(cursore_);
               end;
        end;
      end;
   gotoxy(Xstart-1,y);
   str_app:=copy(stringa,x_-(cursore_-xstart),xtot-xstart);
   quadra:=length(str_app)=length(copy(stringa,x_-(cursore_-xstart),255));
   while length(str_app)<xtot-xstart do str_app:=str_app+' ';
   str_app:=' '+str_app+' ';
   if quadra then str_app[length(str_app)]:=']'
             else str_app[length(str_app)]:=#17;
   if cursore_-x_=xstart-1 then str_app[1]:='['
                           else str_app[1]:=#16;

   write(str_app);
   gotoxy(cursore_,y);
   if topo then Showmouse;
   end
  else  {not keypressed}
   if topo then
       begin
       Rilascio(mox,moy,mtasto);
       if mtasto=1 then
          begin
          if (moy=y)and(mox>=xstart)and(mox<=xtot) then
                   begin
                   diff:=mox-whereX;
                   if diff<0 then
                             begin
                             inc(cursore_,diff);
                             inc(x_,diff);
                             end;
                   if diff>0 then
                             begin
                             inc(cursore_,diff);
                             inc(x_,diff);
                             diff:=x_-length(stringa);
                             if diff>0 then
                                 begin
                                 dec(x_,diff-1);
                                 dec(cursore_,diff-1);
                                 end;
                             end;
                   end;
          if avanzate and ( (moy<>y)or(cursore_>mox)or(mox>xtot) ) then
             begin
             c:=#13;
             lastU:=mox;
             lastD:=moy;
             Break;
             end;
          end;
       end;
if x_<>old_x then
          begin
          old_x:=x_;
          gotoxy(cursore_,y);
          if topo then Showmouse;
          end;
until c=#13;
cursore_:=cursore_-xstart+1;
ReadString2:=stringa;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function GetTextMaxX:word;
var x,y:byte;
    x_,old_x:integer;
begin
x:=whereX;
y:=whereY;
old_x:=0;
x_:=1;
repeat
 gotoxy(x_,1);
 old_x:=x_;
 inc(x_);
until wherex<>old_x;
GetTextMaxX:=wherex;
gotoxy(x,y);
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function GetTextMaxY:word;
var x,y:byte;
    y_,old_y:integer;
begin
x:=whereX;
y:=whereY;
old_y:=0;
y_:=1;
repeat
 gotoxy(1,y_);
 old_y:=y_;
 inc(y_);
until wherey<>old_y;
GetTextMaxy:=wherey;
gotoxy(x,y);
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function contaDirFile(s:string):longint;
var DirInfo: SearchRec;
    tot:longint;

begin
s:=fexpand2(s);
if isDir(s)=false then
                  begin
                  contaDirFile:=-1;
                  Exit;
                  end;
if s[length(s)]<>'\' then s:=s+'\';
s:=s+'*.*';
tot:=0;
FindFirst(s, Archive + ReadOnly + SysFile + Hidden + Directory + Anyfile, DirInfo);
while DosError = 0 do
      begin
      if (dirinfo.name<>'.')and(dirinfo.name<>'..') then inc(tot);
      FindNext(DirInfo);
      end;
contadirfile:=tot;
end;

{++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function contaDir(s:string):longint;
var DirInfo: SearchRec;
    tot:longint;

begin
s:=fexpand2(s);
if isDir(s)=false then
                  begin
                  contadir:=-1;
                  Exit;
                  end;
if s[length(s)]<>'\' then s:=s+'\';
s:=s+'*.*';
tot:=0;
FindFirst(s, Archive + ReadOnly + SysFile + Hidden + Directory + Anyfile, DirInfo);
while DosError = 0 do
      begin
      if (dirinfo.name<>'.')and(dirinfo.name<>'..')and(dirinfo.attr and directory <>0) then inc(tot);
      FindNext(DirInfo);
      end;
contadir:=tot;
end;

{++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function contaFile(s:string):longint;
var DirInfo: SearchRec;
    tot:longint;

begin
s:=fexpand2(s);
if isDir(s)=false then
                  begin
                  contafile:=-1;
                  Exit;
                  end;
if s[length(s)]<>'\' then s:=s+'\';
s:=s+'*.*';
tot:=0;
FindFirst(s, Archive + ReadOnly + SysFile + Hidden + Directory + Anyfile, DirInfo);
while DosError = 0 do
      begin
      if (dirinfo.name<>'.')and(dirinfo.name<>'..')and(dirinfo.attr and directory =0) then inc(tot);
      FindNext(DirInfo);
      end;
contaFile:=tot;
end;

{++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure setlength(var s:string; n:byte);
begin
s[0]:=char(n);
end;

{++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function UnderDos:boolean;
begin
underdos:=true;
end;

{++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function UnderWin:boolean;
begin
underWin:=false;
end;

{++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function ChangeFileExt(const FileName, Extension: string): string;
var i: longint;
begin
I := Length(FileName);
while (I > 0) and not(FileName[I] in ['/', '\', ':']) do Dec(I);
if (I = 0) or (FileName[I] <> '') then I := 256;
ChangeFileExt:= Copy(FileName, 1, I - 1) + Extension;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function contaThis(path,nome:string):longint;
var DirInfo: SearchRec;
    tot:longint;
begin
path:=fexpand2(path);
if isDir(path)=false then
                  begin
                  contaThis:=-1;
                  Exit;
                  end;
if path[length(path)]<>'\' then path:=path+'\';
path:=path+nome;
tot:=0;
FindFirst(path, Archive + ReadOnly + SysFile + Hidden + Directory + Anyfile, DirInfo);
while DosError = 0 do
      begin
      if (dirinfo.name<>'.')and(dirinfo.name<>'..') then inc(tot);
      FindNext(DirInfo);
      end;
contathis:=tot;
end;

{++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function getshortname(var s:string):boolean;
begin
getshortname:=false;
end;

{++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function getlongname(var s:string):boolean;
begin
getlongname:=false;
end;

{++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function Attr(s:string):string;
var F: SearchRec;
begin
if s[length(s)]='\' then s:=copy(s,1,length(s)-1);
FindFirst(s, Anyfile, F);
if (doserror<>0) then
   begin
   attr:='';
   Exit;
   end;
s:='';
if (f.attr and archive)  <>0 then s:='A'     else s:='_';
if (f.attr and readonly) <>0 then s:=s+'R' else s:=s+'_';
if (f.attr and hidden)   <>0 then s:=s+'H' else s:=s+'_';
if (f.attr and sysfile)  <>0 then s:=s+'S' else s:=s+'_';
if (f.attr and directory)<>0 then s:=s+'D' else s:=s+'_';
attr:=s;
end;

{++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function from_alt_to_char(b:byte):char;
begin
case b of
     16 : from_alt_to_char:='q';
     17 : from_alt_to_char:='w';
     18 : from_alt_to_char:='e';
     19 : from_alt_to_char:='r';
     20 : from_alt_to_char:='t';
     21 : from_alt_to_char:='y';
     22 : from_alt_to_char:='u';
     23 : from_alt_to_char:='i';
     24 : from_alt_to_char:='o';
     25 : from_alt_to_char:='p';

     30 : from_alt_to_char:='a';
     31 : from_alt_to_char:='s';
     32 : from_alt_to_char:='d';
     33 : from_alt_to_char:='f';
     34 : from_alt_to_char:='g';
     35 : from_alt_to_char:='h';
     36 : from_alt_to_char:='j';
     37 : from_alt_to_char:='k';
     38 : from_alt_to_char:='l';

     44 : from_alt_to_char:='z';
     45 : from_alt_to_char:='x';
     46 : from_alt_to_char:='c';
     47 : from_alt_to_char:='v';
     48 : from_alt_to_char:='b';
     49 : from_alt_to_char:='n';
     50 : from_alt_to_char:='m';
     120..128 : from_alt_to_char:=char(b-71{-119+48});
     129 : from_alt_to_char:='0';

      else from_alt_to_char:=#1;
     end;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

end.


Versione:    Data:     Righe:  Modifica:

1.090.042  29/09/02    2309    con Conta Dir_File;
1.090.041  04/07/02    2209    con ExpandEnvironment;
1.090.040  10/03/02    2178    Readstring2 , GetTextMaxX , GetTextMaxY;
1.087.039  28/02/02    1947    FExpand2;
1.086.038  08/02/01    1874    DestroyF,SubDir;
1.085.037  04/02/01    1669    TmpFile;
1.084.036  04/01/01    1612    NewDir;
1.083.035  02/01/01    1526    ValidName;
1.082.034  14/12/00    1466    PathOf + NameOf;
1.080.033  18/08/00    1422    ReadString + GetEnvVarS;
1.079.032  13/08/00    1313    FreeChar;
1.078.031  12/08/00    1297    StringToPChar;
1.077.030  07/08/00    1287    isDir,DeepDir,DirEmpty;
1.074.029  16/07/00    1209    PosJollyRl;
1.073.028  13/07/00    1200    PosJolly;
1.072.027  07/07/00    1130    CharDriver;
1.071.026  06/07/00    1116    PosStart;
1.070.025  05/07/00    1100    Letters,Digits,CharDriver;
1.067.024  30/06/00    1067    CharReserved;
1.066.023  29/06/00    1043    ExchangeLongint;
1.065.022  22/06/00    1032    Bool,BackColorXY,TxtColorXY,LampXY;
1.061.018  07/06/00     987    Ctrl;
1.060.017  06/06/00     978    Alt;
1.059.016  04/06/00     969    Union,Intersection,ExchangeStr,Testa_Coda;
1.054.015  03/06/00     863    Single;
1.053.014  02/06/00     841    Min,Max;
1.051.013  31/05/00     823    fDelete;
1.050.012  30/05/00     814    RadToDeg,DegToRad,ToByte,IsInt,TAN,COTAN,SIGN,FACT,FromTo;
1.039.011  29/05/00     720    NameReserved,IntToStr,reverse,ExchangeChar,ToDecimal;
1.034.010  28/05/00     598    CastLongint;
1.033.009  05/05/00     590    TruncPath;
1.032.008  22/04/00     544    CopyRL;
1.031.007  26/03/00     530    Sostituisci LR / RL, conta;
1.029.006  18/03/00     441    Low/Up Str, PosRL;
1.026.005  12/03/00     420    con nospaceL/R;
1.024.004  11/03/00     392    con lowcase;
1.023.003  04/02/00     379    con freverse,eleva;
1.021.002  15/01/00     354    con D_H;
1.020.001  10/12/99     293    inizio.
