{$MODE FPC}
unit Altro32D;  { per DOS/Win 32 bit}

interface

  {$define DOS}
//  {$define Win}

{$ifdef DOS}
uses Crt,SysUtils,Dos,MsMouse,Math, Altro32;
{$endif}

{$ifdef Win}
uses Crt,SysUtils,Dos,Mouse,Math,Video, Altro32;
{$endif}

function  SfogliaFile(XX,YY:byte; all,ordina,topo:boolean; testo,percorso_:string; var ifiles:string; CD:byte):string;
function  ReadString(stringa:string; Xstart,Xtot,status:byte; topo,avanzate:boolean;
                     var ins:boolean;  var lastD,lastU,posto:byte):string;
function  ReadString2(stringa:string; Xstart,Xtot,status:byte; topo,avanzate:boolean;
                     var ins:boolean; var lastD,lastU,cursore_,x_:byte):string;

implementation

const maxx=2000;
type  {$ifdef DOS}
      tipo1=string[13];
      {$endif}
      {$ifdef WIN}
      tipo1=string;
      {$endif}

      AA=array[1..maxx] of tipo1;

var  A:AA;          {per il QSort}
     q:word;

var   percorso,nomefile:string;
      count,iesimo,app:word;
      selezionato,X,Y:byte;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function Partition(var A:AA; p,r:word):word;
var i,j:word;
    x,xx: tipo1;
begin
x:=A[p];
i:=p-1;
j:=r+1;
while true do
      begin
      repeat
       dec(j);
      until A[j]<=x;
      repeat
       inc(i);
      until A[i]>=x;
      if i<j then
             begin
             xx:=A[i];
             A[i]:=A[j];
             A[j]:=xx;
             end
            else
             begin
             Partition:=j;
             Break;
             end;
      end;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure QuickSort(var A:AA; p,r:word);
begin
if p<r then
       begin
       q:=Partition(A,p,r);
       QuickSort(A,p,q);
       QuickSort(A,q+1,r);
       end;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

{$ifdef DOS}
procedure RilascioDestra(var mox,moy,tasto:byte);
var reg:registers;
begin
if MouseFound=false then
                    begin
                    mox:=0;
                    moy:=0;
                    tasto:=0;
                    Exit;
                    end;
reg.bx:=1;     {in:    bx=0: S,  bx=1: D,  bx=2: C}
reg.ax:=6;
intr($33,reg);
moy:=reg.dx div 8 +1;    {Y}
mox:=reg.cx div 8 +1;    {X}
tasto:=reg.bx;
end;
{$endif}

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure FindFiles2(path:string; const all:boolean);
var F: SearchRec;
    nome:string;
    i:longint;
label continua;
begin
showmouse;
FindFirst(Path,  Anyfile - VolumeId - Directory, F);
while (DosError = 0) and (Count < Maxx) do
  begin
  if all=false then if ((f.attr and hidden)<>0)or((f.attr and sysfile)<>0) then
                    goto continua;
  if (f.attr and directory) =0  then
                                begin
                                Inc(Count);
                                nome:=pathof(path)+f.name;
                                GetshortName(nome);
                                A[count]:='f'+NameOf(nome);
                                for i:=1 to count-1 do
                                    if A[count]=A[i] then
                                       begin
                                       dec(count);
                                       break;
                                       end;
                                end;
  continua:
  FindNext(F);
  end;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function CercaFile(nome:tipo1):word;
var i:word;
begin
nome:=upCase(nome);
for i:=1 to count do if UpCase(Copy(A[i],2,255))=nome then Exit(i);
Exit(0);
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function CercaFile2(nome:tipo1):word;
var i:word;
begin
nome:=upCase(nome);
for i:=1 to count do if UpCase(Copy(A[i],2,length(nome)))=nome then Exit(i);
Exit(0);
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure FindAllFiles(percorso,ifiles:string; all:boolean);
var testa,coda:string;   {casi speciali in cui ifiles= '' *. .* . }
    F: SearchRec;
label continua2;

begin
if copy(ifiles,length(ifiles),1)=';' then ifiles:=copy(ifiles,1,length(ifiles)-1);
if ifiles='' then ifiles:='*.*';
testa:=ifiles;
while (testa<>'') do
          begin
          Testa_Coda(testa,';',testa,coda);
          if testa[1]=';' then delete(testa,1,1);
          if (testa=';')or(testa='') then testa:='*.*';
          if copy(testa,1,1)='.' then testa:='*'+testa;
          if copy(testa,posRL('.',testa,255)+1,1)='' then testa:=testa+'*';
          FindFiles2(percorso+testa,all);
          testa:=coda;
          end;

FindFirst(percorso+'*.*', directory, F);
while (DosError = 0) and (Count < Maxx) do
         begin
         if f.name[1]='.' then goto continua2;
         if all=false then if ((f.attr and hidden)<>0)or((f.attr and sysfile)<>0) then
                           goto continua2;
         if (f.attr and directory) <>0  then
                                        begin
                                        Inc(Count);
                                        f.name:=percorso+f.name;
                                        GetshortName(f.name);
                                        A[count]:='D'+nameof(f.name);
                                        end;
         continua2:
         FindNext(F);
         end;
if count<maxx then
              begin
              inc(count);
              A[count]:='D.';
              end
             else A[1]:='D.';
if not ( (length(percorso)=3)and(percorso[3]='\')and(percorso[2]=':')and(UpCase(percorso[1]) in ['A'..'Z']) ) then
   if count<maxx then
                 begin
                 if (copy(percorso,1,2)='\\') then
                    if conta('\',copy(percorso,3,255),1,true)<=2 then Exit;
                 inc(count);
                 A[count]:='D..';
                 end
                else A[2]:='D..';
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure YellowZona;
var str:string[14];
begin
str:=copy(copy(A[iesimo],2,255),1,12);
if A[iesimo][1]='D' then str:=str+'\';
while length(str)<13 do str:=str+' ';
{$ifdef dos}
textbackground(3);
textcolor(yellow);
gotoxy(X+4,Y+5+selezionato);
write(str);
{$endif}
{$ifdef win}
outtextxy(x+3,y+4+selezionato,str,255,3,yellow);
{$endif}
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure NonTrovato;
begin
textcolor(white);
textbackground(3);
gotoxy(x+20,y+17);
case DosError of    // *** i messaggi non saranno visibili
     3:    write('Percorso non trovato.');
     2,18: write('File non trovato.');
     end;
{$ifdef Dos}
sound(300);
delay2(0);
nosound;
{$endif}
Tast_Vuota;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure BarraV(const topo:boolean; var pos_barraV:byte);
var i:word;
    {$ifdef dos}
    str:string;
    {$endif}
    old_pos_barraV:byte;
begin
if topo then HideMouse;
i:=count div 11;
if i<>0 then i:=iesimo div i;
i:=i+2;
if i>12 then i:=12;
if iesimo=1 then i:=2;
old_pos_barraV:=pos_barraV;
if Y+5+i<>old_pos_barraV then
        begin
        pos_barrav:=Y+5+i;
        {$ifdef dos}
        str:='';
        for i:=2 to 12 do str:=str+''+#10+#8;
        gotoxy(X+18,Y+7);
        write(str);
        gotoxy(X+18,pos_barraV);
        textbackground(black+7);
        textcolor(black);
        write(#9);
        {$endif}
        {$ifdef win}
        for i:=0 to 10 do outtextxy(x+17,y+6+i,'',255,3,white);
        outtextxy(x+17,pos_barrav-1,#9,255,black+7,black);
        updatescreen(false);
        {$endif}
        end;
if topo then showmouse;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure Dettagli(const topo:boolean; var pos_barraV:byte; const ifiles:string);
var dt : DateTime;      {UnpackTime }
    F: SearchRec;
    nome,str:string;
    {$ifdef dos}
    i:byte;
    {$endif}
begin
nome:=PathOf(percorso)+nomefile;
GetshortName(nome);
FindFirst(nome, Anyfile, F);
if (doserror<>0) or  ( (nomefile='.') and (length(nome)=3) and (nome[2]=':') and ( upcase(nome[1]) in ['A'..'Z'] ) and (nome[3]='\') ) then
                 begin
                 f.time:=0;
                 f.attr:=directory;
                 f.size:=0;
                 DosError:=0;
                 end;

if topo then HideMouse;
cursoroff;
if DosError<>0 then NonTrovato;
{$ifdef dos}
if DosError=0 then if Char_VideoXY(x+20,y+17) in ['T',' '] then else
                      begin
                      textbackground(3);
                      gotoxy(x+20,y+17);
                      write('                     ');
                      end;
textbackground(3);
textcolor(blue);
gotoxy(X+10,Y+2);
if A[iesimo][1]<>'D' then write(copy(nomefile,1,36))
                     else write(copy(nomefile+'\'+ifiles,1,36));
str:='';
for i:=wherex to X+45 do str:=str+' ';
write(str);
textcolor(0);
gotoxy(X+20,Y+8);
write('Attributi: ');
{$endif}
{$ifdef win}
if DosError=0 then
   if GetCharXY(x+19,y+16) in ['T',' '] then
           else outtextxy(x+19,y+16,'                     ',255,3,255);

if A[iesimo][1]<>'D' then str:=copy(nomefile,1,36)
                     else str:=copy(nomefile+'\'+ifiles,1,36);
while length(str)<36 do str:=str+' ';
outtextxy(x+9,y+1,str,255,3,blue);
outtextxy(x+19,y+7,'Attributi: ',255,3,0);
{$endif}
if DosError=0 then
   begin
   if (f.attr and archive)  <>0 then str:='A'     else str:='_';
   if (f.attr and readonly) <>0 then str:=str+'R' else str:=str+'_';
   if (f.attr and hidden)   <>0 then str:=str+'H' else str:=str+'_';
   if (f.attr and sysfile)  <>0 then str:=str+'S' else str:=str+'_';
   if (f.attr and directory)<>0 then str:=str+'D' else str:=str+'_';
   end
  else str:='???? ';
{$ifdef dos}
textcolor(white);
write(str);
textcolor(0);
str:='';
for i:=wherex to X+49 do str:=str+' ';
write(str);

gotoxy(X+20,Y+9);
write('Byte: ');
textcolor(white);
gotoxy(X+26,Y+9);
if DosError=0 then if (f.attr and directory)<>0 then write('_')
                                                else write(Dim_punto(f.size))
              else write('?');
str:='';
for i:=wherex to X+49 do str:=str+' ';
write(str);

UnpackTime(f.time,dt);
textcolor(0);
gotoxy(X+20,Y+10);
write('Data: ');
textcolor(white);
if DosError=0 then
              begin
              str:='';
              if dt.day<10 then str:='0';
              str:=str+inttostr(dt.day)+'/';
              if dt.month<10 then str:=str+'0';
              str:=str+inttostr(dt.month)+'/';
              if dt.year<10 then str:=str+'0';
              str:=str+inttostr(dt.year);
              end
             else str:='??/??/????';
write(str);
gotoxy(X+20,Y+11);
textcolor(0);
write('Ora : ');
textcolor(white);
if DosError=0 then
   begin
   str:='';
   if dt.hour<10 then str:='0';
   str:=str+inttostr(dt.hour)+':';
   if dt.min<10 then str:=str+'0';
   str:=str+inttostr(dt.min)+':';
   if dt.sec<10 then str:=str+'0';
   str:=str+inttostr(dt.sec);
   end
  else str:='??:??:??';
write(str);

gotoxy(X+20,Y+12);
textcolor(0);
write('LFN : ');
nome:=fexpand2(nome);
GetLongName(nome);
textcolor(white);
gotoxy(X+26,Y+12);
write(copy(nome,1,23));
str:='';
for i:=wherex to X+49 do str:=str+' ';
write(str);

gotoxy(X+20,Y+13);
write(copy(nome,24,29));
str:='';
for i:=wherex to X+49 do str:=str+' ';
write(str);

gotoxy(X+20,Y+14);
write(copy(nome,53,29));
str:='';
for i:=wherex to X+49 do str:=str+' ';
write(str);

gotoxy(X+20,Y+15);
write(copy(nome,82,29));
str:='';
for i:=wherex to X+49 do str:=str+' ';
write(str);

gotoxy(X+20,Y+16);
write(copy(nome,111,29));
str:='';
for i:=wherex to X+49 do str:=str+' ';
write(str);

gotoxy(X+20,Y+17);
write(copy(nome,140,29));
str:='';
for i:=wherex to X+49 do str:=str+' ';
write(str);

gotoxy(X+20,Y+18);
write(copy(nome,169,29));
str:='';
for i:=wherex to X+49 do str:=str+' ';
write(str);

gotoxy(X+20,Y+19);
write(copy(nome,198,29));
str:='';
for i:=wherex to X+49 do str:=str+' ';
write(str);

gotoxy(X+20,Y+20);
write(copy(nome,227,29));
str:='';
for i:=wherex to X+49 do str:=str+' ';
write(str);
{$endif}
{$ifdef win}
outtextxy(x+30,y+7,str,255,3,white);
outtextxy(X+19,Y+8,'Byte: ',255,3,0);
if DosError=0 then if (f.attr and directory)<>0 then outtextxy(X+25,Y+8,'_',255,3,white)
                                                else outtextxy(X+25,Y+8,Dim_punto(f.size),255,3,white)
              else outtextxy(X+25,Y+8,'?',255,3,white);
UnpackTime(f.time,dt);
outtextxy(X+19,Y+9,'Data: ',255,3,0);
if DosError=0 then
              begin
              str:='';
              if dt.day<10 then str:='0';
              str:=str+inttostr(dt.day)+'/';
              if dt.month<10 then str:=str+'0';
              str:=str+inttostr(dt.month)+'/';
              if dt.year<10 then str:=str+'0';
              str:=str+inttostr(dt.year);
              end
             else str:='??/??/????';
outtextxy(X+25,Y+9,str,255,3,white);
outtextxy(X+19,Y+10,'Ora : ',255,3,0);
if DosError=0 then
   begin
   str:='';
   if dt.hour<10 then str:='0';
   str:=str+inttostr(dt.hour)+':';
   if dt.min<10 then str:=str+'0';
   str:=str+inttostr(dt.min)+':';
   if dt.sec<10 then str:=str+'0';
   str:=str+inttostr(dt.sec);
   end
  else str:='??:??:??';
outtextxy(x+25,y+10,str,255,3,white);
WindowsStr(x+19,y+11,x+47,y+19,' ',255,3,white);
outtextxy(X+19,Y+11,'LFN : ',255,3,0);
nome:=fexpand2(nome);
GetLongName(nome);
outtextxy(X+25,Y+11,copy(nome,1,23),255,3,white);
outtextxy(X+19,Y+12,copy(nome,24,29),255,3,white);
outtextxy(X+19,Y+13,copy(nome,53,29),255,3,white);
outtextxy(X+19,Y+14,copy(nome,82,29),255,3,white);
outtextxy(X+19,Y+15,copy(nome,111,29),255,3,white);
outtextxy(X+19,Y+16,copy(nome,140,29),255,3,white);
outtextxy(X+19,Y+17,copy(nome,169,29),255,3,white);
outtextxy(X+19,Y+18,copy(nome,198,29),255,3,white);
outtextxy(X+19,Y+19,copy(nome,227,29),255,3,white);
updatescreen(false);
{$endif}
cursoron;
if topo then showmouse;
BarraV(topo,pos_barraV);
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure Mostra(primo:word);
var s:string;
    i:word;
begin
{$ifdef dos}
textbackground(3);  {*** la stampa}
textcolor(blue);
{$endif}
for i:=primo to 12+primo do
    begin
    if i<=count then
                begin
                s:=copy(copy(A[i],2,255),1,12);
                if A[i][1]='D' then s:=s+'\';
                end
               else s:='            ';
    while length(s)<13 do s:=s+' ';
    {$ifdef dos}
    gotoxy(X+4,Y+i+1-primo+5);
    write(s);
    {$endif}
    {$ifdef win}
    outtextxy(X+3,Y+i-primo+5,s,255,3,blue);
    {$endif}
    end;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

procedure GreenZona(const topo:boolean);   {*** da aggiornare quello selezionato}
var str:string;
    i:byte;
begin
str:=copy(copy(A[iesimo],2,255),1,12);
if A[iesimo][1]='D' then str:=str+'\';
for i:=length(str) to 12 do str:=str+' ';
nomefile:=copy(A[iesimo],2,255);
gotoxy(X+4,Y+selezionato+5);
{$ifdef dos}
if topo then hidemouse;
textbackground(green);
textcolor(white);
write(str);
if topo then showmouse;
{$endif}
{$ifdef win}
outtextxy(X+3,Y+selezionato+4,str,255,green,white);
updatescreen(false);
{$endif}
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function SfogliaFile(XX,YY:byte; all,ordina,topo:boolean; testo,percorso_:string; var ifiles:string; CD:byte):string;
var stato:byte;  {0= Nome | 1= Lista | 2= OK | 3= ESCI}  { CD= click delay}
    i,primo:word;
    mox,moy,tasto,posto,pos_barraV,ii,iii,x_:byte;
    c:char;
    str,stringa:string;
    scrivo:tipo1;
    insert:boolean;

label next2,next,restart,escoReadStr,readStr,giu,iniziocase,alt_l;
begin
if cd>100 then cd:=100;
percorso:=percorso_;
if pos('\',ifiles)<>0 then Exit('');
insert:=false;
stato:=0;
scrivo:='';
if XX>31 then XX:=31;
if XX=0  then XX:=1;
if YY>5 then YY:=5;
if YY=0 then YY:=1;
X:=XX;
Y:=YY;
if length(testo)>49 then testo[0]:=#49;
restart:

percorso:=fexpand2(percorso);
{$I-}
chdir(percorso);
{$I-}
if IOResult <> 0 then;
if percorso[length(percorso)]<>'\' then percorso:=percorso+'\';
Count:=0;
pos_barraV:=0;
{$ifdef dos}
gotoxy(X,Y);
textbackground(white);
str:='';
for ii:=1 to 50 do str:=str+' ';
write(str);
textcolor(black);
gotoxy(25+X-(length(testo)div 2),Y);
write(testo);
textbackground(3);
for ii:=Y+1 to Y+20 do
    begin
    gotoxy(X,ii);
    write(str);
    end;
gotoxy(X,Y+2);
write('   Nome: [                                    ]');
gotoxy(X+3,Y+2);
textcolor(white);
write('N'+#10+#10+#8+'L');
textcolor(black);
gotoxy(X+4,Y+4);
write('ista:');
gotoxy(X+3,Y+20);
write('File:');
gotoxy(X+3,Y+5);
write('Ŀ');

str:='';
for i:=1 to 13 do str:=str+''+#10+#8;
gotoxy(x+3,y+6);
write(str);

str:='';
for i:=1 to 13 do str:=str+''+#10+#8;
gotoxy(x+18,y+6);
write(str);

gotoxy(X+3,Y+19);
write('');
textbackground(3);
textcolor(white);
gotoxy(X+9,Y+20);
if length(ifiles)<10 then write(Copy(ifiles,1,9)+'             ')
                     else write(Copy(ifiles,1,6)+'...             ');
gotoxy(X+18,Y+6);
write(#24);
gotoxy(X+18,Y+18);
write(#25);
textbackground(lightgreen);
gotoxy(X+24,Y+6);
write('   Ok   ');
gotoxy(X+37,Y+6);
write('  Esci  ');              {grafica finita}
{$endif}
{$ifdef win}
outtextxy(x-1,y-1,' ',255,7,black,50);
outtextxy(24+X-(length(testo)div 2),Y-1,testo,255,7,black);
for ii:=Y+1 to Y+20 do
                    begin
                    ForceUpdateXY(x-1,ii-1,50);
                    outtextxy(x-1,ii-1,' ',255,3,black,50);
                    end;
outtextxy(x-1,y+1,'   Nome: [                                    ]',255,255,255);
outtextxy(x+2,y+1,'N',255,255,white);
outtextxy(x+2,y+3,'L',255,255,white);
outtextxy(x+3,y+3,'ista',255,255,black);
outtextxy(x+2,y+19,'File:');
outtextxy(x+2,y+4,'Ŀ');
for i:=1 to 13 do outtextxy(x+2,y+4+i,'');
for i:=1 to 13 do outtextxy(x+17,y+4+i,'');
outtextxy(x+2,y+18,'');
if length(ifiles)<10 then outtextxy(x+8,y+19,Copy(ifiles,1,9)+'             ',255,3,white)
                     else outtextxy(x+8,y+19,Copy(ifiles,1,6)+'...             ',255,3,white);
outtextxy(x+17,y+5,#24,255,3,white);
outtextxy(x+17,y+17,#25,255,3,white);
outtextxy(x+23,y+5,'   Ok   ',255,2,white);
outtextxy(x+36,y+5,'  Esci  ',255,2,white);          {grafica finita}
{$endif}

c:=#1;                          {inizializzo e cerco}
nomefile:=NameOf(ifiles);
iesimo:=1;  {a cui punta}
primo:=1;   {in alto}
selezionato:=1;

{$ifdef dos}
textbackground(11);
gotoxy(X+22,y+12);
write('Ricerca files in corso... '+#8);  // si pulisce da solo con NFL
{$endif}
{$ifdef win}
outtextxy(x+21,y+11,'Ricerca files in corso... ',255,255,white);  // si pulisce da solo con NFL
setCursorpos(x+46,y+11);
updatescreen(false);
{$endif}

FindAllFiles(percorso,ifiles,all);
if ordina then
          begin
          app:=CercaFile('.');
          A[app]:=A[1];
          A[1]:='D.';
          app:=CercaFile('..');
          if app>0 then
                   begin
                   A[app]:=A[2];
                   A[2]:='D..';
                   QuickSort(A,3,count);
                   end
                  else QuickSort(A,2,count); {era la root: non ha radice}
          end;
for i:=count+1 to maxx do A[i]:='';
posto:=length(A[1]);
x_:=posto;
{$ifdef dos}
gotoxy(X+19,Y+4);
textcolor(white);
textbackground(3);
write(dim_punto(count));
textcolor(black);
write(' elementi trovati     ');
{$endif}
{$ifdef win}
outtextxy(x+18,y+3,dim_punto(count),255,255,white);
outtextxy(x+18+length(dim_punto(count)),y+3,' elementi trovati     ',255,255,black);
updatescreen(false);
{$endif}

if count=maxx then
   begin
   if (length(percorso)>3)and(a[1]<>'D.') then
      begin
      a[1]:='D.';
      a[2]:='D..';
      end;
   {$ifdef dos}
   textcolor(white);
   textbackground(3);
   gotoxy(x+20,y+9);
   write('Troppi files nella directory:');
   gotoxy(x+20,y+10);
   write('ve ne sono pi di ',dim_punto(maxx));
   gotoxy(x+20,y+12);
   write('Alcuni non postranno essere');
   gotoxy(x+20,y+13);
   write('visualizzati.');
   gotoxy(x+20,y+15);
   write('Premere su  OK  o  ESC');
   gotoxy(x+20,y+16);
   write('per continuare ... ');
   gotoxy(wherex-1,wherey);
   {$endif}
   {$ifdef win}
   outtextxy(x+19,y+8,'Troppi files nella directory:',255,255,white);
   outtextxy(x+19,y+9,'ve ne sono pi di '+dim_punto(maxx),255,255,white);
   outtextxy(x+19,y+11,'Alcuni non postranno essere',255,255,white);
   outtextxy(x+19,y+12,'visualizzati.',255,255,white);
   outtextxy(x+19,y+14,'Premere su  OK  o  ESC',255,255,white);
   outtextxy(x+19,y+15,'per continuare ... ',255,255,white);
   setcursorpos(x+37,y+15);
   updatescreen(false);
   {$endif}
   {$ifdef DOS}
   sound(300);
   delay2(0);
   nosound;
   if topo then showMouse;
   {$endif}
   Tast_Vuota;
   repeat
    if keypressed or not topo then
                  case ReadKey of
                       #13,#27,#32 : Break;
                       #0          : ReadKey;
                       end
                  else // topo==true
                   begin
                   rilascio(mox,moy,tasto);
                   if (tasto=1)and(moy=Y+6)and(mox>X+23)and(mox<X+32) then Break; {OK}
                   if (tasto=1)and(moy=Y+6)and(mox>X+36)and(mox<X+45) then Break; {ESCI}
                   end;
   until false;
   end;
if topo then hidemouse;
Mostra(primo);
if topo then showmouse;
nomefile:=Copy(A[1],2,255);  {serve solo per dettagli della riga successiva}
Dettagli(topo,pos_barraV,ifiles);
nomefile:=NameOf(ifiles);
GreenZona(topo);
gotoxy(X+4,Y+selezionato+5);
repeat
if stato=0 then
           begin
           YellowZona;
           {$ifdef dos}
           textbackground(green);
           gotoxy(X+24,Y+6);
           write(' ');
           gotoxy(X+31,Y+6);
           write(' ');
           gotoxy(X+37,Y+6);
           write(' ');
           gotoxy(X+44,Y+6);
           write(' ');
           gotoxy(x+10,y+2);
           textbackground(3);
           textcolor(blue);
           {$endif}
           {$ifdef win}
           outtextxy(X+23,Y+5,' ',255,green,255);
           outtextxy(X+30,Y+5,' ',255,green,255);
           outtextxy(X+36,Y+5,' ',255,green,255);
           outtextxy(X+43,Y+5,' ',255,green,255);
           gotoxy(x+10,y+2);
           setcursorpos(x+9,y+1);
           updatescreen(false);
           textbackground(3);
           textcolor(blue);
           {$endif}
           readStr:
           scrivo:='';
           if topo then showmouse;
           if insert then CursorBig else cursorOn;
           posto:=min(length(nomefile+'\'+ifiles)+1,254);
           x_:=posto+1;
           if A[iesimo][1]='D' then
                                begin
                                stringa:=nomefile;
                                nomefile:=ReadString2(nomefile+'\'+ifiles,X+10,X+46,0,topo,true,insert,moy,mox,posto,x_)
                                end
                               else
                                begin
                                stringa:=nomefile;
                                nomefile:=ReadString2(nomefile,X+10,X+46,0,topo,true,insert,moy,mox,posto,x_);
                                end;
           if (nomefile='') and
              ( ((mox=13)and(moy=0)) or ((moy=Y+6)and(mox>X+23)and(mox<X+32)) ) then
                           begin
                           nomefile:=stringa;
                           goto readStr;
                           end;
           if (upcase(percorso[1]) in ['A'..'Z']) and (percorso[2]=':') and
              (percorso[3]='\') and (nomefile='\') then
              begin
              percorso:=percorso[1]+':\';
              goto restart;
              end;
           if (exist(ExpandEnvironment(percorso+nomefile))>-1) or isdir(ExpandEnvironment(percorso+nomefile)) then
                                                                                                              else nomefile:=fexpand2(nomefile);
           cursoron;
           if (mox=27)and(moy=0) then Exit(''); {ESC 2 volte esce totalmente}
           if (mox=13)and(moy=0) then       {INVIO}
               begin
               next:  {emula INVIO quando si preme su OK}
               stringa:=fExpand2(percorso+nomefile); {'\\' finali deve dare la root}
               if (stringa[length(stringa)]='\')and(length(stringa)>1)and
                  (stringa[length(stringa)-1]='\') then stringa:=Copy(stringa,1,2)+'\'; {U:\}
               if nomefile='.' then
                               begin
                               if topo then showMouse;
                               Continue;
                               end;
               ii:=pos('*',nomefile);
               if ii=0 then ii:=255;
               iii:=pos('?',nomefile);
               if iii=0 then iii:=255;
               ii:=Trunc(min(ii,iii));
               if posrl('\',nomefile,length(nomefile))<ii then
               if (pos('*',nomefile)>0)or(pos('?',nomefile)>0) then {l'input era una directory + files}
                   begin
                   stato:=0;
                   if (Copy(nomefile,2,1)=':')or(Copy(nomefile,1,1)='\') then
                                                                         else nomefile:=fexpand2(percorso+nomefile);
                   percorso:=copy(nomefile,1,posrl('\',nomefile,255));
                   ifiles:=copy(nomefile,posrl('\',nomefile,length(nomefile))+1,255);
                   goto restart;
                   end;
               if posrl('\',nomefile,length(nomefile))>ii then Exit(fExpand2(nomefile));
               if Exist(stringa)>=0 then Exit(fExpand2(stringa)); {era un file}
               if isDir(stringa) then  {era una directory}
                  begin
                  stato:=1;
                  percorso:=stringa;
                  goto restart;
                  end;
               stringa:=fExpand2(nomefile);
               if Exist(stringa)>=0 then Exit(fExpand2(stringa)); {l'input era un file}
               if isDir(stringa) then  {l'input era una directory}
                  begin
                  stato:=1;
                  percorso:=stringa;
                  goto restart;
                  end;
               if (Copy(nomefile,2,1)=':')or(Copy(nomefile,1,1)='\') then
                   SfogliaFile:=fExpand2(nomefile)
                  else
                   SfogliaFile:=fExpand2(percorso+nomefile);
               Exit;  {qualunque cosa sia, esce: potrebbe crearla (salva) }
               end;
           if (mox=9)and(moy=0) then       {TAB}
              begin
              stato:=1;
              GreenZona(topo);
              {$ifdef dos}
              textbackground(3);           {aggiorno il readstring}
              textcolor(blue);
              gotoxy(X+9,Y+2);
              if A[iesimo][1]<>'D' then write(copy('['+nomefile,1,36))
                                   else write(copy('['+nomefile+'\'+ifiles,1,36));
              str:='';
              for i:=wherex to X+45 do str:=str+' ';
              write(str+']');
              {$endif}
              {$ifdef win}                   {aggiorno il readstring}
              if A[iesimo][1]<>'D' then str:='['+copy(nomefile,1,36)
                                   else str:='['+copy(nomefile+'\'+ifiles,1,36);
              while length(str)<>37 do str:=str+' ';
              outtextxy(x+8,y+1,str+']',255,3,blue);
              updatescreen(false);
              {$endif}
              gotoxy(X+4,Y+selezionato+5);
              if topo then showmouse;
              end;
           if (moy=255)and(mox=38) then
              begin               {ALT +L}
   ALT_L:
              stato:=1;
              GreenZona(topo);
              c:=#1;
              {$ifdef dos}
              textbackground(3);
              textcolor(blue);
              gotoxy(X+9,Y+2);
              write('['+copy(nomefile,1,36));
              str:='';
              for i:=wherex to X+45 do str:=str+' ';
              write(str+']');
              gotoxy(X+4,Y+selezionato+5);
              {$endif}
              {$ifdef win}
              str:='['+copy(nomefile,1,36);
              while length(str)<>37 do str:=str+' ';
              outtextxy(X+8,Y+1,str+']',255,3,blue);
              updatescreen(false);
              {$endif}
              end;
           if  ( (mox=X+18)and(moy>Y+5)and(moy<Y+19)and(count>13) )or
               ( (mox>X+3)and(mox<X+17)and(moy>Y+5)and(moy<Y+19) ) then
                             goto next2;   {area lista files e freccine}
           if (moy>0)and(moy<26) then {mouse che clicca fuori da readstring}
              begin
              tasto:=1;
              goto escoReadStr;
              end;
           end;
if KeyPressed or not topo then c:=Readkey
              else
               begin
               {$ifdef DOS}
               Rilascio(mox,moy,tasto);
               {$endif}
               escoReadStr:
               if tasto=1 then
                  begin
                  if (moy=Y+6)and(mox>X+36)and(mox<X+45) then Exit(''); {ESCI}
                  if (moy=Y+6)and(mox>X+23)and(mox<X+32) then  {OK}
                     case stato of
                        1,2: begin
                             c:=#13;
                             stato:=1;
                             cursoron;
                             end;
                          3: begin
                             {$ifdef dos}
                             gotoxy(X+37,Y+6);
                             write(' ');
                             gotoxy(X+44,Y+6);
                             write(' ');
                             {$endif}
                             {$ifdef win}
                             outtextxy(x+36,y+5,' ');
                             outtextxy(x+43,y+5,' ');
                             updatescreen(false);
                             {$endif}
                             GreenZona(topo);
                             gotoxy(X+4,Y+selezionato+5);
                             c:=#13;
                             stato:=1;
                             cursoron;
                             end;
                          0: goto Next;
                          end; {del case}
                  end;
               {$ifdef DOS}
               RilascioDestra(mox,moy,tasto); {conferma l' apertura}
               {$endif}
               {$ifdef Win}
               tasto:=0;
               {$endif}
               if (tasto=1)and(stato=1)and(count>0)
                  and(selezionato=moy-Y-5) then goto next;
               Click(mox,moy,tasto);
               if tasto=1 then      {Gestione mouse}
                  begin
                  Next2: {esce da readstring e controlla area file e freccine}
                  if (moy=Y+2)and(mox>X+9)and(mox<X+46) then
                     begin
                     stato:=0;
                     Continue;            {ritorna al readstring}
                     end;
                  if (mox=(X+18)) and (moy=(Y+6)) then  {freccina alta}
                                                  begin
                                                  stato:=1;
                                                  c:=#72;
                                                  delay2(CD);
                                                  goto iniziocase;
                                                  end;
                  if (mox=(X+18)) and (moy=(Y+18)) then {freccina bassa}
                                                  begin
                                                  stato:=1;
                                                  c:=#80;
                                                  delay2(CD);
                                                  goto iniziocase;
                                                  end;
                  if (mox=X+18)and(moy>Y+6)and(moy<Y+18)and(count>21) then
                     begin  {barra}
                     stato:=1;
                     i:=count div 11;
                     if i<>0 then i:=iesimo div i;
                     i:=i+2;
                     if i>12 then i:=12;
                     if iesimo=1 then i:=2;
                     if i+y+5<>moy then
                        begin
                        iesimo:=(count div 11)*(moy-7-y)+2;
                        primo:=iesimo;
                        posto:=length(A[iesimo]);
                        selezionato:=1;
                        mostra(primo);
                        dettagli(topo,pos_barraV,ifiles);
                        c:=#72;
                        goto iniziocase;
                        end;
                     end;
                  if (mox>X+3)and(mox<X+17)and(moy>Y+5)and(moy<Y+19) then
                     if (count>0) then
                        begin {file selezionato}
                        if stato<>1 then
                                    begin
                                    {$ifdef dos}
                                    textbackground(green);
                                    gotoxy(X+24,Y+6);
                                    write(' ');
                                    gotoxy(X+31,Y+6);
                                    write(' ');
                                    gotoxy(X+37,Y+6);
                                    write(' ');
                                    gotoxy(X+44,Y+6);
                                    write(' ');
                                    {$endif}
                                    {$ifdef win}
                                    outtextxy(x+23,y+5,' ',255,green,255);
                                    outtextxy(x+30,y+5,' ',255,green,255);
                                    outtextxy(x+36,y+5,' ',255,green,255);
                                    outtextxy(x+43,y+5,' ',255,green,255);
                                    updatescreen(false);
                                    {$endif}
                                    end;
                        cursoron;
                        ii:=moy-Y-5;
                        if (selezionato=ii)and(stato=1) then Continue;
                        stato:=1;
                        if selezionato>ii then   {verso sopra}
                               begin
                               str:=copy(copy(A[iesimo],2,255),1,12);
                               if A[iesimo][1]='D' then str:=str+'\';
                               while length(str)<13 do str:=str+' ';
                               {$ifdef dos}
                               textbackground(3);    {*** da aggiornare quello selezionato precedentemente}
                               textcolor(blue);
                               gotoxy(X+4,Y+selezionato+5);
                               write(str);
                               {$endif}
                               {$ifdef win}          {*** da aggiornare quello selezionato precedentemente}
                               outtextxy(X+3,Y+selezionato+4,str,255,3,blue);
                               updatescreen(false);
                               {$endif}
                               iesimo:=iesimo-(selezionato-ii);
                               posto:=length(A[iesimo]);
                               selezionato:=ii;
                               end
                              else if count<>iesimo then
                               begin  {verso sotto}  {*** da aggiornare quello selezionato precedentemente}
                               str:=copy(copy(A[iesimo],2,255),1,12);
                               if A[iesimo][1]='D' then str:=str+'\';
                               while length(str)<13 do str:=str+' ';
                               {$ifdef dos}
                               textbackground(3);
                               textcolor(blue);
                               gotoxy(X+4,Y+selezionato+5);  {*** da aggiornare quello selezionato}
                               write(str);
                               {$endif}
                               {$ifdef win}                  {*** da aggiornare quello selezionato}
                               outtextxy(X+3,Y+selezionato+4,str,255,3,blue);
                               updatescreen(false);
                               {$endif}
                               if count-primo>=ii then
                                                  begin
                                                  selezionato:=ii;
                                                  iesimo:=primo+selezionato-1;
                                                  end
                                                 else
                                                  begin
                                                  selezionato:=count-primo+1;
                                                  iesimo:=count;
                                                  end;
                               posto:=length(A[iesimo]);
                               end;
                        GreenZona(topo);
                        Dettagli(topo,pos_barraV,ifiles);
                        gotoxy(X+4,Y+selezionato+5);
                        end;
                  end;
               if stato=0 then
                          begin
                          nomefile:=stringa;
                          goto readStr;
                          end;
               end;
if c=#0 then
        begin
        c:=ReadKey;
        iniziocase:
        if ord(c) in [71,79,81,77,80,72,73,75] then scrivo:='';
        if ( stato in [1..3] ) and (ord(c)=49) then { ALT + N }
           begin
           stato:=0;
           Continue;
           end;
        if ( (stato=2) or (stato=3) ) and (ord(c)=38) then
                 begin { ALT + L }
                 {$ifdef dos}
                 if stato=2 then gotoxy(X+24,Y+6)
                            else gotoxy(X+37,Y+6);
                 write(' ');
                 if stato=2 then gotoxy(X+31,Y+6)
                            else gotoxy(X+44,Y+6);
                 write(' ');
                 {$endif}
                 {$ifdef win}
                 if stato=2 then outtextxy(X+23,Y+5,' ')
                            else outtextxy(X+36,Y+5,' ');
                 if stato=2 then outtextxy(X+30,Y+5,' ')
                            else outtextxy(X+43,Y+5,' ');
                 updatescreen(false);
                 {$endif}
                 cursorOn;
                 moy:=255;
                 goto ALT_L;
                 end;
        if (count>0)and(stato=1) then
        case ord(c) of
             71: if iesimo>1 then     { inizio }
                             begin
                             iesimo:=1;
                             primo:=1;
                             selezionato:=1;
                             Mostra(primo);
                             GreenZona(topo);
                             Dettagli(topo,pos_barraV,ifiles);
                             gotoxy(X+4,Y+6);
                             posto:=length(A[iesimo]);
                             end;
             79: if iesimo<count then     { fine }
                    begin
                    iesimo:=count;
                    primo:=(count div 13) *13 +1;
                    selezionato:=count mod 13;
                    if selezionato=0 then
                                     begin
                                     selezionato:=13;
                                     primo:=primo-13;
                                     end;
                    Mostra(primo);
                    GreenZona(topo);
                    Dettagli(topo,pos_barraV,ifiles);
                    gotoxy(X+4,Y+selezionato+5);
                    posto:=length(A[iesimo]);
                    end;
          81,77: if (iesimo<count-12)and(count>13) then  { pag giu' | destra }
                    begin
                    iesimo:=iesimo+13;
                    primo:=primo+13;
                    if iesimo>count then iesimo:=count;
                    if primo>count then
                                begin
                                selezionato:=selezionato-(count-primo)-1;
                                primo:=count;
                                end;
                    Mostra(primo);
                    dec(iesimo);
                    dec(selezionato);
                    posto:=length(A[iesimo]);
                    goto giu;
                    end
                   else
                    begin
                    c:=#79;
                    goto iniziocase;
                    end;
             80: if iesimo<count then  { giu' }
                    begin                             Giu:
                    inc(iesimo);
                    if selezionato<13 then inc(selezionato)
                                     else
                                      begin
                                      inc(primo);
                                      Mostra(primo);
                                      end;
                    GreenZona(topo);
                    if whereY>y+6 then
                       begin     {*** da aggiornare quello selezionato precedentemente}
                       str:=copy(copy(A[iesimo-1],2,255),1,12);
                       if A[iesimo-1][1]='D' then str:=str+'\';
                       while length(str)<13 do str:=str+' ';
                       {$ifdef dos}
                       gotoxy(X+4,Y+selezionato+4);
                       textbackground(3);
                       textcolor(blue);
                       write(str);
                       {$endif}
                       {$ifdef win}
                       outtextxy(X+3,Y+selezionato+3,str,255,3,blue);
                       updatescreen(false);
                       {$endif}
                       posto:=length(A[iesimo]);
                       end;
                    Dettagli(topo,pos_barraV,ifiles);
                    gotoxy(X+4,Y+selezionato+5);
                    end;
             72: if iesimo>1 then   { su }
                    begin
                    dec(iesimo);
                    if selezionato>1 then dec(selezionato)
                                     else
                                      begin
                                      dec(primo);
                                      Mostra(primo);
                                      end;
                    GreenZona(topo);
                    str:=copy(copy(A[iesimo+1],2,255),1,12);
                    if A[iesimo+1][1]='D' then str:=str+'\';
                    while length(str)<13 do str:=str+' ';
                    {$ifdef dos}
                    gotoxy(X+4,Y+selezionato+6);
                    textbackground(3);    {*** da aggiornare quello selezionato precedentemente}
                    textcolor(blue);
                    write(str);
                    {$endif}
                    {$ifdef win}          {*** da aggiornare quello selezionato precedentemente}
                    outtextxy(X+3,Y+selezionato+5,str,255,3,blue);
                    updatescreen(false);
                    {$endif}
                    Dettagli(topo,pos_barraV,ifiles);
                    gotoxy(X+4,Y+selezionato+5);
                    posto:=length(A[iesimo]);
                    end;
          73,75: if iesimo>13 then  { pag su | sinistra }
                    begin
                    iesimo:=max(iesimo-13,0);
                    primo:=max(primo-13,0);
                    if iesimo<13 then
                                 begin
                                 selezionato:=iesimo;
                                 primo:=1;
                                 end;
                    Mostra(primo);
                    dec(iesimo);
                    dec(selezionato);
                    if iesimo=0 then posto:=length(A[1])
                                else posto:=length(A[iesimo]);
                    goto giu;
                    end
                   else
                    begin
                    c:=#71;
                    goto iniziocase;
                    end;
             end; {del case}
        c:=#1;
        end
       else if c<>#1 then {tasto normale}
        begin
        if topo then HideMouse;
        case c of
            #13:  case stato of     {INVIO}
                       3: Exit('');  {ESCI}
                     2,1: begin                  {OK o selezionato}
                          if A[iesimo]='D.' then
                                            begin
                                            if topo then showmouse;
                                            c:=#1;
                                            Continue;
                                            end;
                          cursoron;
                          scrivo:='';
                          if Copy(A[iesimo],1,1)='D' then
                             begin
                             if Copy(A[iesimo],2,255)='..' then
                                  begin
                                  i:=PosRL('\',percorso,length(percorso)-1);
                                  if i>0 then percorso:=Copy(percorso,1,i)
                                         else
                                          begin
                                          if topo then showmouse;
                                          c:=#1;
                                          Continue; {unita' Subst}
                                          end;
                                  end
                                 else percorso:=percorso+nomefile+'\';
                             stato:=1;
                             goto restart;
                             end;
                          if Copy(A[iesimo],1,1)='f' then Exit(fExpand2(percorso+nomefile));
                          end;
                      end;  {del case}
             #9:  begin         {cambia stato con TAB}
                  scrivo:='';
                  inc(stato);
                  if stato>3 then stato:=0;
                  if (stato=3) then
                     begin
                     YellowZona;
                     cursoroff;
                     {$ifdef dos}
                     textbackground(green);
                     textcolor(white);
                     gotoxy(X+24,Y+6);
                     write(' ');
                     gotoxy(X+31,Y+6);
                     write(' ');
                     gotoxy(X+37,Y+6);
                     write('[');
                     gotoxy(X+44,Y+6);
                     write(']');
                     {$endif}
                     {$ifdef win}
                     outtextxy(X+23,Y+5,' ',255,green,white);
                     outtextxy(X+30,Y+5,' ',255,green,white);
                     outtextxy(X+36,Y+5,'[',255,green,white);
                     outtextxy(X+43,Y+5,']',255,green,white);
                     updatescreen(false);
                     {$endif}
                     end;
                  if stato=2 then
                     begin
                     YellowZona;
                     cursoroff;
                     {$ifdef dos}
                     textbackground(green);
                     textcolor(white);
                     gotoxy(X+24,Y+6);
                     write('[');
                     gotoxy(X+31,Y+6);
                     write(']');
                     {$endif}
                     {$ifdef win}
                     outtextxy(X+23,Y+5,'[',255,green,white);
                     outtextxy(X+30,Y+5,']',255,green,white);
                     updatescreen(false);
                     {$endif}
                     end;
                  if stato=1 then
                             begin
                             GreenZona(topo);
                             cursoron;
                             end;
                  if stato=0 then
                     begin
                     c:=#1;   {readstring}
                     Continue;
                     end;
                  end;
            #27:  Exit(''); {tasto ESC}
            #38:  if ALT then  {ALT + L  LISTA}
                     begin
                     scrivo:='';
                     stato:=1;
                     {$ifdef dos}
                     textbackground(green);
                     gotoxy(X+24,Y+6);
                     write(' ');
                     gotoxy(X+31,Y+6);
                     write(' ');
                     gotoxy(X+37,Y+6);
                     write(' ');
                     gotoxy(X+44,Y+6);
                     write(' ');
                     {$endif}
                     {$ifdef win}
                     outtextxy(X+23,Y+5,' ',255,green,255);
                     outtextxy(X+30,Y+5,' ',255,green,255);
                     outtextxy(X+36,Y+5,' ',255,green,255);
                     outtextxy(X+43,Y+5,' ',255,green,255);
                     updatescreen(false);
                     {$endif}
                     GreenZona(topo);
                     gotoxy(X+4,Y+selezionato+5);
                     cursoron;
                     end;
            #49:  if ALT then  {ALT + N  NOME}
                     begin
                     scrivo:='';
                     stato:=0;
                     continue;
                     end;
             end; {del case}
        if (stato=1) then  {in ogni altro stato, azzerarlo}
           begin
           stringa:=scrivo;
           if c=#8 then if length(scrivo)>0 then scrivo[0]:=char(length(scrivo)-1);
           if ord(c) in [32..255] then if length(scrivo)<13 then scrivo:=scrivo+Upcase(c);
           if scrivo<>stringa then
              begin
              i:=CercaFile2(scrivo);
              if (i<>iesimo)and(i>0) then
                 begin
                 iesimo:=i;
                 if iesimo<7 then
                    begin
                    primo:=1;
                    selezionato:=i;
                    end
                   else
                    begin
                    primo:=iesimo-6;
                    selezionato:=iesimo-primo+1;
                    end;
                 Mostra(primo);
                 GreenZona(topo);
                 Dettagli(topo,pos_barraV,ifiles);
                 end;
              if (i=0)and(ord(c) in [32..255]){and(length(scrivo)>length(stringa))}
                     and (length(scrivo)>0) then scrivo[0]:=char(length(scrivo)-1);
              gotoxy(X+4+length(scrivo),Y+selezionato+5);
              end;
           end;
        if topo then showmouse;
        c:=#1;
        end
until false;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function ReadString(stringa:string; Xstart,Xtot,status:byte; topo,avanzate:boolean;
                    var ins:boolean; var lastD,lastU,posto:byte):string;
var i,old_x,{$ifdef dos}mox,moy,mtasto,{$endif}y,x,maxx:byte;
    c:char;
    str:string;

{---------------------------------------------------------------------------}

procedure Tasto(var x:byte; var stringa:string; c:char; Xtot,Xstart:byte; ins:boolean);
begin
if ins then
        if whereX<Xtot then
                       begin
                       stringa[0]:=char(length(stringa)+1);
                       stringa[length(stringa)]:=#0;
                       stringa[x-Xstart+1]:=c;
                       inc(x);
                       if stringa[length(stringa)]=#0 then stringa[0]:=char(length(stringa)-1);;
                       end else
       else { ins=false }
        if length(stringa)+xstart<Xtot then
                       begin
                       Insert(c,Stringa,x-Xstart+1);
                       inc(x);
                       end;
end;

{---------------------------------------------------------------------------}

begin
maxX:=gettextmaxx;                         {status: 0 = normale}
if Xstart=0 then Xstart:=1;                {status: 1 = maiuscolo}
xstart:=min(Xstart,maxX-1);                {status: 2 = minuscolo}
if Xtot=0 then Xtot:=1;                    {status: altro = normale}
xtot:=min(Xtot,maxX-1);

if topo then hidemouse;
if status>2 then status:=0;
gotoxy(xstart,whereY);
write(stringa);
y:=WhereY;
if posto>length(stringa) then posto:=length(stringa)+1;
if posto=0 then posto:=1;
str:='';
for i:=wherex to Xtot do str:=str+' ';
write(str);
x:=Xstart-1+posto;
gotoxy(x,wherey);
old_x:=255;
c:=#1;
if ins then CursorBig
       else CursorOn;
if topo then
        begin
        hidemouse;
        showmouse;
        showmouse;
        showmouse;
        end;
repeat
if KeyPressed or not topo then
   begin
   c:=ReadKey;
   if ord(c)=0 then
      begin
      c:=ReadKey;
      {$ifdef dos}
      if ALT and avanzate then
             begin
             lastU:=ord(c);  {esce alla pressione del tasto ALT + qualcosa}
             lastD:=255;
             c:=#13;
             end;
      {$endif}
      case ord(c) of
           75: if x>Xstart then dec(x);       {K sinistra}
           83: begin
               if x-length(stringa)-xstart=0 then Continue;
               delete(stringa,x-Xstart+1,1);  {S canc}
               old_x:=255; {forza showmouse}
               end;
           79: x:=length(stringa)+Xstart;     {O fine}
           71: x:=Xstart;                     {G inizio}
           77: if x<length(stringa)+Xstart then inc(x);  {M destra}
           82: begin
               ins:=not ins;                  {R insert}
               if ins then CursorBig
                      else CursorOn;
               Continue;
               end;
           72,73,80,81: Continue;
           else
             begin
             {$ifdef win}
             lastU:=ord(c);  {esce alla pressione del tasto ALT + qualcosa}
             lastD:=255;
             c:=#13;
             {$endif}
             {$ifdef dos}
             Continue;
             {$endif}
             end;
           end;
      if ord(c) in [75,79,71,77] then
         begin
         gotoxy(x,y);
         Continue;
         end;
      end
     else  {tasti normali}
      begin
      lastU:=ord(c); {il valore del tasto}
      lastD:=0;
      case status of
           0: ;
           1: c:=UpCase(c);
           2: c:=LowCase(c);
           end;
      case c of
        #27 : if stringa<>'' then
                 begin   {Esc}
                 gotoxy(Xstart,y);
                 str:='';
                 for i:=1 to length(stringa) do str:=str+' ';
                 write(str);
                 stringa:='';
                 x:=Xstart;
                 end
                else c:=#13;
        #32..#255 : begin
                    str:=stringa;
                    Tasto(x,stringa,c,Xtot,Xstart,ins);
                    if str=stringa then continue;
                    end;
        #9: if avanzate then c:=#13;
        #8: if x>Xstart then  {back-space}
                begin
                dec(x);
                Delete(stringa,x-Xstart+1,1);
                end
               else Continue;
        end;
      end;
   gotoxy(Xstart,y);
   write(stringa);
   if whereX<80 then write(' ');
   gotoxy(x,y);
   if topo then hidemouse;
   if topo then showmouse;
   end
  else  {not keypressed}
   if topo then
       begin
       {$ifdef dos}
       Rilascio(mox,moy,mtasto);
       if mtasto=1 then
          begin
          if moy=y then
             if (mox>=xstart)and(mox<=xstart+length(stringa)-1) then x:=mox else
                if mox<=xtot then if mox>=length(stringa)+xstart then x:=xstart+length(stringa);
          if avanzate and ( (moy<>y)or(x>mox)or(mox>xtot) ) then
             begin
             c:=#13;
             lastU:=mox;
             lastD:=moy;
             Break;
             end;
          end;
       {$endif}
       end;
if x<>old_x then
          begin
          old_x:=x;
          gotoxy(x,y);
          if topo then showmouse;
          end;
until c=#13;
posto:=wherex-xstart+1;
ReadString:=stringa;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

function ReadString2(stringa:string; Xstart,Xtot,status:byte; topo,avanzate:boolean;
                    var ins:boolean; var lastD,lastU,cursore_,x_:byte):string;
var old_x,{$ifdef dos}diff,mox,moy,mtasto,{$endif}y,maxx:byte;
    c:char;
    old_str_app,str_app:string;
    quadra:boolean;

{---------------------------------------------------------------------------}

procedure Tasto(var x,x_:byte; var stringa:string; c:char; Xtot:byte; ins:boolean);
begin
if ins and (x_<=length(stringa)) then
                       begin
                       stringa[x_]:=c;
                       inc(x_);
                       inc(x);
                       end
       else { ins=false }
        if length(stringa)<254 then
                       begin
                       Insert(c,Stringa,x_);
                       if x<xtot then inc(x);
                       inc(x_);
                       end;
end;

{---------------------------------------------------------------------------}

begin
maxX:=gettextmaxx;                         {status: 0 = normale}
if Xstart=0 then Xstart:=1;                {status: 1 = maiuscolo}
xstart:=trunc(min(Xstart,maxX-1));         {status: 2 = minuscolo}
if Xtot=0 then Xtot:=1;                    {status: altro = normale}
xtot:=min(Xtot,maxX-1);

if xtot-xstart<3 then RunError(201);
if x_>length(stringa)+1 then x_:=length(stringa)+1;
if x_=0 then x_:=1;
if status>2 then status:=0;
y:=WhereY;
cursore_:=min(cursore_,xtot-xstart+1);
if cursore_>length(stringa) then cursore_:=length(stringa)+1;
if cursore_=0 then cursore_:=1;
if cursore_>x_ then cursore_:=x_;
cursore_:=Xstart-1+cursore_;

gotoxy(xstart-1,Y);
str_app:=copy(stringa,x_-(cursore_-xstart),xtot-xstart);
quadra:=length(str_app)=length(copy(stringa,x_-(cursore_-xstart),255));

while length(str_app)<xtot-xstart do str_app:=str_app+' ';
str_app:=' '+str_app+' ';
if quadra then str_app[length(str_app)]:=']'
          else str_app[length(str_app)]:=#17;

if cursore_-x_=xstart-1 then str_app[1]:='['
                        else str_app[1]:=#16;
write(str_app);
gotoxy(cursore_,y);

old_x:=255;
c:=#1;
if ins then CursorBig;

repeat
if KeyPressed or not topo then
   begin
   c:=ReadKey;
   if ord(c)=0 then
      begin
      c:=ReadKey;
      {$ifdef dos}
      if ALT and avanzate then
             begin
             lastU:=ord(c);  {esce alla pressione del tasto ALT + qualcosa}
             lastD:=255;
             c:=#13;
             end;
      {$endif}
      case ord(c) of
           75: begin
               if cursore_>Xstart then dec(cursore_);       {K sinistra}
               if x_>1 then dec(x_);
               end;
           83: if x_<=length(stringa) then delete(stringa,x_,1);  {S canc}
           79: begin
               x_:=length(stringa)+1;  {O fine}
               if x_>(xtot-xstart) then cursore_:=xtot
                                   else cursore_:=length(stringa)+xstart;
               end;
           71: begin
               cursore_:=Xstart;              {G inizio}
               x_:=1;
               end;
           77: if x_<=length(stringa) then
                                      begin     {M destra}
                                      inc(x_);
                                      if cursore_<Xtot then inc(cursore_);
                                      end;
           82: begin
               ins:=not ins;                  {R insert}
               if ins then CursorBig
                      else CursorOn;
               Continue;
               end;
           72,73,80,81: Continue;
           else
             begin
             {$ifdef win}
             lastU:=ord(c);  {esce alla pressione del tasto ALT + qualcosa}
             lastD:=255;
             c:=#13;
             {$endif}
             {$ifdef dos}
             Continue;
             {$endif}
             end;
           end;
      end
     else  {tasti normali}
      begin
      lastU:=ord(c); {il valore del tasto}
      lastD:=0;
      case status of
           0: ;
           1: c:=UpCase(c);
           2: c:=LowCase(c);
           end;
      case c of
        #27 : if stringa<>'' then
                 begin   {Esc}
                 gotoxy(Xstart,y);
                 stringa:='';
                 cursore_:=Xstart;
                 x_:=1;
                 end
                else c:=#13;
        #32..#255 : Tasto(cursore_,x_,stringa,c,Xtot,ins);
        #9: if avanzate then c:=#13;
        #8: if x_>1 then
               begin                     {back-space}
               Delete(stringa,x_-1,1);
               dec(x_);
               if cursore_>xstart then dec(cursore_);
               end;
        end;
      end;
   old_str_app:=str_app;
   str_app:=copy(stringa,x_-(cursore_-xstart),xtot-xstart);
   quadra:=length(str_app)=length(copy(stringa,x_-(cursore_-xstart),255));
   while length(str_app)<xtot-xstart do str_app:=str_app+' ';
   str_app:=' '+str_app+' ';
   if quadra then str_app[length(str_app)]:=']'
             else str_app[length(str_app)]:=#17;
   if cursore_-x_=xstart-1 then str_app[1]:='['
                           else str_app[1]:=#16;
   if old_str_app<>str_app then
        begin
        cursoroff;
        gotoxy(Xstart-1,y);
        write(str_app);
        gotoxy(cursore_,y);
        if ins then cursorbig else cursoron;
        end;
   if topo then ShowMouse;
   end
  else  {not keypressed}
   if topo then
       begin
       {$ifdef dos}
       Rilascio(mox,moy,mtasto);
       if mtasto=1 then
          begin
          if (moy=y)and(mox>=xstart)and(mox<=xtot) then
                   begin
                   diff:=mox-whereX;
                   if diff<0 then
                             begin
                             inc(cursore_,diff);
                             inc(x_,diff);
                             end;
                   if diff>0 then
                             begin
                             inc(cursore_,diff);
                             inc(x_,diff);
                             diff:=x_-length(stringa);
                             if diff>0 then
                                 begin
                                 dec(x_,diff-1);
                                 dec(cursore_,diff-1);
                                 end;
                             end;
                   end;
          if avanzate and ( (moy<>y)or(cursore_>mox)or(mox>xtot) ) then
             begin
             c:=#13;
             lastU:=mox;
             lastD:=moy;
             Break;
             end;
          end;
       {$endif}
       end;
if x_<>old_x then
          begin
          old_x:=x_;
          gotoxy(cursore_,y);
          if topo then ShowMouse;
          end;
until c=#13;
cursore_:=cursore_-xstart+1;
ReadString2:=stringa;
end;

{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}

end.
